package it.istat.relais.datasetInput;


import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;


public class ReadingFile {

	Connection connection;
	
        /*constructor of the class*/
	public ReadingFile(Connection con){
		this.connection = con;
	}
	
	/*function that implements the reading of the two datasets from input files.
         * Input:
         * pathDSA: pattern of the input file containing the dataset A
         * A table DSA is created and populated starting from the file
         * sepDSA: character separating the variables in the dataset A 
         * pathDSB: pattern of the input file containing the dataset B
         * sepDSB: character separating the variables in the dataset B
         * A table DSB is created and populated starting from the file
         * A table contanaining the reconciled schema of the two dataset
         * is created and populated. */
        public void Reading(String pathDSA, String sepDSA, String pathDSB, String sepDSB) throws Exception {
		Statement stmDSA, stmDSB, stmReconciledSchema, stmInsert, stmLoadDSA, stmLoadDSB = null;
		RecordReader readerDSA, readerDSB;
		Record schemaDSA, schemaDSB, schemaReconciled;
		Record[] schemas; 
		String createDSA,  createDSB, createReconciledSchema;
		String loadDSA, attributeDSA, loadDSB, attributeDSB;
		int dimDSA, dimDSB;
		String rs;
                Record row;
                int jj;
                Statement stmI;
                
		try{
			readerDSA = new RecordReader(pathDSA, sepDSA);
			schemaDSA = new Record(readerDSA.read(), sepDSA);
			dimDSA = schemaDSA.size();
			try{
			Statement stm1 = (Statement)connection.createStatement();			
			stm1.executeUpdate("DROP TABLE "+TablesName.nameDsa());
			stm1.close();
			}catch(SQLException e){
			}
			//creation of table DSA schema equals to the input file schema 
			attributeDSA="";
			createDSA = "CREATE TABLE "+TablesName.nameDsa()+" (KEY_DSA INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, \n";
			for(int i=0; i < dimDSA; i++){
                               if (schemaDSA.get(i).toString().equals("")) throw new Exception("Column name missing in Dataset A");
				createDSA = createDSA+ schemaDSA.get(i).toString().toUpperCase()+" VARCHAR(250), \n";
				if(i< dimDSA-1)
					attributeDSA = attributeDSA + schemaDSA.get(i).toString()+", \n";
				else
					attributeDSA = attributeDSA + schemaDSA.get(i).toString()+" \n";
			}
			createDSA = createDSA+" PRIMARY KEY (KEY_DSA));";
			
			stmDSA = (Statement)connection.createStatement();
			stmDSA.executeUpdate(createDSA);
			stmDSA.close();
			
                        stmDSA = (Statement)connection.createStatement();
			stmDSA.executeUpdate("DROP TABLE IF EXISTS "+TablesName.nameColDsa());
                        stmDSA.executeUpdate("DROP TABLE IF EXISTS "+TablesName.nameColDsb());
                        stmDSA.executeUpdate("CREATE TABLE "+TablesName.nameColDsa()+" (ATTRIBUTE VARCHAR(250), ORIG VARCHAR(1)); ");
                        stmDSA.executeUpdate("CREATE TABLE "+TablesName.nameColDsb()+" (ATTRIBUTE VARCHAR(250), ORIG VARCHAR(1)); ");
			stmDSA.close();
                        
                        Statement stmInsCol = (Statement)connection.createStatement();
                        for(int i=0; i < dimDSA; i++){
                            stmInsCol.executeUpdate("INSERT INTO "+TablesName.nameColDsa()+" VALUES ('"+schemaDSA.get(i).toString().toUpperCase()+"','Y');");
                        }
                        
                        String name = "os.name";
                        String os = System.getProperty(name).toLowerCase();
                        
                        if (os.indexOf("win") >= 0){
        		String pathLoadDSA = pathDSA.replace("\\", "\\\\");
			
			loadDSA = "LOAD DATA INFILE \'"+pathLoadDSA+ "\' INTO TABLE "+TablesName.nameDsa()+" FIELDS TERMINATED BY \""+sepDSA+"\" LINES TERMINATED BY '\r\n' IGNORE 1 LINES ("; 
                        loadDSA = loadDSA + attributeDSA +");";
            
                        stmLoadDSA = (Statement)connection.createStatement();
                        stmLoadDSA.executeUpdate(loadDSA);
			stmLoadDSA.close();
                        }
                        else{
                                  String insertDSAtemp;
                            jj= 1;
                            while((rs=readerDSA.read())!= null){
                            row = new Record(rs,sepDSA);
                            insertDSAtemp = "INSERT INTO "+TablesName.nameDsa()+" VALUES ("+jj+",";
                            for(int i=0; i < dimDSA-1; i++)
                                insertDSAtemp = insertDSAtemp+"'"+ row.get(i).toString().replaceAll("'", "''")+"', ";
                            insertDSAtemp = insertDSAtemp + "'"+ row.get(dimDSA-1).toString().replaceAll("'", "''")+ "');";
                            stmI = (Statement)connection.createStatement();
                            stmI.executeUpdate(insertDSAtemp);
                            stmI.close();
                            jj++;
                          } 
                        }
                        
                        readerDSB = new RecordReader(pathDSB, sepDSB);
			schemaDSB = new Record(readerDSB.read(), sepDSB);
			dimDSB = schemaDSB.size();
			try{
			Statement stm2 = (Statement)connection.createStatement();
			stm2.executeUpdate("DROP TABLE "+TablesName.nameDsb());
			stm2.close();
			}catch(SQLException e){
				;
			}
			attributeDSB ="";
			
			createDSB = " CREATE TABLE "+TablesName.nameDsb()+" (KEY_DSB INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, \n";
			for(int i=0; i < dimDSB; i++){
                                if (schemaDSB.get(i).toString().equals("")) throw new Exception("Column name missing in Dataset B");
				createDSB = createDSB+ schemaDSB.get(i).toString().toUpperCase()+" VARCHAR(250), \n";
				if(i< dimDSB-1)
					attributeDSB = attributeDSB + schemaDSB.get(i).toString()+", \n";
				else
					attributeDSB = attributeDSB + schemaDSB.get(i).toString()+" \n";
			}
			createDSB = createDSB+" PRIMARY KEY (KEY_DSB));";
			
			Statement stmInsCol2 = (Statement)connection.createStatement();
                        for(int i=0; i < dimDSB; i++){
                            stmInsCol2.executeUpdate("INSERT INTO "+TablesName.nameColDsb()+" VALUES ('"+schemaDSB.get(i).toString().toUpperCase()+"','Y');");
                        }
                        stmInsCol2.close();
                        
			stmDSB = (Statement)connection.createStatement();
			stmDSB.executeUpdate(createDSB);
			stmDSB.close();
			if (os.indexOf("win") >= 0){
			String pathLoadDSB = pathDSB.replace("\\", "\\\\");
			 	
			loadDSB = "LOAD DATA INFILE \'"+pathLoadDSB+ "\' INTO TABLE "+TablesName.nameDsb()+" FIELDS TERMINATED BY \""+sepDSB+"\" LINES TERMINATED BY '\r\n' IGNORE 1 LINES ("; 
                        loadDSB = loadDSB + attributeDSB +");";
            
                        stmLoadDSB = (Statement)connection.createStatement();
                        stmLoadDSB.executeUpdate(loadDSB);
			stmLoadDSB.close();
                        }
			else {
                            jj = 1;
                           while((rs=readerDSB.read())!= null){
                            row = new Record(rs,sepDSB);
                            String insertDSBtemp = "INSERT INTO "+TablesName.nameDsb()+" VALUES ("+jj+",";
                            for(int i=0; i < dimDSB-1; i++)
                                insertDSBtemp = insertDSBtemp+"'"+ row.get(i).toString().replaceAll("'", "''")+"', ";
                            insertDSBtemp = insertDSBtemp + "'"+ row.get(dimDSB-1).toString().replaceAll("'", "''")+ "');";
                            stmI = (Statement)connection.createStatement();
                            stmI.executeUpdate(insertDSBtemp);
                            stmI.close();
                            jj++;
                        }
                        }
                        
                        Statement stm3 = (Statement)connection.createStatement();
			stm3.executeUpdate("DROP TABLE IF EXISTS "+TablesName.nameReconciledSchema());
			createReconciledSchema = "CREATE TABLE "+TablesName.nameReconciledSchema()+" (ATTRIBUTE_DSA VARCHAR(250), ATTRIBUTE_DSB VARCHAR(250), COMMON_ATTRIBUTE VARCHAR(250));";
			
			stmReconciledSchema = (Statement)connection.createStatement();
			stmReconciledSchema.executeUpdate(createReconciledSchema);
			stmReconciledSchema.close();
				
                        stmInsert = (Statement)connection.createStatement();
                        stmInsert.executeUpdate("INSERT INTO "+TablesName.nameReconciledSchema()+" (ATTRIBUTE_DSA,ATTRIBUTE_DSB,COMMON_ATTRIBUTE) SELECT UPPER(A.ATTRIBUTE), UPPER(B.ATTRIBUTE), UPPER(A.ATTRIBUTE) FROM "
                                                +TablesName.nameColDsa()+" A, "+TablesName.nameColDsb()+" B WHERE UPPER(A.ATTRIBUTE)=UPPER(B.ATTRIBUTE)");
			stmInsert.close();
                        
		readerDSA.close();
		readerDSB.close();
                
		}catch (Exception e) {
                    System.out.println(e.getMessage());
                    throw e;		
		
		}
	}
	
}