package it.istat.relais.datasetInput;

import java.io.FileNotFoundException;
import java.io.IOException;


public class RecordReader extends RowReader {
	
	private String separator;
	
	/*constructor that calls the constructor of the
         * RowReader class. It takes as input the pathname 
         * of the input file and the separator character.*/
        public RecordReader(String pathname, String separator) throws FileNotFoundException {
		super(pathname);
		this.separator = separator;
	}
	
	/*constructor that calls the constructor of the
         * RowReader class. It takes as input the pathname 
         * of the input file, the separator character and 
         * the buffer size.*/
        public RecordReader(String pathname, String separator, int buffer_sz)
						throws FileNotFoundException {
		super(pathname, buffer_sz);
		this.separator = separator;
	}
	
	/*Returns a Record representation of a row*/
        public Record readRecord() throws IOException {
		String row;
		
		row = read();
		if (row != null)
			return new Record(row, separator);
		
		return null;
	}
	
}

