package it.istat.relais.datasetInput;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class RowReader {
	
	private BufferedReader in;
	
	/*Constructor that takes as input the file name*/
        public RowReader(String pathname) throws FileNotFoundException {
		try {
			
			in = new BufferedReader(new FileReader(pathname));
			
		} catch (FileNotFoundException e) {
			
			System.err.println("Could not open " + pathname);
			throw e;
			
		}
	}
	
	/*Constructor that takes as input the file name 
         * and the buffer size*/
        public RowReader(String pathname, int buffer_sz) throws FileNotFoundException {
		try {
			
			in = new BufferedReader(new FileReader(pathname), buffer_sz);
			
		} catch (FileNotFoundException e) {
			
			System.err.println("Could not open " + pathname);
			throw e;
			
		}
	}
	
	/*Returns a row read from input file*/
        public String read() throws IOException {
		String row;
		
		try {
			
			if ((row = in.readLine()) == null)
				return null;
			
		} catch (IOException e) {
			
			System.err.println("readline() unsuccessful");
			throw e;
			
		}
		
		return row;
	}
	
	/*Close the input file*/
        public void close() {
		try {
			
			in.close();
			
		} catch (IOException e) {
			
			System.err.println("close() unsuccessful");
			
		}
	}
	
}
