package it.istat.relais.deterministic;


import it.istat.relais.constants.TablesName;
import it.istat.relais.matchingVariables.MatchingVariables;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class ReducedWeight {

private	Connection connection;
int weightNum;
private String[] subrules;
private double[] weights;

/*Constructor*/	
public ReducedWeight(Connection conn) throws Exception {
            weightNum = 0;
            
            this.connection=conn;
            Statement stmCount = (Statement) connection.createStatement();
            ResultSet rsCount = stmCount.executeQuery("SELECT COUNT(*) FROM "+TablesName.nameReductionWeight());
            if (rsCount.next())
                weightNum = rsCount.getInt(1);
            rsCount.close();
            stmCount.close();

            subrules = new String[weightNum];
            weights = new double[weightNum];
            
            int index=0;
            Statement stmSel = (Statement) connection.createStatement();
            ResultSet rsSel = stmSel.executeQuery("SELECT SUBRULE, WEIGHT FROM "+TablesName.nameReductionWeight()+" ORDER BY ID_SR");
            while (rsSel.next()) {
                subrules[index] = rsSel.getString(1);
                weights[index] = rsSel.getDouble(2);
                index++;
            }
            rsSel.close();
            stmSel.close();

	}
        
/*Updates the weigths of the table with the input weigths */ 
public void updateWeights(double[] newweights) throws Exception {
            int index;
            String existClause;
            MatchingVariables mv=new MatchingVariables(connection);

            existClause="SELECT 1 FROM "+TablesName.nameReductionWeight()+" W WHERE ";
            String[] cols=mv.getContingencyColumns();
            for(int i=0; i<cols.length; i++)
                existClause = existClause+"(W."+cols[i]+"=D."+cols[i]+" OR W."+cols[i]+" IS NULL) AND ";
            
            Statement stmupd = (Statement) connection.createStatement();
            stmupd.executeUpdate("UPDATE "+TablesName.nameMURule()+" SET WEIGHT=1 WHERE RULE=1");
            for (index=0;index<weightNum;index++) {
                stmupd.executeUpdate("UPDATE "+TablesName.nameReductionWeight()+" SET WEIGHT="+newweights[index]+" WHERE ID_SR="+(index+1));
                stmupd.executeUpdate("UPDATE "+TablesName.nameMURule()+" D SET WEIGHT=WEIGHT+"+newweights[index]+" WHERE EXISTS ("+existClause+" ID_SR="+(index+1)+")");
            }
            stmupd.close();

            weights = newweights;
        }
        
    /*Returns the vector of subrules*/    
    public String[] getSubRules() {
            return subrules;
        }
        
    /*Returns the vector of weigths*/    
    public double[] getWeights() {
            return weights;
        }
        
    /*Returns a double that corresponds to the total weigth
     *that is the sum of all the weights*/    
    public double getTotalWeights() {
            double tot=0;
            for (int index=0;index<weightNum;index++)
                tot = tot+weights[index];
            return tot;
        }
        
                   
}






