package it.istat.relais.deterministic;

/* It is the class that represents deterministic rules as specified by users*/
public class Rule {
    private RuleElement[] rulesElements;
    String pattern;
    int elemProcessed;
    
    /*Constructor*/
    public Rule(RuleElement[] rule) {
        this.rulesElements=rule;
        this.elemProcessed = 0;
    }
    
    /*Returns a character that is the result
     *of the Apply function applied to the input pattern*/
    public char Apply(String pattern) {
        this.pattern=pattern;
        elemProcessed = 1;
        return VerifyBy();
    }

    /*Returns for a specified pattern the value of the flag inidcating if the rule is verified*/
    private char VerifyBy() {
        char digit;
        char ruleVar='1';
        char newVar,operator;
        boolean not;
        int variable;
        
        while (rulesElements[elemProcessed]!=null) {
            digit = rulesElements[elemProcessed].GetLastdigit();
            newVar = ' ';
            not = rulesElements[elemProcessed].GetNot();
            operator = rulesElements[elemProcessed].GetOperator();
            variable = rulesElements[elemProcessed].GetVariable();
            
            if (digit==')' || digit=='E')
                return ruleVar;
            if (digit=='V')
                newVar=pattern.charAt(variable);
            if (digit=='(') {
                elemProcessed++;
                newVar=VerifyBy();
            }
            
            if (newVar!=' ') {
                if (not) newVar = RuleNot(newVar);
                if (operator=='A') 
                    ruleVar = RuleAnd(ruleVar,newVar);
                else if (operator=='O') 
                    ruleVar = RuleOr(ruleVar,newVar);
                else
                    ruleVar = newVar;
            }
            elemProcessed++;    
        }
        return '0';
    }
    
    /*Applies the not rule to a character*/
    private char RuleNot(char value) {
        if (value=='1') return '0';
        if (value=='0') return '1';
        return value;
    }
    
    /*Applies the and rule to a character*/
    private char RuleAnd(char value1,char value2) {
        if (value1=='1' && value2=='1') return '1';
        return '0';
    }
    
    /*Applies the or rule to a character*/
    private char RuleOr(char value1,char value2) {
        if (value1=='0' && value2=='0') return '0';
        return '1';
    }
}

