package it.istat.relais.deterministic;
/* Atomic element of a rule*/

public class RuleElement {
 
    int idrec;
    String text;
    int level;
    int variable;
    char lastdigit;
    char operator;
    boolean not;
    
   /*Constructor*/
    public RuleElement(int idrec,String text,int level,int variable,
                       char lastdigit,char operator, boolean not) {
  
        this.idrec=idrec;
        this.text=text;
        this.level=level;
        this.variable=variable;
        this.lastdigit=lastdigit;
        this.operator=operator;
        this.not=not;
    }
    
    /*Returns the text of the element of the rule*/
    public String GetText() {
        return this.text;
    }
    
    /*Returns the level of the element of the rule*/
    public int GetLevel() {
        return this.level;
    }

   /*Returns the identification number of the 
    *element of the rule*/
    public int GetIdrec() {
        return this.idrec;
    }
    
    /*Returns the value of the variable of the 
     *element of the rule*/
    public int GetVariable() {
        return this.variable;
    }
    
    /*Returns the last digit of the
     *element of the rule*/
    public char GetLastdigit() {
        return this.lastdigit;
    }
    
    /*Returns the operation value of
     *the element of the rule*/
    public char GetOperator() {
        return this.operator;
    }
    
    /*Returns the value of the variable not */
    public boolean GetNot() {
        return this.not;
    }
}
