package it.istat.relais.displayTables;

import it.istat.relais.constants.TablesName;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.sql.*;
import java.sql.SQLException;
import javax.swing.table.AbstractTableModel; 


public class DisplayTable extends JFrame implements ActionListener{
 
private ModTab tabModel;
private JTable t;
public Connection conn;
private String tableName;

public DisplayTable(Connection conn,String tableName) {
    this.tableName=tableName;
    this.conn=conn;
    try {readTable(null);} catch (SQLException ex) {
                ex.printStackTrace();
            } 

    
}
 

public void actionPerformed(ActionEvent e) {
}


class ModTab extends AbstractTableModel{ 
private Statement stmtMT; 
private ResultSet rsltMT;
private ResultSetMetaData rsmdMT; 

public ModTab() throws SQLException{

super(); 
try {

stmtMT=conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
ResultSet.CONCUR_UPDATABLE); 
rsltMT= stmtMT.executeQuery("SELECT * FROM "+tableName.toUpperCase());
rsmdMT= rsltMT.getMetaData(); 

} 
catch (Exception ex)  {
ex.printStackTrace();
} 


} 

public int getRowCount(){
try {
rsltMT.last(); 
return rsltMT.getRow();
} 
catch(SQLException e)
{ System.out.println("Error " + e);
return 0; } 
}

public int getColumnCount(){
try { 
return rsmdMT.getColumnCount() ; 
}
catch(SQLException e)
{ System.out.println("Error " + e);
return 0; }
}

public ResultSet getResultSet()
{ return rsltMT; 
}


public Object getValueAt(int rowIndex, int columnIndex) {

try { 

ResultSet rs = getResultSet(); 
rs.absolute(rowIndex + 1);
return rs.getObject(columnIndex + 1);

}
catch(SQLException e)
{ System.out.println("Error " + e);
return null;
}
}


public String getColumnName(int c) { 
try { 

return rsmdMT.getColumnName(c + 1); 
} 
catch(Exception e)
{ System.out.println("Error " + e);
return " "; }
} 

}

public void readTable(ActionEvent e) throws SQLException{

JDialog window = new JDialog();
Font f2 = new Font(null, Font.BOLD,15); 
tabModel = new ModTab();
t = new JTable(tabModel);
window.add(t);
window.setFont(f2);
window.setTitle(tableName.toUpperCase());
window.setSize(600,400);
window.setLocation(300,200);
window.setVisible(true); 
window.setLayout(new BorderLayout());
window.add(BorderLayout.CENTER,new JScrollPane(t)); 
window.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE); 


}

public static DefaultComboBoxModel tableList(Connection conn1,String schema) {
        String[] list=null;
        try {
            String stringCount="SELECT COUNT(*) FROM information_schema.TABLES WHERE TABLE_SCHEMA= '"+schema.toUpperCase()+"' AND "+
                               " (TABLE_NAME IN ("+TablesName.listTables()+") OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMU()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameContingencyReduced()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameFrequencyDistributions()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameConsistencyDictionary()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameAccuracyDictionary()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMUVariable()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameContingency()+"%') ";
            Statement stmCount =(Statement)conn1.createStatement();
            ResultSet rsCount = stmCount.executeQuery(stringCount);
            int ntot=0;
            if (rsCount.next())
                ntot = (int) rsCount.getDouble(1);

            if (ntot==0) return null;
            list = new String[ntot];

            String stringQuery="SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA= '"+schema.toUpperCase()+"' AND "+
                               " (TABLE_NAME IN ("+TablesName.listTables()+") OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMU()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameContingencyReduced()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameFrequencyDistributions()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameConsistencyDictionary()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameAccuracyDictionary()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMUVariable()+"%' OR "+
                               "  TABLE_NAME LIKE '"+TablesName.nameContingency()+"%') ";
            
            Statement stmSchema =(Statement)conn1.createStatement();
            ResultSet rsSchema = stmSchema.executeQuery(stringQuery);
            int count=0;
            while (rsSchema.next()) {
		list[count]=rsSchema.getString(1);
                count++;
            }
            stmSchema.close();
    } catch (Exception e){
	System.out.println("Error in making the table list");
        e.printStackTrace();
    } finally {
        DefaultComboBoxModel cbmodel = new DefaultComboBoxModel(list);
        return cbmodel;
    }
}

public static DefaultComboBoxModel MUListWithBlock(Connection conn1,String schema) {
        String[] list=null;
        String tableMUBlock;
        
        try {
            String stringCount="SELECT COUNT(*) FROM information_schema.TABLES WHERE TABLE_SCHEMA= '"+schema.toUpperCase()+"' AND "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMU()+"%' ";
            Statement stmCount =(Statement)conn1.createStatement();
            ResultSet rsCount = stmCount.executeQuery(stringCount);
            int ntot=0;
            if (rsCount.next())
                ntot = (int) rsCount.getDouble(1);

            if (ntot==0) return null;
            list = new String[ntot];

            /*String stringQuery="SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA= '"+schema.toUpperCase()+"' AND "+
                               "  TABLE_NAME LIKE '"+TablesName.nameMU()+"%' ";
            
            Statement stmSchema =(Statement)conn1.createStatement();
            ResultSet rsSchema = stmSchema.executeQuery(stringQuery);
            int count=0;
            while (rsSchema.next()) {
		list[count]=rsSchema.getString(1);
                count++;
            }
            stmSchema.close();*/
            int count=0;
            Statement stmBlock = (Statement) conn1.createStatement();
	    ResultSet rsBlock = stmBlock.executeQuery("SELECT BLOCK_NUMBER, BLOCK_MODALITY FROM "+TablesName.nameBlockModality());
	    while (rsBlock.next()) {
		tableMUBlock = TablesName.nameMU()+"_"+rsBlock.getString(1).toUpperCase();
		Statement stm0 =(Statement)conn1.createStatement();
            	ResultSet rs0 = stm0.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE upper(TABLE_NAME) = '"+tableMUBlock+"' AND TABLE_SCHEMA = '"+schema.toUpperCase()+"'");
            	if(rs0.next()) {
                    list[count]=tableMUBlock+" ("+rsBlock.getString(2)+")";
                    count++;
                }
            }
    } catch (Exception e){
	System.out.println("Error in making the MU list");
        e.printStackTrace();
    } finally {
        DefaultComboBoxModel cbmodel = new DefaultComboBoxModel(list);
        return cbmodel;
    }
}

}
