package it.istat.relais.displayTables;

import javax.swing.table.AbstractTableModel;

public class VariablesModel extends AbstractTableModel{

int dimension;
private String[] variables;
private String[] metrics;
private double[] thresholds;

public VariablesModel(String[] variables,String[] metrics,double[] thresholds) {

    super(); 

    this.dimension=variables.length;
    this.variables = new String[dimension];
    this.metrics = new String[dimension];
    this.thresholds = new double[dimension];
    
    for (int index=0;index<dimension;index++) {
        this.variables[index]=variables[index];
        this.metrics[index]=metrics[index];
        this.thresholds[index]=thresholds[index];
    }
    
}

public int getRowCount(){
    return dimension;
} 


public int getColumnCount(){
   return 3;  
}

public Object getValueAt(int rowIndex, int columnIndex) {

if (columnIndex==0) return variables[rowIndex];
else if (columnIndex==1) return metrics[rowIndex];
else return thresholds[rowIndex];
}


        @Override
public String getColumnName(int columnIndex) { 
            
if (columnIndex==0) return "Variable";
else if (columnIndex==1) return "Similarity Metric";
else return "Threshold";
}
        
        @Override
public boolean isCellEditable(int row, int column) {
        return (column == 3);
}
        
        @Override
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }

}
