package it.istat.relais.displayTables;

import javax.swing.table.AbstractTableModel;

public class WeightsModel extends AbstractTableModel{

int dimension;
private double[] weights;

public WeightsModel(double[] weights){

    super(); 

    this.dimension=weights.length;
    this.weights = new double[dimension];
    
    for (int index=0;index<dimension;index++) {
        this.weights[index]=weights[index];
    }
    
}

public int getRowCount(){
    return dimension;
} 


public int getColumnCount(){
   return 1;  
}

public Object getValueAt(int rowIndex, int columnIndex) {

return weights[rowIndex];
}


        @Override
public String getColumnName(int columnIndex) { 
            
return "Weight";
}
        
        @Override
public boolean isCellEditable(int row, int column) {
        return (true);
}
        
        @Override
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }

	
        @Override
    public void setValueAt(Object value, int row, int col) {
    	
        weights[row] = Double.parseDouble(value.toString());
        fireTableCellUpdated(row, col);  

    }

    public double[] getNewWeights() {

        return weights;
    }


}
