package it.istat.relais.export;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.DefaultComboBoxModel;

public class ExportToDb {
private String dbName;
private Connection connection;

/*Constructor*/
public ExportToDb(Connection conn,String NewDataBase)  {

	this.dbName = NewDataBase;
	this.connection = conn;

}

/*Returns the list of backup in the database*/
public static DefaultComboBoxModel BackUpList(Connection conn1,String filter,String tablemaster) {
    String[] list=null;
    try {
            String stringCount="SELECT COUNT(*) FROM information_schema.TABLES WHERE upper(TABLE_NAME)='"+tablemaster.toUpperCase()+"' AND TABLE_SCHEMA <> 'relais'";
            Statement stmCount =(Statement)conn1.createStatement();
            ResultSet rsCount = stmCount.executeQuery(stringCount);
            int ntot=0;
            if (rsCount.next())
                ntot = (int) rsCount.getDouble(1);

            if (ntot==0) return null;
            list = new String[ntot];

            String stringQuery="SELECT TABLE_SCHEMA FROM information_schema.TABLES WHERE upper(TABLE_NAME)='"+tablemaster.toUpperCase()+"' AND TABLE_SCHEMA <> 'relais'";
            if (filter != null)
                stringQuery = stringQuery + " AND TABLE_SCHEMA = '"+filter+"'";
            Statement stmSchema =(Statement)conn1.createStatement();
            ResultSet rsSchema = stmSchema.executeQuery(stringQuery);
            int count=0;
            while (rsSchema.next()) {
		list[count]=rsSchema.getString(1);
                count++;
            }
            stmSchema.close();
    } catch (Exception e){
	System.out.println("Error in finding backup name");
    } finally {
        if (list==null) return null;
        DefaultComboBoxModel cbmodel = new DefaultComboBoxModel(list);
        return cbmodel;
    }
}

/*Evaluates if a backupName has been alredy used in the database*/
public static boolean existsBackUp(Connection conn1,String backupName) {
    boolean exist=false;
    try {
            String stringQuery="SELECT SCHEMA_NAME FROM information_schema.SCHEMATA WHERE SCHEMA_NAME='"+backupName+"'";
            Statement stmSchema =(Statement)conn1.createStatement();
            ResultSet rsSchema = stmSchema.executeQuery(stringQuery);
            if (rsSchema.next()) {
		exist=true;
            }
            stmSchema.close();
    } catch (Exception e){
	System.out.println("Error in finding backup name");
    } finally {
        return exist;
    }
}

/*Creates a new database*/
public int dbCreate() throws Exception {

	try{
		if (dbName.equalsIgnoreCase("relais")){
			System.out.println("relais as database name is not allowed!");
			return 0;
		}

		Statement stmCreate =(Statement)connection.createStatement();
		stmCreate.executeUpdate("CREATE DATABASE "+dbName+" ;");
		stmCreate.close();
		
		return 1;
		
		}catch(Exception e){
			System.out.println("Invalid database name or database already exists");
			throw e;
		}
		
}

/*Drops a database*/
public void dbDrop() throws Exception {

	try{
		if (dbName.equalsIgnoreCase("relais")){
			System.out.println("Drop database relais: action not allowed!");
			return;
		}

		Statement stmCreate =(Statement)connection.createStatement();
		stmCreate.executeUpdate("DROP DATABASE "+dbName+" ;");
		stmCreate.close();
	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Copies the content of a table in a new table (tableName)*/
public void tableCopy(String tableName) throws Exception {
	try{
    		Statement stmDrop =(Statement)connection.createStatement();
		stmDrop.executeUpdate("DROP TABLE "+dbName+"."+tableName.toUpperCase()+" ;");
		stmDrop.close();
        } catch(Exception ex){
	    ;
	}
	try{
		Statement stmCreate =(Statement)connection.createStatement();
		stmCreate.executeUpdate("CREATE TABLE "+dbName+"."+tableName.toUpperCase()+" AS SELECT * FROM "+tableName.toUpperCase()+";");
		stmCreate.close();
	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Copies the content of all the database in a new database*/
public void dbCopy() throws Exception {
	Statement stm;
	ResultSet rsTables;
	
	try{
		stm= (Statement)connection.createStatement();	
		rsTables = stm.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA='relais';");
		while (rsTables.next())
		{
			System.out.println("COPY TABLE "+rsTables.getString(1));
			this.tableCopy(rsTables.getString(1));
		}

	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Copies tables that contain outputs of computations*/
public void dbCopyResult() throws Exception {
	Statement stm;
	ResultSet rsTables;
	
	try{
		stm= (Statement)connection.createStatement();	
		rsTables = stm.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA='relais'"+
                                            " AND (" +
                                            " upper(TABLE_NAME) LIKE '"+TablesName.nameContingency()+"%'"+
                                            " OR upper(TABLE_NAME) LIKE '"+TablesName.nameContingencyReduced()+"%'"+
                                            " OR upper(TABLE_NAME) LIKE '"+TablesName.nameMU()+"%'"+
                                            " OR upper(TABLE_NAME) IN ('"+TablesName.nameReconciledSchema()+
                                                                "','"+TablesName.nameSetting()+
                                                                "','"+TablesName.nameBlockModality()+
                                                                "','"+TablesName.nameMURule()+
                                                                "','"+TablesName.nameMatchingVeriables()+
                                                                "','"+TablesName.nameDsa()+
                                                                "','"+TablesName.nameDsb()+
                                                                "','"+TablesName.nameColDsa()+
                                                                "','"+TablesName.nameColDsb()+
                                                                "','"+TablesName.nameResidualDsa()+
                                                                "','"+TablesName.nameResidualDsb()+
                                                                "','"+TablesName.nameMatch()+
                                                                "','"+TablesName.namePossibleMatch()+
                                                                "','"+TablesName.nameLog()+"'))");
		while (rsTables.next())
		{
			System.out.println("Copy table "+rsTables.getString(1));
			this.tableCopy(rsTables.getString(1));
		}

	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Imports the content of a database in the relais database that is
 *the work database*/
public void dbImport() throws Exception {
	Statement stm;
	ResultSet rsTables;
	
	try{
		stm= (Statement)connection.createStatement();	
		rsTables = stm.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA='"+dbName+"';");
		while (rsTables.next())
		{
			System.out.println("Restore table "+rsTables.getString(1));
			this.tableImport(rsTables.getString(1));
		}

	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Starts the elaboration with a specific database*/
public static void startElab(Connection conn,String dataBase) {

	try{
		Statement stmDrop =(Statement)conn.createStatement();
		stmDrop.executeUpdate("DROP DATABASE "+dataBase+";");
		stmDrop.close();
                
                Statement stmCreate =(Statement)conn.createStatement();
		stmCreate.executeUpdate("CREATE DATABASE "+dataBase+";");
		stmCreate.close();
    
                Statement stmUse =(Statement)conn.createStatement();
		stmUse.executeUpdate("USE "+dataBase+";");
		stmUse.close();
	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
	}	
}

/*Imports a specific table*/
public void tableImport(String tableName) throws Exception {
       this.tableImport(tableName,tableName);
}

/*Imports a specific table*/
public void tableImport(String tableName, String tableToCopy) throws Exception {
	
	try{
    		Statement stmDrop =(Statement)connection.createStatement();
		stmDrop.executeUpdate("DROP TABLE "+tableName.toUpperCase()+";");
		stmDrop.close();
        } catch(Exception ex){
	    ;
	}
	try{
		Statement stmCreate =(Statement)connection.createStatement();
		stmCreate.executeUpdate("CREATE TABLE "+tableName+" AS SELECT * FROM "+dbName+"."+tableToCopy.toUpperCase()+";");
		stmCreate.close();
                
                if (tableName.equalsIgnoreCase(TablesName.nameDsa()) || tableName.equalsIgnoreCase(TablesName.nameDsb())){
                    Statement stmIdxCreate =(Statement)connection.createStatement();
                    try {
                        stmIdxCreate.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" ADD PRIMARY KEY (KEY_DSA)");
                    } catch (Exception e) {
                        stmIdxCreate.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" ADD PRIMARY KEY (KEY_DSB)");
                    }
                    stmIdxCreate.close();
                }
                
                if (tableName.equalsIgnoreCase(TablesName.nameCurrentStatus())){
                    Statement stmIdxCreateCS =(Statement)connection.createStatement();
                    stmIdxCreateCS.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" ADD PRIMARY KEY (ID_OPER)");
                    stmIdxCreateCS.close();
                    Statement stmAutoIncCS =(Statement)connection.createStatement();
                    stmAutoIncCS.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" MODIFY ID_OPER INTEGER UNSIGNED NOT NULL AUTO_INCREMENT");
                    stmAutoIncCS.close();
                }
                
                if (tableName.equalsIgnoreCase(TablesName.nameLog())){
                    Statement stmIdxCreateLT =(Statement)connection.createStatement();
                    stmIdxCreateLT.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" ADD PRIMARY KEY (IDLOG)");
                    stmIdxCreateLT.close();
                    Statement stmAutoIncLT =(Statement)connection.createStatement();
                    stmAutoIncLT.executeUpdate("ALTER TABLE "+tableName.toUpperCase()+" MODIFY IDLOG INTEGER UNSIGNED NOT NULL AUTO_INCREMENT");
                    stmAutoIncLT.close();
                }
                    
	} catch(Exception ex){
	    System.out.println("SQLException: " + ex.getMessage());
            throw ex;
	}	
}

/*Return value of setting 'char_separator'*/
public String ReadSeparator() throws Exception {

    		Statement stmRead =(Statement)connection.createStatement();
		ResultSet rsSett = stmRead.executeQuery("SELECT CHAR_SEPARATOR FROM "+dbName+"."+TablesName.nameSetting()+" ;");
                rsSett.next();
                String out=rsSett.getString(1);
		stmRead.close();
                return (out);
 
}

public String ReadProcessType() throws Exception {
        String out="Linkage";
        try {
            Statement stmRead =(Statement)connection.createStatement();
            ResultSet rsSett = stmRead.executeQuery("SELECT PROJECT_TYPE FROM "+dbName+"."+TablesName.nameSetting()+" ;");
            rsSett.next();
            out=rsSett.getString(1);
            stmRead.close();

        } catch (Exception e) {
            if(e.getMessage().startsWith("Unknown column")) {
                System.out.println("WARNING: backup was created with a previous version of Relais");
            }
            else throw(e);
        } finally {
            return (out);
        }
}

}
