
package it.istat.relais.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.ComboBoxModel;
import javax.swing.JFileChooser;


public class ChooseMetadataParameters extends javax.swing.JDialog {
    /** A return status code - returned if Cancel button has been pressed */
    public static final int RET_CANCEL = 0;
    /** A return status code - returned if OK button has been pressed */
    public static final int RET_OK = 1;

    /** Creates a new form "NewOkCancelDialog" */
    public ChooseMetadataParameters(java.awt.Frame parent, boolean modal, ComboBoxModel items) {
        super(parent, modal);
        initComponents();
        if (items!=null) CorrelationVariable.setModel(items);
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
	setLocation((screenSize.width - frameSize.width) / 2,
		    (screenSize.height - frameSize.height) / 2);
    }
    
    public void setVariableName(String variable) {
        VariableName.setText(variable);
    }
    
    /** @return the return status of this dialog - one of RET_OK or RET_CANCEL */
    public int getReturnStatus() {
        return returnStatus;
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        VariableName = new javax.swing.JTextField();
        IdentificationPower = new javax.swing.JCheckBox();
        Completeness = new javax.swing.JCheckBox();
        Consistency = new javax.swing.JCheckBox();
        Accuracy = new javax.swing.JCheckBox();
        Entropy = new javax.swing.JCheckBox();
        Correlation = new javax.swing.JCheckBox();
        AccuracyFile = new javax.swing.JButton();
        ConsistencyFile = new javax.swing.JButton();
        CorrelationVariable = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        TextFileAccuracy = new javax.swing.JTextField();
        SeparatorAccuracy = new javax.swing.JComboBox();
        TextFileConsistency = new javax.swing.JTextField();
        SeparatorConsistency = new javax.swing.JComboBox();

        setTitle("Settings");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("MetaData"));

        jLabel1.setText("Variable");

        VariableName.setEditable(false);
        VariableName.setFont(new java.awt.Font("Tahoma", 1, 11));
        VariableName.setText("variable");
        VariableName.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        IdentificationPower.setSelected(true);
        IdentificationPower.setText("Identification Power");
        IdentificationPower.setEnabled(false);

        Completeness.setSelected(true);
        Completeness.setText("Completeness");

        Consistency.setText("Consistency");

        Accuracy.setText("Accuracy");

        Entropy.setText("Entropy");

        Correlation.setText("Correlation");

        AccuracyFile.setText("...");
        AccuracyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AccuracyFileActionPerformed(evt);
            }
        });

        ConsistencyFile.setText("...");
        ConsistencyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConsistencyFileActionPerformed(evt);
            }
        });

        CorrelationVariable.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                CorrelationVariableItemStateChanged(evt);
            }
        });

        jButton1.setText("Info");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Info");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Info");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("Info");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("Info");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton6.setText("Info");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        TextFileAccuracy.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                TextFileAccuracyFocusGained(evt);
            }
        });

        SeparatorAccuracy.setEditable(true);
        SeparatorAccuracy.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "", ";", ":" }));
        SeparatorAccuracy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SeparatorAccuracyActionPerformed(evt);
            }
        });

        TextFileConsistency.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                TextFileConsistencyFocusGained(evt);
            }
        });

        SeparatorConsistency.setEditable(true);
        SeparatorConsistency.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "", ";", ":" }));
        SeparatorConsistency.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SeparatorConsistencyActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(IdentificationPower)
                                .addGap(279, 279, 279))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(Completeness)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(Correlation)
                                            .addComponent(Consistency)
                                            .addComponent(Accuracy))
                                        .addGap(29, 29, 29)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(CorrelationVariable, 0, 166, Short.MAX_VALUE)
                                            .addComponent(TextFileConsistency, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE)
                                            .addComponent(TextFileAccuracy, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 166, Short.MAX_VALUE))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(SeparatorConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(SeparatorAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                                    .addComponent(Entropy))
                                .addGap(8, 8, 8)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(ConsistencyFile)
                                    .addComponent(AccuracyFile))
                                .addGap(18, 18, 18)))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jButton3)
                                    .addComponent(jButton2)
                                    .addComponent(jButton1))
                                .addComponent(jButton4, javax.swing.GroupLayout.Alignment.TRAILING))
                            .addComponent(jButton5)
                            .addComponent(jButton6)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(VariableName, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton6)
                        .addGap(29, 29, 29))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(VariableName, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(IdentificationPower)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(AccuracyFile)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(ConsistencyFile)
                                    .addComponent(SeparatorConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(TextFileConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(Completeness)
                                .addGap(7, 7, 7)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(Accuracy)
                                    .addComponent(SeparatorAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(TextFileAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Consistency)))
                        .addGap(17, 17, 17)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(Entropy)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Correlation))
                            .addComponent(CorrelationVariable, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(26, 26, 26)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 290, Short.MAX_VALUE)
                .addComponent(cancelButton)
                .addGap(35, 35, 35))
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        if (Consistency.isSelected() && (TextFileConsistency.getText().equals("") || SeparatorConsistency.getSelectedItem().equals(""))) {
            new AllertDialog(null,true,"Choose file and separator for consistency rule");
            return;
        }
        if (Accuracy.isSelected() && (TextFileAccuracy.getText().equals("") || SeparatorAccuracy.getSelectedItem().equals(""))) {
            new AllertDialog(null,true,"Choose file and separator for accuracy rule");
            return;
        }
        doClose(RET_OK);
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton1ActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton2ActionPerformed
private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton3ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton5ActionPerformed

private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jButton6ActionPerformed

private void AccuracyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AccuracyFileActionPerformed
  Accuracy.setSelected(true);
  JFileChooser odc = new JFileChooser();
  odc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
  odc.setDialogTitle("Select rules file");
  int odcValue = odc.showOpenDialog(this);
  if (odcValue==JFileChooser.APPROVE_OPTION) {
      this.TextFileAccuracy.setText(odc.getSelectedFile().toString());
  }
}//GEN-LAST:event_AccuracyFileActionPerformed

private void ConsistencyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConsistencyFileActionPerformed
  Consistency.setSelected(true);
  JFileChooser odc = new JFileChooser();
  odc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
  odc.setDialogTitle("Select rules file");
  int odcValue = odc.showOpenDialog(this);
  if (odcValue==JFileChooser.APPROVE_OPTION) {
      this.TextFileConsistency.setText(odc.getSelectedFile().toString());
  }
}//GEN-LAST:event_ConsistencyFileActionPerformed

private void SeparatorAccuracyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SeparatorAccuracyActionPerformed
    Accuracy.setSelected(true);
}//GEN-LAST:event_SeparatorAccuracyActionPerformed

private void TextFileAccuracyFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_TextFileAccuracyFocusGained
    Accuracy.setSelected(true);
}//GEN-LAST:event_TextFileAccuracyFocusGained

private void SeparatorConsistencyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SeparatorConsistencyActionPerformed
    Consistency.setSelected(true);
}//GEN-LAST:event_SeparatorConsistencyActionPerformed

private void TextFileConsistencyFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_TextFileConsistencyFocusGained
    Consistency.setSelected(true);
}//GEN-LAST:event_TextFileConsistencyFocusGained

private void CorrelationVariableItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_CorrelationVariableItemStateChanged
    Correlation.setSelected(true);
}//GEN-LAST:event_CorrelationVariableItemStateChanged

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                ChooseMetadataParameters dialog = new ChooseMetadataParameters(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    public boolean getIdentificationPower() {
        return IdentificationPower.isSelected();
    }
      
    public boolean getAccuracy() {
        return Accuracy.isSelected();
    }
    
    public boolean getCompleteness() {
        return Completeness.isSelected();
    }
    
    public boolean getConsistency() {
        return Consistency.isSelected();
    }
    
    public boolean getCorrelation() {
        return Correlation.isSelected();
    }
    
    public boolean getEntropy() {
        return Entropy.isSelected();
    }
    
    public String getAccuracyFile() {
        return TextFileAccuracy.getText();
    }
    
    public String getAccuracySep() {
        return SeparatorAccuracy.getSelectedItem().toString();
    }
    
    public String getConsistencyFile() {
        return TextFileConsistency.getText();
    }
    
    public String getConsistencySep() {
        return SeparatorConsistency.getSelectedItem().toString();
    }
    
    public String getCorrelationVar() {
        return CorrelationVariable.getSelectedItem().toString();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox Accuracy;
    private javax.swing.JButton AccuracyFile;
    private javax.swing.JCheckBox Completeness;
    private javax.swing.JCheckBox Consistency;
    private javax.swing.JButton ConsistencyFile;
    private javax.swing.JCheckBox Correlation;
    private javax.swing.JComboBox CorrelationVariable;
    private javax.swing.JCheckBox Entropy;
    private javax.swing.JCheckBox IdentificationPower;
    private javax.swing.JComboBox SeparatorAccuracy;
    private javax.swing.JComboBox SeparatorConsistency;
    private javax.swing.JTextField TextFileAccuracy;
    private javax.swing.JTextField TextFileConsistency;
    private javax.swing.JTextField VariableName;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
        
   
            
}
