package it.istat.relais.gui;

import it.istat.relais.constants.TablesName;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;


public class ChooseMetadataParametersMatching extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    
    private Connection connection;
    public ChooseMetadataParametersMatching(java.awt.Frame parent, boolean modal, Connection conn) {
        super(parent, modal);
        initComponents();
        
        ComboBoxModel var=null;
        
        this.connection=conn;
        try{
            String[] list=null;
            String stringQuery="Select count(*) FROM "+TablesName.nameReconciledSchema();
            Statement stmCount =(Statement)conn.createStatement();
            ResultSet rsCount = stmCount.executeQuery(stringQuery);
            int ntotV=0;
            if (rsCount.next())
                ntotV = (int) rsCount.getDouble(1);

            if (ntotV==0) throw new Exception("No variables");
            list = new String[ntotV];
            
            Statement stmV = (Statement)connection.createStatement();
            ResultSet rsV = stmV.executeQuery("SELECT * FROM "+TablesName.nameReconciledSchema());
            int count=0;
            while (rsV.next()) {
		list[count]=rsV.getString(1);
                count++;
            }	
            DefaultComboBoxModel cbmodel = new DefaultComboBoxModel(list);
            var = (ComboBoxModel) cbmodel;
        } catch (Exception e) {
            var = null;
        }
        
        if (var!=null) CorrelationBox.setModel(var);

        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
	setLocation((screenSize.width - frameSize.width) / 2,
		    (screenSize.height - frameSize.height) / 2);
    }
    
    public void setVariableName(String variable) {
        VariableName.setText(variable);
    }
    
    public int getReturnStatus() {
        return returnStatus;
    }
        
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        VariableName = new javax.swing.JTextField();
        Completeness = new javax.swing.JCheckBox();
        Consistency = new javax.swing.JCheckBox();
        Accuracy = new javax.swing.JCheckBox();
        FrequencyDistributions = new javax.swing.JCheckBox();
        Correlation = new javax.swing.JCheckBox();
        AccuracyFile = new javax.swing.JButton();
        ConsistencyFile = new javax.swing.JButton();
        TextFileAccuracy = new javax.swing.JTextField();
        SeparatorAccuracy = new javax.swing.JComboBox();
        TextFileConsistency = new javax.swing.JTextField();
        SeparatorConsistency = new javax.swing.JComboBox();
        Entropy = new javax.swing.JCheckBox();
        CorrelationBox = new javax.swing.JComboBox();

        setTitle("Settings");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("MetaData"));

        jLabel1.setText("Variable");

        VariableName.setEditable(false);
        VariableName.setFont(new java.awt.Font("Tahoma", 1, 11));
        VariableName.setText("variable");
        VariableName.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        Completeness.setText("Completeness");

        Consistency.setText("Consistency");

        Accuracy.setText("Accuracy");

        FrequencyDistributions.setText("Frequency Distributions");
        FrequencyDistributions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FrequencyDistributionsActionPerformed(evt);
            }
        });
        FrequencyDistributions.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                FrequencyDistributionsStateChanged(evt);
            }
        });

        Correlation.setText("Correlation");
        Correlation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CorrelationActionPerformed(evt);
            }
        });
        Correlation.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                CorrelationStateChanged(evt);
            }
        });

        AccuracyFile.setText("...");
        AccuracyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AccuracyFileActionPerformed(evt);
            }
        });

        ConsistencyFile.setText("...");
        ConsistencyFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConsistencyFileActionPerformed(evt);
            }
        });

        TextFileAccuracy.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                TextFileAccuracyFocusGained(evt);
            }
        });

        SeparatorAccuracy.setEditable(true);
        SeparatorAccuracy.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "", ";", ":" }));
        SeparatorAccuracy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SeparatorAccuracyActionPerformed(evt);
            }
        });

        TextFileConsistency.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                TextFileConsistencyFocusGained(evt);
            }
        });

        SeparatorConsistency.setEditable(true);
        SeparatorConsistency.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "", ";", ":" }));
        SeparatorConsistency.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SeparatorConsistencyActionPerformed(evt);
            }
        });

        Entropy.setText("Entropy");
        Entropy.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                EntropyStateChanged(evt);
            }
        });

        CorrelationBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(FrequencyDistributions)
                    .addComponent(Entropy)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(Consistency)
                                        .addGap(207, 207, 207))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(Accuracy)
                                            .addComponent(Correlation))
                                        .addGap(33, 33, 33)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(TextFileAccuracy, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE)
                                            .addComponent(TextFileConsistency, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE)
                                            .addComponent(CorrelationBox, 0, 178, Short.MAX_VALUE))))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(SeparatorConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(SeparatorAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(102, 102, 102)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(ConsistencyFile)
                                    .addComponent(AccuracyFile)))
                            .addComponent(Completeness))
                        .addGap(61, 61, 61))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(VariableName, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(VariableName, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Completeness)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(TextFileAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(SeparatorAccuracy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(AccuracyFile))
                    .addComponent(Accuracy))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Consistency)
                    .addComponent(TextFileConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(SeparatorConsistency, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ConsistencyFile))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Entropy)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Correlation)
                    .addComponent(CorrelationBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(FrequencyDistributions)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 286, Short.MAX_VALUE)
                        .addComponent(cancelButton))
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 420, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        if (Consistency.isSelected() && (TextFileConsistency.getText().equals("") || SeparatorConsistency.getSelectedItem().equals(""))) {
            new AllertDialog(null,true,"Choose file and separator for consistency rule");
            return;
        }
        if (Accuracy.isSelected() && (TextFileAccuracy.getText().equals("") || SeparatorAccuracy.getSelectedItem().equals(""))) {
            new AllertDialog(null,true,"Choose file and separator for accuracy rule");
            return;
        }
        doClose(RET_OK);
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

private void AccuracyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AccuracyFileActionPerformed
  Accuracy.setSelected(true);
  JFileChooser odc = new JFileChooser();
  odc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
  odc.setDialogTitle("Select rules file");
  int odcValue = odc.showOpenDialog(this);
  if (odcValue==JFileChooser.APPROVE_OPTION) {
      this.TextFileAccuracy.setText(odc.getSelectedFile().toString());
  }
}//GEN-LAST:event_AccuracyFileActionPerformed

private void ConsistencyFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConsistencyFileActionPerformed
  Consistency.setSelected(true);
  JFileChooser odc = new JFileChooser();
  odc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
  odc.setDialogTitle("Select rules file");
  int odcValue = odc.showOpenDialog(this);
  if (odcValue==JFileChooser.APPROVE_OPTION) {
      this.TextFileConsistency.setText(odc.getSelectedFile().toString());
  }
}//GEN-LAST:event_ConsistencyFileActionPerformed

private void SeparatorAccuracyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SeparatorAccuracyActionPerformed
    Accuracy.setSelected(true);
}//GEN-LAST:event_SeparatorAccuracyActionPerformed

private void TextFileAccuracyFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_TextFileAccuracyFocusGained
    Accuracy.setSelected(true);
}//GEN-LAST:event_TextFileAccuracyFocusGained

private void SeparatorConsistencyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SeparatorConsistencyActionPerformed
    Consistency.setSelected(true);
}//GEN-LAST:event_SeparatorConsistencyActionPerformed

private void TextFileConsistencyFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_TextFileConsistencyFocusGained
    Consistency.setSelected(true);
}//GEN-LAST:event_TextFileConsistencyFocusGained

private void CorrelationStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_CorrelationStateChanged
    if(Correlation.isSelected())
        FrequencyDistributions.setSelected(true);
}//GEN-LAST:event_CorrelationStateChanged

private void FrequencyDistributionsStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_FrequencyDistributionsStateChanged
if(!FrequencyDistributions.isSelected()) {
        Correlation.setSelected(false);
        Entropy.setSelected(false);
  }
}//GEN-LAST:event_FrequencyDistributionsStateChanged

private void FrequencyDistributionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FrequencyDistributionsActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_FrequencyDistributionsActionPerformed

private void CorrelationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CorrelationActionPerformed
    
}//GEN-LAST:event_CorrelationActionPerformed

private void EntropyStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_EntropyStateChanged
  if(Entropy.isSelected())
     FrequencyDistributions.setSelected(true);// TODO add your handling code here:
}//GEN-LAST:event_EntropyStateChanged

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                ChooseMetadataParametersBlocking dialog = new ChooseMetadataParametersBlocking(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    public boolean getCompleteness() {
        return Completeness.isSelected();
    }
      
    public boolean getAccuracy() {
        return Accuracy.isSelected();
    }
    
    public boolean getConsistency() {
        return Consistency.isSelected();
    }
    
    public boolean getFrequencyDistributions() {
        return FrequencyDistributions.isSelected();
    }
    
    public String getAccuracyFile() {
        return TextFileAccuracy.getText();
    }
    
    public String getAccuracySep() {
        return SeparatorAccuracy.getSelectedItem().toString();
    }
    
    public String getConsistencyFile() {
        return TextFileConsistency.getText();
    }
    
    public String getConsistencySep() {
        return SeparatorConsistency.getSelectedItem().toString();
    }
    
    public boolean getEntropy(){
        return Entropy.isSelected();
    }
    public boolean getCorrelationCramerIndex(){
        return Correlation.isSelected();
    }
    
    public String getCorrelationVarName2(){
        return CorrelationBox.getSelectedItem().toString();
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox Accuracy;
    private javax.swing.JButton AccuracyFile;
    private javax.swing.JCheckBox Completeness;
    private javax.swing.JCheckBox Consistency;
    private javax.swing.JButton ConsistencyFile;
    private javax.swing.JCheckBox Correlation;
    private javax.swing.JComboBox CorrelationBox;
    private javax.swing.JCheckBox Entropy;
    private javax.swing.JCheckBox FrequencyDistributions;
    private javax.swing.JComboBox SeparatorAccuracy;
    private javax.swing.JComboBox SeparatorConsistency;
    private javax.swing.JTextField TextFileAccuracy;
    private javax.swing.JTextField TextFileConsistency;
    private javax.swing.JTextField VariableName;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
           
}
