package it.istat.relais.gui;

import com.visutools.nav.bislider.BiSlider;
import java.awt.*;
import java.sql.Connection;
import javax.swing.JFrame;
import com.visutools.nav.bislider.BiSliderEvent;
import it.istat.relais.project.CurrentStatus;
import it.istat.relais.project.Summary;
import it.istat.relais.project.VariablesSetting;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JLabel;

public class DrawFrame extends javax.swing.JFrame {
    
    private int returnStatus = RET_CANCEL;
    private Connection conn;
    private VariablesSetting vs;
    private Summary sum;
    private CurrentStatus cs;
    private DrawFunction p;
    private BiSlider bsl;
    private TextField tx1;
    private TextField tx2;
    private TextField tx4;
    private TextField tx5;
    private TextField tx6;
    private TextField tx7;
    private double unmTh;
    private double mTh;
    private JButton ok;
    private JButton cancel;
    private JLabel l1;
    private JLabel l2;
    private JLabel l3; 
    private JLabel l4;
    private JLabel l5;
    private JLabel l6;
    private JLabel l7;
    private String MUtable;
    
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    /** Creates new form DrawDiaolog */
    //public DrawFrame(java.awt.Frame parent, boolean modal, Connection conn, VariablesSetting vsIn) {
    public DrawFrame(Connection conn, VariablesSetting vsIn, Summary sumIn, CurrentStatus csIn, String table) {
          
        initComponents();
        this.setTitle("Thresholds");
        MUtable=table;
        
        Image img = java.awt.Toolkit.getDefaultToolkit().createImage("Img\\erre4.jpg");
        this.setIconImage(img);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
					(screenSize.height - frameSize.height) / 2);
        this.conn = conn;
        this.vs = vsIn;
        this.sum = sumIn;
        this.cs = csIn; 
        this.setResizable(false);
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

        l1 = new JLabel();
     l1.setFont(Font.decode("Bold"));
     l1.setText("Unmatch Threshold");
          
     tx1 = new TextField();
     tx1.setEditable(false);
     tx1.setFont(Font.decode("BOLD"));

     l2 = new JLabel();
     l2.setFont(Font.decode("Bold"));
     l2.setText("Match Threshold");
     
     tx2 = new TextField();
     tx2.setEditable(false);
     tx2.setFont(Font.decode("BOLD"));

     //new BiSlider(new NumberRangeModel(0, 100, -255, 255));
     bsl = new BiSlider();
     bsl.setHorizontal(true);
     bsl.setMinimumValue(0);
     bsl.setMaximumValue(1);
     bsl.setSliderBackground(Color.WHITE);
     bsl.setUniformSegment(true);        
     bsl.setSegmentSize(0.10);
     bsl.setMaximumColor(Color.blue);
     bsl.setMinimumColor(Color.green);
     bsl.addBiSliderListener(new MyBiSliderListener());

     tx1.setText(""+(float)bsl.getMinimumColoredValue());
     tx2.setText(""+(float)bsl.getMaximumColoredValue());
     
     unmTh = bsl.getMinimumColoredValue();
     mTh = bsl.getMaximumColoredValue();
     p = new DrawFunction(conn,MUtable);
     p.setInitialLine1Position();
     p.setInitialLine2Position();
     
     l3 = new JLabel();
     l3.setFont(Font.decode("Bold"));
     l3.setText("Move the sliding bars to assign the thresholds values");

     tx4 = new TextField();
     tx4.setEditable(false);
     tx4.setFont(Font.decode("BOLD"));
     tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
     //tx4.setText(p.getNMatch((float)(0.9)));
     tx5 = new TextField();
     tx5.setEditable(false);
     tx5.setFont(Font.decode("BOLD"));
     tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
     tx6 = new TextField();
     tx6.setEditable(false);
     tx6.setFont(Font.decode("BOLD"));
     tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
     //tx6.setText(p.getTruLinkM((float)(0.9)));
     tx7 = new TextField();
     tx7.setEditable(false);
     tx7.setFont(Font.decode("BOLD"));
     tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
   
     l4 = new JLabel();
     l4.setFont(Font.decode("Bold"));
     l4.setText("Matches");
     l5 = new JLabel();
     l5.setFont(Font.decode("Bold"));
     l5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
     l5.setText("Possible Matches");
     l6 = new JLabel();
     l6.setFont(Font.decode("Bold"));
     l6.setText("Estimated true links");
     l7 = new JLabel();
     l7.setFont(Font.decode("Bold"));
     l7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
     l7.setText("Estimated true links");
     
    ok = new JButton("Ok");
    //ok.setText("OK");
    ok.setToolTipText("Use these thresholds");
    ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                returnStatus = RET_OK;
                System.out.println("Thresholds chosen");
                vs.UpdateThresholdU(bsl.getMinimumColoredValue());
                System.out.println("Unmatch Threshold: "+vs.ReadThresholdU());
                vs.UpdateThresholdM(bsl.getMaximumColoredValue());
                System.out.println("Match Threshold "+vs.ReadThresholdM());
                int idcs=cs.Insert("SMT", "Setting match threshold");
                cs.UpdateStatus(idcs, "Successfully terminated");
               sum.Insert(38, "Threshold Unmatch", vs.ReadThresholdU(), "");
               sum.Insert(39, "Threshold Match", vs.ReadThresholdM(), "");
  
                dispose();
                
            }
     
        });
    
      cancel = new JButton("Cancel");
      cancel.setToolTipText("Close window");
      cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                returnStatus = RET_CANCEL;  
                System.out.println("Thresholds choice canceled");
                dispose();
                
            }
        });
      
      double mtr = vs.ReadThresholdM();
     double utr = vs.ReadThresholdU();
            
     if (mtr>=0 && utr>=0) {      
         bsl.setMinimumColoredValue(utr);
         p.setLine1Position((float)utr, (float)utr);
         bsl.setMaximumColoredValue(mtr);
         p.setLine2Position((float)mtr, (float)mtr);
     } 
     
     this.add(l1);
     this.add(tx1);
     this.add(l2);
     this.add(tx2);
     this.add(p);
     this.add(bsl);
     this.add(l3);
     this.add(l4);
     this.add(tx4);
     this.add(tx5);
     this.add(l5);
     this.add(l6);
     this.add(tx6);
     this.add(tx7);
     this.add(l7);
     this.add(ok);
     this.add(cancel);
     
     l1.setBounds(10,5,115,20);
     tx1.setBounds(125, 5, 115, 20);
     l2.setBounds(250,5,100,20);
     tx2.setBounds(350,5,115,20);
     p.setBounds(2, 25,500, 300); 
     bsl.setBounds(2,325,500, 30); 
     l3.setBounds(100, 360, 400, 20);
     l4.setBounds(50, 390, 140, 18);
     tx4.setBounds(190, 390, 60, 18);
     tx5.setBounds(250, 390, 60, 18);
     l5.setBounds(310, 390, 140, 18);
     l6.setBounds(50, 408, 140, 18);
     tx6.setBounds(190, 408, 60, 18);
     tx7.setBounds(250, 408, 60, 18);
     l7.setBounds(310, 408, 140, 18);
     ok.setBounds(80, 450,100, 30); 
     cancel.setBounds(320, 450,100, 30); 
     
     //this.setBounds(100,100,500,420);
     this.pack();
     this.setVisible(true); 
     
    }

  


public int getReturnStatus() {
    
    return returnStatus;
    }

public class MyBiSliderListener implements com.visutools.nav.bislider.BiSliderListener{
    public void newMinValue(BiSliderEvent e){
       tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint();
       p.setLine1Position((float)bsl.getMinimumColoredValue(),(float)bsl.getMinimumColoredValue());
       p.repaint();
       tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
    }
    public void newMaxValue(BiSliderEvent e){
       tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint();
      p.setLine2Position((float)bsl.getMaximumColoredValue(),(float)bsl.getMaximumColoredValue());
      p.repaint();  
       tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
    }

    public void newValues(BiSliderEvent BiSliderEvent_Arg) {
        tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint();
             p.setLine1Position((float)bsl.getMinimumColoredValue(),(float)bsl.getMinimumColoredValue());
             p.setLine2Position((float)bsl.getMaximumColoredValue(),(float)bsl.getMaximumColoredValue());
        p.repaint();  
        tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
        }

        @Override
        public void newColors(BiSliderEvent BiSliderEvent_Arg) {
          tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint(); 
            p.setLine1Position((float)bsl.getMinimumColoredValue(),(float)bsl.getMinimumColoredValue());
            p.setLine2Position((float)bsl.getMaximumColoredValue(),(float)bsl.getMaximumColoredValue());
            p.repaint();  
            tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
        }

        @Override
        public void prepareJumpValues(BiSliderEvent BiSliderEvent_Arg) {
            throw new UnsupportedOperationException("Not supported yet.");
        }

        @Override
        public void notifyJumpValues(BiSliderEvent BiSliderEvent_Arg) {
            throw new UnsupportedOperationException("Not supported yet.");
        }

        

        @Override
        public void newSegments(BiSliderEvent BiSliderEvent_Arg) {
            throw new UnsupportedOperationException("Not supported yet.");
        }

        @Override
        public void newMin(BiSliderEvent BiSliderEvent_Arg) {
         tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint(); 
         p.setLine1Position((float)bsl.getMinimumValue(),(float)bsl.getMinimumValue());
             p.repaint();
             tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
        }

        @Override
        public void newMax(BiSliderEvent BiSliderEvent_Arg) {
         tx1.setText(""+(float)bsl.getMinimumColoredValue());
       tx1.repaint();
       tx2.setText(""+(float)bsl.getMaximumColoredValue());
       tx2.repaint();
         p.setLine2Position((float)bsl.getMaximumValue(),(float)bsl.getMaximumValue());
           p.repaint();
           tx4.setText(p.getNMatch((float)bsl.getMaximumColoredValue()));
       tx5.setText(p.getNPMatch((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
       tx6.setText(p.getTruLinkM((float)bsl.getMaximumColoredValue()));
       tx7.setText(p.getTruLinkP((float)bsl.getMinimumColoredValue(),(float)bsl.getMaximumColoredValue()));
        }

        @Override
        public void newGlobalRange(BiSliderEvent BiSliderEvent_Arg) {
            throw new UnsupportedOperationException("Not supported yet.");
        }

       
       
    }

 
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 507, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 499, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
                                              

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
              //  DrawFrame dialog = new DrawFrame(new javax.swing.JFrame(), true, null, null);
                DrawFrame dialog = new DrawFrame(null, null, null, null,null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                   }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
