package it.istat.relais.gui;

import it.istat.relais.constants.TablesName;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.DecimalFormat;
import javax.swing.JPanel;


public class DrawFunction extends JPanel {
private Connection conn;
private float[] xdata; 
private float[] mydata;
private float[] uydata;
private float[] xdataval;
private float[] fm_val;
private float[] fu_val;
private int dimData;
private String MUtable;
//int xMin=0, xMax=1, yMin=-20, yMax=1;
int xMin=0, xMax=1, yMin=0, yMax=1;
//int larghezza=500, altezza=500;
int larghezza=500, altezza=250;
float fattoreScalaX, fattoreScalaY;
float maxVal;
int lx1, lx2, ly1, ly2=altezza-1;
int l2x1, l2x2, l2y1, l2y2=altezza-1;

public DrawFunction(Connection connection, String tableName){		
    
    int k;
    maxVal = (float) 0.1;
    this.conn = connection;   
    this.MUtable=tableName;
    try{
           Statement stm1 = (Statement)conn.createStatement();
	   ResultSet rs1 = stm1.executeQuery("SELECT COUNT(*) FROM "+MUtable);
           rs1.next();
           dimData = rs1.getInt(1);
           stm1.close();
	   
           mydata = new float[dimData];
           Statement stm2 = (Statement)conn.createStatement();
	   ResultSet rs2 = stm2.executeQuery("SELECT m FROM "+MUtable+" order by p_post");
           /*ResultSet rs2 = stm2.executeQuery("select s_m from "+
                      " (select a.p_post,sum(b.m) s_m from (select distinct p_post from "+
                      TablesName.nameMU()+ " a, "+TablesName.nameMU()+" b "+
                      " where b.p_post>=a.p_post group by a.p_post) as calc order by p_post ");*/
           k=0;
           while(rs2.next()){
              mydata[k] = rs2.getFloat(1);
              //System.out.println("m:"+mydata[k]);
              if (maxVal<mydata[k]) maxVal=mydata[k];
              k++;
           }
           stm2.close();
	   
           uydata = new float[dimData];
           Statement stm3 = (Statement)conn.createStatement();
	   ResultSet rs3 = stm3.executeQuery("SELECT u FROM "+MUtable+" order by p_post");
           /*ResultSet rs3 = stm3.executeQuery("select s_u from "+
                      " (select a.p_post,sum(b.u) s_u from (select distinct p_post from "+
                      TablesName.nameMU()+ " a, "+TablesName.nameMU()+" b "+
                      " where b.p_post>=a.p_post group by a.p_post) as calc order by p_post ");*/
           k=0;
           while(rs3.next()){
              uydata[k] = rs3.getFloat(1);
              //System.out.println("u:"+uydata[k]);
              if (maxVal<uydata[k]) maxVal=uydata[k];
              k++;
           }
           stm3.close();
	   xdata = new float[dimData];
           
           for(int jj=0; jj<dimData; jj++){
              xdata[jj]= (float)(jj)/(dimData-1);   
           }
           
           xdataval = new float[dimData];
           Statement stm4 = (Statement)conn.createStatement();
	   ResultSet rs4 = stm4.executeQuery("SELECT p_post FROM "+MUtable+" order by p_post");
           
           k=0;
           while(rs4.next()){
              xdataval[k] = rs4.getFloat(1);
              //System.out.println("x:"+xdataval[k]);
              k++;
           }
           stm4.close();
           
           fm_val = new float[dimData];
           Statement stm5 = (Statement)conn.createStatement();
	   ResultSet rs5 = stm5.executeQuery("SELECT f_m FROM "+MUtable+" order by p_post");
           
           k=0;
           while(rs5.next()){
              fm_val[k] = rs5.getFloat(1);
              k++;
           }
           stm5.close();
           
           fu_val = new float[dimData];
           Statement stm6 = (Statement)conn.createStatement();
	   ResultSet rs6 = stm6.executeQuery("SELECT f_u FROM "+MUtable+" order by p_post");
           
           k=0;
           while(rs6.next()){
              fu_val[k] = rs6.getFloat(1);
              k++;
           }
           stm6.close();
           
	}catch(Exception e){
	   e.printStackTrace();
	}
    }


  
    @Override
public void paintComponent(Graphics g){
    
    super.paintComponent(g); 
    Graphics2D g2 = (Graphics2D)g;
    setBackground(Color.white); 
    fattoreScalaX=larghezza/((float)xMax-xMin);  
    fattoreScalaY=altezza/((float)yMax-yMin); 
    g2.setColor(Color.black);
    g2.drawRect(0,0,larghezza+10,altezza+40);
    //g2.setColor(Color.BLUE);
    
    //g2.drawLine(0,altezza/2, larghezza-1,altezza/2); //ascisse X 
    g2.drawLine(0,altezza+1, larghezza-1,altezza+1); //ascisse X 
    g2.drawLine(1,0,1,altezza+15);  //ordinata Y 
    //g2.drawString(""+xMin, 5,altezza/2-5);  
    //g2.drawString(""+xMax, larghezza-20,altezza/2-5); 
    //g2.drawString(""+xMin, 5,altezza+12);  
    //g2.drawString(""+xMax, larghezza-20,altezza+12); 
    //g2.drawString(""+yMax, 5,15); 
    g2.drawString(""+maxVal, 5,15);
    //g2.drawString(""+yMin, 5,altezza-5); 
    
    
    
    g2.setColor(Color.blue);
    draw(g2,xdata,mydata); //draw Match
    g2.drawString("Match distribution (log)",(larghezza-170),25);
    g2.setColor(Color.red);
    draw(g2,xdata,uydata); //draw Unmatch
    g2.drawString("Unmatch distribution (log)",20,25);
    
    //riga da associalre allo slider
    g2.setColor(Color.black);
    g2.drawString("p_post", larghezza/2,altezza+24); 
    drowppost(g2,xdata,xdataval);
    g2.setColor(Color.black);
    g2.drawLine(lx1,lx2,ly1,ly2);
    g2.setColor(Color.black);
    g2.drawLine(l2x1,l2x2,l2y1,l2y2);
    
    }
    
    
    
    void draw(Graphics2D g2, float[] xdata, float[] ydata ){
        
        /*       
        for(int ii=0; ii<dimData-1;ii++){
            setPixel(g2, xdata[ii],f(ydata[ii]),xdata[ii+1],f(ydata[ii+1]));
        }
        setPixel(g2, xdata[dimData-1],f(ydata[dimData-1]),xdata[dimData-1],f(ydata[dimData-1]));
        */
        for(int ii=0; ii<dimData-1;ii++){
            int startx=(int)(larghezza*xdata[ii]);
            int starty=(int)(altezza*(1-f(ydata[ii])));
            int stopx=(int)(larghezza*xdata[ii+1]);
            int stopy=(int)(altezza*(1-f(ydata[ii+1])));
            //ystem.out.println(startx+":"+starty+":"+lungx+":"+lungy);
            g2.drawLine( startx,starty,stopx,stopy);
            g2.drawLine( startx,starty+1,stopx,stopy+1);
        }
        
        
    }
    
    void drowppost(Graphics2D g2, float[] xdata, float[] xdataval ){
        for(int ii=0; ii<dimData-1;ii++){
            int startx=(int)(larghezza*xdata[ii]);
            if (ii%(dimData/8)==0)
                g2.drawString(""+xdataval[ii+1],startx,altezza+12);
            g2.drawLine( startx,altezza-3,startx,altezza);
        }
    }
    
// definizione della funzione,
// statica, da graficare
static float oldf(float x){
 if(x==0)
     return (float) (-13);
else
     return (float) Math.log(x);
}

float f(float x){
 if(x==0)
     return (float) (0);
else
     return (float) (1)/(float)(Math.log(1+(maxVal/x))/Math.log(2));
}

void setPixel(Graphics2D g2, float x, float y, float x2, float y2){
    
    g2.setFont(Font.decode("Bold"));
    
    if (x<xMin || x>xMax || y<yMin || y>yMax ){
        return;
    }
  
   int ix1 = Math.round((x-xMin)*fattoreScalaX); 
   int iy1 = altezza-Math.round((y-yMin)*fattoreScalaY);
   int ix2 = Math.round((x2-xMin)*fattoreScalaX);
   int iy2 = altezza-Math.round((y2-yMin)*fattoreScalaY);
   g2.drawLine(ix1, iy1, ix2, iy2);
   
}


void setLine1Position(float x1, float y1){
    
    int ii;
    for(ii=0; ii<dimData-1;ii++){
            if (xdataval[ii]>=x1) break;
    }

    lx1 = (int)(xdata[ii]*larghezza);
    lx2 = 0;
    ly1 = (int)(xdata[ii]*larghezza);
    ly2 = altezza-1;
            
    if (ii==dimData-1) { /*last case vline value */
        lx1=lx1-2;
        ly1=ly1-2;
    }
    //System.out.println(x1+":"+ii+":"+lx1+":"+ly1);
    /*lx1 = Math.round((x1-xMin)*fattoreScalaX);
    lx2 = 0;
    ly1 = Math.round((y1-xMin)*fattoreScalaX);
    ly2 = altezza-1;*/
}

void setLine2Position(float x1, float y1){
    
    int ii;
    for(ii=0; ii<dimData-1;ii++){
            if (xdataval[ii]>=x1) break;
    }

    l2x1 = (int)(xdata[ii]*larghezza);
    l2x2 = 0;
    l2y1 = (int)(xdata[ii]*larghezza);
    l2y2 = altezza-1;
    
    if (ii==dimData-1) { /*last case vline value */
        l2x1=l2x1-2;
        l2y1=l2y1-2;
    }
    /*l2x1 = Math.round((x1-xMin)*fattoreScalaX);
    l2x2 = 0;
    l2y1 = Math.round((y1-xMin)*fattoreScalaX);
    l2y2 = altezza-1;*/
}


void setInitialLine1Position(){
    lx1 = 1;
    lx2 = 0;
    ly1 = 1;
    ly2 = altezza-1;
}

void setInitialLine2Position(){
    l2x1 = larghezza-1 ;
    l2x2 = 0;
    l2y1 = larghezza-1 ;
    l2y2 = altezza-1;
}

String getNMatch(float tm){
    float nmatch=0;
    int ii;
    for(ii=0; ii<dimData;ii++){
        if (xdataval[ii]>=tm) {
                nmatch += fm_val[ii];
                nmatch += fu_val[ii];
        }
    }

    return " "+Math.round(nmatch);
}

String getNPMatch(float tu,float tm){
    float nmatch=0;
    int ii;
    for(ii=0; ii<dimData;ii++){
        if (xdataval[ii]>=tu && xdataval[ii]<tm) {
                nmatch += fm_val[ii];
                nmatch += fu_val[ii];
        }
    }

    return " "+Math.round(nmatch);
}

String getTruLinkM(float tm){
    float nmatch=0;
    int ii;
    for(ii=0; ii<dimData;ii++){
        if (xdataval[ii]>=tm) {
                nmatch += fm_val[ii];
        }
    }
    //System.out.println(" "+nmatch);
    DecimalFormat df= new DecimalFormat("#.#");
    return " "+ df.format(nmatch);
}

String getTruLinkP(float tu,float tm){
    float nmatch=0;
    int ii;
    for(ii=0; ii<dimData;ii++){
        if (xdataval[ii]>=tu && xdataval[ii]<tm)  {
                nmatch += fm_val[ii];
        }
    }
    //System.out.println(" "+nmatch);
    DecimalFormat df= new DecimalFormat("#.#");
    return " "+ df.format(nmatch);
}

}

