package it.istat.relais.gui;

import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.ComboBoxModel;

public class FieldSplit extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    ComboBoxModel itemsa;
    ComboBoxModel itemsb;
            
    public FieldSplit(java.awt.Frame parent, boolean modal, String lintype,ComboBoxModel itemsa, ComboBoxModel itemsb) {
        super(parent, modal);
        initComponents();
        this.itemsa=itemsa;
        this.itemsb=itemsb;
        if (itemsa!=null) comboVariable.setModel(itemsa);
        if (lintype.equalsIgnoreCase("Deduplication")) comboSet.setEnabled(false);
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
					(screenSize.height - frameSize.height) / 2);
    }

    public int getReturnStatus() {
        return returnStatus;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        comboSet = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        comboVariable = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        comboCase = new javax.swing.JComboBox();
        textSeparator = new javax.swing.JTextField();
        radioSeparator = new javax.swing.JRadioButton();
        radioLength = new javax.swing.JRadioButton();
        textLength = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        textNewVariable = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        textNewVariable2 = new javax.swing.JTextField();

        setTitle("Preprocessing");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("Add new variables");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setText("Field Parse:");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        comboSet.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Dataset A", "Dataset B" }));
        comboSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboSetActionPerformed(evt);
            }
        });

        jLabel2.setText("Dataset:");

        jLabel3.setText("Variable:");

        comboVariable.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(comboSet, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(comboVariable, 0, 296, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(comboSet, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(comboVariable, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        comboCase.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Begin", "End" }));

        textSeparator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textSeparatorActionPerformed(evt);
            }
        });

        radioSeparator.setSelected(true);
        radioSeparator.setText("Separator");
        radioSeparator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioSeparatorActionPerformed(evt);
            }
        });

        radioLength.setText("Length");
        radioLength.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioLengthActionPerformed(evt);
            }
        });

        textLength.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textLengthActionPerformed(evt);
            }
        });

        jLabel7.setText("Starting from:");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(radioSeparator)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(textSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(143, 143, 143)
                        .addComponent(radioLength)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 38, Short.MAX_VALUE)
                        .addComponent(textLength, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(comboCase, 0, 294, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radioSeparator)
                    .addComponent(textSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(radioLength)
                    .addComponent(textLength, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(comboCase, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        textNewVariable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textNewVariableActionPerformed(evt);
            }
        });

        jLabel5.setText("First new variable name:");

        jLabel6.setText("Second new variable name:");

        textNewVariable2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textNewVariable2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(96, 96, 96)
                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(46, 46, 46)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(textNewVariable2, javax.swing.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                            .addComponent(textNewVariable, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 247, Short.MAX_VALUE)))
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textNewVariable, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textNewVariable2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 20, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addGap(20, 20, 20))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        if (this.getTypeSeparator() && getSeparator().equals("")) {
            new AllertDialog(null,true,"Separator is required");
        } else if (!this.getTypeSeparator() && getLength()<=0) {
            new AllertDialog(null,true,"A numeric value for length is required");
        } else if (this.getNewField().length()<1) {
            new AllertDialog(null,true,"First new variable name is required");
        } else if (NewVariableExists()) {
            new AllertDialog(null,true,"The inputed first new variable name is already used in dataset");
        } else if (this.getNewField2().length()<1) {
            new AllertDialog(null,true,"Second new variable name is required");
        } else if (NewVariable2Exists()) {
            new AllertDialog(null,true,"The inputed second new variable name is already used in dataset");
        }
        else {
            doClose(RET_OK);
        }

    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

private void textSeparatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textSeparatorActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_textSeparatorActionPerformed

private void comboSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboSetActionPerformed
// TODO add your handling code here:
    if (comboSet.getSelectedIndex()==1) comboVariable.setModel(itemsb);
    else comboVariable.setModel(itemsa);
}//GEN-LAST:event_comboSetActionPerformed

private void radioSeparatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioSeparatorActionPerformed
// TODO add your handling code here:
  this.radioLength.setSelected(!this.radioSeparator.isSelected());
}//GEN-LAST:event_radioSeparatorActionPerformed

private void textNewVariableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textNewVariableActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_textNewVariableActionPerformed

private void textNewVariable2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textNewVariable2ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_textNewVariable2ActionPerformed

private void radioLengthActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioLengthActionPerformed
// TODO add your handling code here:
  this.radioSeparator.setSelected(!this.radioLength.isSelected());
}//GEN-LAST:event_radioLengthActionPerformed

private void textLengthActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textLengthActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_textLengthActionPerformed

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }
    
    public String getSeparator() {
        return this.textSeparator.getText().replace("'","''");
    }
    
    public int getLength() {
        int val=0;
        try {
         val = Integer.parseInt(this.textLength.getText());
        } catch (Exception ex) { 
        }
        return val;
    }
    
    public String getSet() {
        if (this.comboSet.getSelectedIndex()==1) return "B";
        return "A";
    }
    
    public String getField() {
        return this.comboVariable.getSelectedItem().toString();
    }
    
    public boolean getTypeSeparator() {
        if (this.radioSeparator.isSelected()) return true;
        return false;
    }
        
    public boolean getStartBegin() {
        if (this.comboCase.getSelectedIndex()==1) return false;
        return true;
    }
    
    public String getNewField() {
        return this.textNewVariable.getText().toUpperCase();
    }
    
    public String getNewField2() {
        return this.textNewVariable2.getText().toUpperCase();
    }
    
    public boolean NewVariableExists() {
        ComboBoxModel items;
        if (this.comboSet.getSelectedIndex()==1) {
            items = itemsb;
        } else {
            items = itemsa;
        }
        for (int ind=0;ind<items.getSize();ind++) {
           if (items.getElementAt(ind).toString().equals(getNewField())) 
               return true;
        }
        return false;
    }
    
    public boolean NewVariable2Exists() {
        ComboBoxModel items;
        if (this.comboSet.getSelectedIndex()==1) {
            items = itemsb;
        } else {
            items = itemsa;
        }
        for (int ind=0;ind<items.getSize();ind++) {
           if (items.getElementAt(ind).toString().equals(getNewField2())) 
               return true;
        }
        return false;
    }
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FieldSplit dialog = new FieldSplit(new javax.swing.JFrame(), true,null, null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox comboCase;
    private javax.swing.JComboBox comboSet;
    private javax.swing.JComboBox comboVariable;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton okButton;
    private javax.swing.JRadioButton radioLength;
    private javax.swing.JRadioButton radioSeparator;
    private javax.swing.JTextField textLength;
    private javax.swing.JTextField textNewVariable;
    private javax.swing.JTextField textNewVariable2;
    private javax.swing.JTextField textSeparator;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
}
