package it.istat.relais.gui;

import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.project.Summary;
import it.istat.relais.project.SummaryData;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.util.ArrayList;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class FinalSummaryDialog extends javax.swing.JDialog {
    public Summary summary;
    public MatchingVariables mv;
    public String model=null;
    private JPanel panel;
    
    public FinalSummaryDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        this.setTitle("Process Summaries");
        initComponents();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
					(screenSize.height - frameSize.height) / 2);
        this.setVisible(false);
   
    }
 
            

    public void show(Summary summary, MatchingVariables mv) {
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
     Dimension frameSize = getSize();
        
        this.mv = mv;
        
        ArrayList<SummaryData> sdata = new ArrayList<SummaryData>();
       setLayout(new BorderLayout());  
        panel=new JPanel();  
        panel.setLayout(new FlowLayout());  
        add(panel);  
        
        String str="<html><table border =\"1\">";
        
        if(dsaDone(summary)){
        sdata.add(summary.Read("DSASum"));
        str+="<tr><td>Record in dataset A</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        if(dsbDone(summary)){
        sdata.add(summary.Read("DSBSum"));
        str+="<tr><td>Record in dataset B</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        if(SSRDone(summary)){
        sdata.add(summary.Read("SSRMethod"));
        str+="<tr><td>Method for Search Space Creation</td>";
        str+="<td>"+sdata.get(sdata.size()-1).getDescription()+"</td></tr>";
        // close bottom }
        
        if(sdata.get(sdata.size()-1).getDescription().equals("Cartesian Product")){
           // sdata.add(summary.Read("PairsInSpace"));
           // str+="<tr><td>Pairs in Space</td>";
           // str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        else if(sdata.get(sdata.size()-1).getDescription().equals("Blocking")){
            sdata.add(summary.Read("NumberBlock"));
            str+="<tr><td>Number of Blocks</td>";
            str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }    
        else if(sdata.get(sdata.size()-1).getDescription().equals("Sorted Neighborhood")){
            sdata.add(summary.Read("SNM"));
            str+="<tr><td>Window Size</td>";
            str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        else if(sdata.get(sdata.size()-1).getDescription().equals("Nested Blocking")){
            sdata.add(summary.Read("NumberBlock"));
            str+="<tr><td>Number of blocks</td>";
            str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
            sdata.add(summary.Read("NestedBlocking"));
            str+="<tr></td>Window Size</td>";
            str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        sdata.add(summary.Read("PairsInSpace"));
        str+="<tr><td>Pairs in Space</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        } //close if(SSRDone(summary))
        
        if(decisionalModelDone(summary)){
        sdata.add(summary.Read("DescisionalModel"));
        str+="<tr><td>Decisional Model</td>";
        model = sdata.get(sdata.size()-1).getDescription();
        str+="<td>"+model+"</td></tr>";
        
        }
        
        if(reductionDone(summary)){
        sdata.add(summary.Read("ReductionMethod"));
        str+="<tr><td>Method of Reduction 1:1</td>";
        str+="<td>"+sdata.get(sdata.size()-1).getDescription()+"</td></tr>";
        }
        
        if(thresholdUnmatchDone(summary)&&thresholdMatchDone(summary)){
        sdata.add(summary.Read("threshold1"));
        str+="<tr><td>Unmatch Threshold</td>";
        str+="<td>"+sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        sdata.add(summary.Read("threshold2"));
        str+="<tr><td>Match Threshold</td>";
        str+="<td>"+sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        
        if(matchDone(summary)){
        sdata.add(summary.Read("match"));
        str+="<tr><td>Number of match</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
          }
        
        if(possiblematchDone(summary)){
        sdata.add(summary.Read("possiblematch"));
        str+="<tr><td>Number of possible match</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        
        if(unmatchDone(summary)){
        sdata.add(summary.Read("unmatch"));
        str+="<tr><td>Number of unmatch</td>";
        str+="<td>"+(int)sdata.get(sdata.size()-1).getValue()+"</td></tr>";
        }
        
        //str+="<tr><td align='center'>"+"button1"+"</td>";
        //str+="<td>"+"button2"+"</td></tr>";
        
        str+="</table></html>";
        
        JLabel label=new JLabel(str);  
        add(label, BorderLayout.PAGE_START);       
       setSize((screenSize.width - frameSize.width) / 2,(screenSize.height - frameSize.height) / 2);  
       setVisible(true);  
      
        
    }
    
    public boolean dsaDone(Summary summary){
        return(summary.dsaDone());
    }
    
    public boolean dsbDone(Summary summary){
        return(summary.dsbDone());
    }
    
    public boolean SSRDone(Summary summary){
        return(summary.SSRDone()); 
    }
    public boolean decisionalModelDone(Summary summary){
        return(summary.decisionalModelDone());
    }
    
    public boolean reductionDone(Summary summary){
        return(summary.reductionDone());
    }
    public boolean thresholdUnmatchDone(Summary summary){
        return(summary.thresholdUnmatchDone());
    }
    
    public boolean thresholdMatchDone(Summary summary){
        return(summary.thresholdMatchDone());
    }
    
    public boolean unmatchDone(Summary summary){
        return(summary.unmatchDone());
    }
    
    public boolean matchDone(Summary summary){
        return(summary.matchDone());
    }
     
    public boolean possiblematchDone(Summary summary){
        return(summary.possiblematchDone());
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        OkButton = new javax.swing.JButton();
        DetailsButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setBackground(new java.awt.Color(204, 204, 204));

        OkButton.setText("Ok");
        OkButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OkButtonActionPerformed(evt);
            }
        });

        DetailsButton1.setText("Details");
        DetailsButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DetailsButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(40, 40, 40)
                .addComponent(DetailsButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 214, Short.MAX_VALUE)
                .addComponent(OkButton)
                .addGap(48, 48, 48))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(264, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(DetailsButton1)
                    .addComponent(OkButton))
                .addGap(27, 27, 27))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void OkButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OkButtonActionPerformed
  dispose();
}//GEN-LAST:event_OkButtonActionPerformed

private void DetailsButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DetailsButton1ActionPerformed
DetailsDialog dd = new DetailsDialog(new javax.swing.JFrame(), true);
   dd.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        //System.exit(0);
                    }
   });
   if(model.equalsIgnoreCase("Fellegi-Sunter"))
       dd.showFS(mv);
   else if(model.equalsIgnoreCase("Rule based"))
       dd.showRB();
   else if(model.equalsIgnoreCase("Exact"))
       dd.showEQ();
}//GEN-LAST:event_DetailsButton1ActionPerformed

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                FinalSummaryDialog dialog = new FinalSummaryDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
                                          

    private void closeDialog(java.awt.event.WindowEvent evt) {                             
        dispose();
    }                            

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton DetailsButton1;
    private javax.swing.JButton OkButton;
    // End of variables declaration//GEN-END:variables

}
