package it.istat.relais.gui;

import it.istat.relais.metrics.dataStructure.MetricMatchingVariable;
import java.awt.Dimension;
import java.awt.Toolkit;


public class ReadDistanceThreshold extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    MetricMatchingVariable mMatchVariable;

    public ReadDistanceThreshold(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        mMatchVariable = null;
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
	setLocation((screenSize.width - frameSize.width) / 2,
		    (screenSize.height - frameSize.height) / 2);
    }

    public void setMatchingVariable(MetricMatchingVariable mmv) {
        this.mMatchVariable = mmv;
        String distance;
        double treshold;
        int windowSize;
        
        this.VariableName.setText(this.mMatchVariable.getMatchingVariable());
        distance = this.mMatchVariable.getComparisonFunction();
        if (distance!=null)
            this.ComboDistance.setSelectedItem(distance);
        else
            this.ComboDistance.setSelectedIndex(0);
        treshold = this.mMatchVariable.getMetricThreshold();
        this.InputThreshold.setText(String.valueOf(treshold));
        windowSize = this.mMatchVariable.getWindowSize();
        this.WindowSize.setText(String.valueOf(windowSize));
         
    }
    
    public MetricMatchingVariable getMatchingVariable() {
        mMatchVariable.setComparisonFunction((String)ComboDistance.getSelectedItem());
        mMatchVariable.setMetricThreshold(Double.parseDouble(InputThreshold.getText()));
        mMatchVariable.setWindowSize(Integer.parseInt(WindowSize.getText()));
        return mMatchVariable;
    }
    
    public int getReturnStatus() {
        return returnStatus;
    }
        
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        VariableName = new javax.swing.JTextField();
        ComboDistance = new javax.swing.JComboBox();
        InputThreshold = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        WindowSize = new javax.swing.JTextField();

        setTitle("Settings");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Set metric and threshold"));

        jLabel1.setText("Match Variable");

        jLabel2.setText("Similarity Metric");

        jLabel3.setText("Threshold");

        VariableName.setEditable(false);
        VariableName.setText("variable");
        VariableName.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        ComboDistance.setMaximumRowCount(6);
        ComboDistance.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Equality", "NumericComparison", "3Grams", "Dice", "Jaro", "JaroWinkler", "Levenshtein", "Soundex", "WindowEquality", "Inclusion3Grams" }));
        ComboDistance.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboDistanceActionPerformed(evt);
            }
        });

        InputThreshold.setText("1.0");
        InputThreshold.setEnabled(false);
        InputThreshold.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                InputThresholdActionPerformed(evt);
            }
        });

        jLabel4.setText("Window size");

        WindowSize.setText("1.0");
        WindowSize.setEnabled(false);
        WindowSize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                WindowSizeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(VariableName)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(ComboDistance, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(InputThreshold, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addGap(18, 18, 18)
                                .addComponent(WindowSize, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(17, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(VariableName, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ComboDistance, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(InputThreshold, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(WindowSize, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(14, 14, 14)
                        .addComponent(cancelButton)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        try {
            if((ComboDistance.getSelectedItem().equals("WindowEquality"))){
                int verificaWind = Integer.parseInt(WindowSize.getText());
                if(verificaWind>=1)
                    ;
                else
                  System.out.println("WARNING! The value of the window size must be an integer greater than 1");      
            }
            double verificatresh = Double.parseDouble(InputThreshold.getText());
            if (verificatresh<=1 && verificatresh>=0)
                doClose(RET_OK);
            else
                System.out.println("WARNING! The value of the threshold must be a number between 0 and 1 ");
        } catch (Exception ex) {
            System.out.println("WARNING! The value of the threshold must be a number ");
        }
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

private void InputThresholdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_InputThresholdActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_InputThresholdActionPerformed

private void ComboDistanceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboDistanceActionPerformed
    if ((ComboDistance.getSelectedItem().equals("Equality"))||(ComboDistance.getSelectedItem().equals("WindowEquality"))) {
        InputThreshold.setText("1.0");
        InputThreshold.setEnabled(false);
        
    } else {
        InputThreshold.setEnabled(true);
       
    }
    if ((ComboDistance.getSelectedItem().equals("WindowEquality"))) {
        WindowSize.setText("1");
        WindowSize.setEnabled(true);
    }
    else
         WindowSize.setEnabled(false);
    
}//GEN-LAST:event_ComboDistanceActionPerformed

    private void WindowSizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_WindowSizeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_WindowSizeActionPerformed

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                ReadDistanceThreshold dialog = new ReadDistanceThreshold(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox ComboDistance;
    private javax.swing.JTextField InputThreshold;
    private javax.swing.JTextField VariableName;
    private javax.swing.JTextField WindowSize;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
        
   
            
}
