package it.istat.relais.gui;

import it.istat.relais.constants.ReleaseName;
import it.istat.relais.constants.TablesName;
import it.istat.relais.displayTables.DisplayTable;
import it.istat.relais.displayTables.WeightDialog;
import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.metrics.dataStructure.MetricMatchingVariable;
import it.istat.relais.metrics.dataStructure.MetricMatchingVariableVector;
import it.istat.relais.result.ResultTable;

import it.istat.relais.project.DBConfiguration;
import it.istat.relais.project.VariablesSetting;
import it.istat.relais.project.CurrentStatus;
import it.istat.relais.export.ExportToDb;
import it.istat.relais.gui.task.*;

import it.istat.relais.log.TraceLog;
import it.istat.relais.matchingVariables.RemoveMU;
import it.istat.relais.project.VariablesSchema;
import it.istat.relais.project.Summary;
import it.istat.relais.project.ReconciledSchema;

import java.awt.Color;
import java.awt.Container;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;
import javax.swing.JSlider;
import javax.swing.SwingUtilities;



public class Relais2Frame extends javax.swing.JFrame {

    VariablesSetting vs;
    Connection conn;
    CurrentStatus cs;
    MetricMatchingVariableVector mmvv;
    MatchingVariables mv;
    WaitDialog waitDialog;
    SummaryDialog sumd;
    ConfirmDialog confirm;
    ResultTable rt;
    TraceLog log;
    Summary sum;
    String orderKey;
    private final String MSGTASKBUSY = "The execution task is busy! Wait the end of current task";
    int blockNumber;
    String blockModality;
    FinalSummaryDialog fsd;
    String dataBase;
    String host;
    String user;
    String password;
    String dsaTableName;
    String dsbTableName;
    String port;
    DrawFrame dd;
    int idcs=0;
    
    
    
    public Relais2Frame() {
        initComponents();
        this.setLocation(150, 100);
        setTitle("RELAIS "+ReleaseName.release());
        Image img = java.awt.Toolkit.getDefaultToolkit().createImage("Img\\erre4.jpg");
        this.setIconImage(img);
        orderKey="key_dsa";
     //   MIGraph.setIcon(new ImageIcon("Img\\graph2.jpg"));
       // MIExit.setIcon(new ImageIcon("Img\\exit3.jpg"));
       // MIScreenClear.setIcon(new ImageIcon("Img\\clean3.jpg"));
        
        
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        outScrollPanel = new it.istat.relais.gui.OutScrollPane();
        System.setOut(outScrollPanel.getOutputStream());
        MainMenuBar = new javax.swing.JMenuBar();
        MStart = new javax.swing.JMenu();
        MINewElab = new javax.swing.JMenuItem();
        MICurrElab = new javax.swing.JMenuItem();
        MIRestartBackup = new javax.swing.JMenuItem();
        MDataset = new javax.swing.JMenu();
        MILoadFromInputFiles = new javax.swing.JMenuItem();
        MIInputFromDBOracle = new javax.swing.JMenuItem();
        MIInputFromDBMySQL = new javax.swing.JMenuItem();
        MICopyBackup = new javax.swing.JMenuItem();
        MICopyBackupUnmatch = new javax.swing.JMenuItem();
        MPreprocessing = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        MDataProfiling = new javax.swing.JMenu();
        MIGuidedSelectionBlockVar = new javax.swing.JMenuItem();
        MIGuidedSelectionMV = new javax.swing.JMenuItem();
        MSearchSpace = new javax.swing.JMenu();
        MICrossProduct = new javax.swing.JMenuItem();
        jMenu5 = new javax.swing.JMenu();
        MIUserSelectionBlockVar = new javax.swing.JMenuItem();
        MIUserSelUnionBlockVar = new javax.swing.JMenuItem();
        MIUserSelectionSortVar = new javax.swing.JMenuItem();
        MIUserSelCombBlocking = new javax.swing.JMenuItem();
        MIUserSelectionSimHash = new javax.swing.JMenuItem();
        MIUserSelBlockedSimHash = new javax.swing.JMenuItem();
        MIReadSSFromFile = new javax.swing.JMenuItem();
        MDecisionModel = new javax.swing.JMenu();
        MDeterministic = new javax.swing.JMenu();
        MIExact = new javax.swing.JMenuItem();
        MIRuleBased = new javax.swing.JMenuItem();
        MProbabilistic = new javax.swing.JMenu();
        MMatchingVariables = new javax.swing.JMenu();
        MIUserSelectionMV = new javax.swing.JMenuItem();
        MIMetricsSetting = new javax.swing.JMenuItem();
        MFellegiSunter = new javax.swing.JMenu();
        MIContingencyTable = new javax.swing.JMenuItem();
        MIEMEstimation = new javax.swing.JMenuItem();
        MFellegiSunterOneBlock = new javax.swing.JMenu();
        MIBlockSelection = new javax.swing.JMenuItem();
        MIContingencyTableOneBlock = new javax.swing.JMenuItem();
        MIEMEstimationOneBlock = new javax.swing.JMenuItem();
        MIReadMarginals = new javax.swing.JMenuItem();
        MReduction = new javax.swing.JMenu();
        MReductionSolve = new javax.swing.JMenu();
        MIReductionOtoO = new javax.swing.JMenuItem();
        MIReductionByDBActionPerformed = new javax.swing.JMenuItem();
        MIReducedContingencyTable = new javax.swing.JMenuItem();
        MResult = new javax.swing.JMenu();
        MISettingMatchThreshold = new javax.swing.JMenu();
        MIGraph = new javax.swing.JMenuItem();
        MIInsertThreshold = new javax.swing.JMenuItem();
        MOtoOResult = new javax.swing.JMenu();
        MIMatchOtoO = new javax.swing.JMenuItem();
        MIPossibleMatchOtoO = new javax.swing.JMenuItem();
        MIDSUnmatchOtoO = new javax.swing.JMenuItem();
        MIUnmatchOtoO = new javax.swing.JMenuItem();
        MClusterResult = new javax.swing.JMenu();
        MIMatchCluster = new javax.swing.JMenuItem();
        MIPossibleMatchCluster = new javax.swing.JMenuItem();
        MIDSUnmatchCluster = new javax.swing.JMenuItem();
        MIUnmatchCluster = new javax.swing.JMenuItem();
        MSave = new javax.swing.JMenu();
        jMenu6 = new javax.swing.JMenu();
        MIChooseOutputFolder = new javax.swing.JMenuItem();
        MIChangeSeparator = new javax.swing.JMenuItem();
        MIMatchFile = new javax.swing.JMenuItem();
        MIPossibleMatchFile = new javax.swing.JMenuItem();
        MIResidualDSASave = new javax.swing.JMenuItem();
        MIResidualDSBSave = new javax.swing.JMenuItem();
        MIOneTableSave = new javax.swing.JMenuItem();
        jMenu7 = new javax.swing.JMenu();
        MIResultBackup = new javax.swing.JMenuItem();
        MIFullBackup = new javax.swing.JMenuItem();
        MShowTables = new javax.swing.JMenu();
        MISelectTable = new javax.swing.JMenuItem();
        MIDeleteBackup = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        MIProcessSummaries = new javax.swing.JMenuItem();
        MIScreenClear = new javax.swing.JMenuItem();
        MIExit = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        MStart.setText("Project");

        MINewElab.setText("New Project");
        MINewElab.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MINewElabActionPerformed(evt);
            }
        });
        MStart.add(MINewElab);

        MICurrElab.setText("Open Last Project");
        MICurrElab.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MICurrElabActionPerformed(evt);
            }
        });
        MStart.add(MICurrElab);

        MIRestartBackup.setText("Open Backup");
        MIRestartBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIRestartBackupActionPerformed(evt);
            }
        });
        MStart.add(MIRestartBackup);

        MainMenuBar.add(MStart);

        MDataset.setText("Dataset");
        MDataset.setEnabled(false);

        MILoadFromInputFiles.setText("Read from Input Files");
        MILoadFromInputFiles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemSetInputFilesActionPerformed(evt);
            }
        });
        MDataset.add(MILoadFromInputFiles);

        MIInputFromDBOracle.setText("Read from DB Oracle");
        MIInputFromDBOracle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemInputFromDBOracleActionPerformed(evt);
            }
        });
        MDataset.add(MIInputFromDBOracle);

        MIInputFromDBMySQL.setText("Read from DB MySQL");
        MIInputFromDBMySQL.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemInputFromDBMySQLActionPerformed(evt);
            }
        });
        MDataset.add(MIInputFromDBMySQL);

        MICopyBackup.setText("Read from Backup");
        MICopyBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MICopyBackupActionPerformed(evt);
            }
        });
        MDataset.add(MICopyBackup);

        MICopyBackupUnmatch.setText("Read from Residual");
        MICopyBackupUnmatch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MICopyBackupUnmatchActionPerformed(evt);
            }
        });
        MDataset.add(MICopyBackupUnmatch);

        MainMenuBar.add(MDataset);

        MPreprocessing.setText("Preprocessing");
        MPreprocessing.setEnabled(false);

        jMenuItem2.setText("Check Format");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        MPreprocessing.add(jMenuItem2);

        jMenu2.setText("Conversion Functions");

        jMenuItem5.setText("Field Standardization");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuItem7.setText("Fields Merge");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem7);

        jMenuItem8.setText("Field Parse");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem8);

        jMenuItem9.setText("Inaccuracy Repair");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem9);

        MPreprocessing.add(jMenu2);

        jMenuItem3.setText("Schema Reconciliation");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        MPreprocessing.add(jMenuItem3);

        MainMenuBar.add(MPreprocessing);

        MDataProfiling.setText("Data Profiling");
        MDataProfiling.setEnabled(false);

        MIGuidedSelectionBlockVar.setText("Blocking Variables");
        MIGuidedSelectionBlockVar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIGuidedSelectionBlockVarActionPerformed(evt);
            }
        });
        MDataProfiling.add(MIGuidedSelectionBlockVar);

        MIGuidedSelectionMV.setText("Matching Variables");
        MIGuidedSelectionMV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIGuidedSelectionMVActionPerformed(evt);
            }
        });
        MDataProfiling.add(MIGuidedSelectionMV);

        MainMenuBar.add(MDataProfiling);

        MSearchSpace.setText("Search Space Creation");
        MSearchSpace.setEnabled(false);

        MICrossProduct.setText("Cross Product");
        MICrossProduct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MICrossProductActionPerformed(evt);
            }
        });
        MSearchSpace.add(MICrossProduct);

        jMenu5.setText("Search Space Reduction");

        MIUserSelectionBlockVar.setText("Blocking");
        MIUserSelectionBlockVar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelectionBlockVarActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelectionBlockVar);

        MIUserSelUnionBlockVar.setText("Blocking Union");
        MIUserSelUnionBlockVar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelUnionBlockVarActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelUnionBlockVar);

        MIUserSelectionSortVar.setText("Sorted Neighborhood");
        MIUserSelectionSortVar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelectionSortVarActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelectionSortVar);

        MIUserSelCombBlocking.setText("Nested Blocking");
        MIUserSelCombBlocking.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelCombBlockingActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelCombBlocking);

        MIUserSelectionSimHash.setText("SimHash");
        MIUserSelectionSimHash.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelectionSimHashActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelectionSimHash);

        MIUserSelBlockedSimHash.setText("Blocked SimHash");
        MIUserSelBlockedSimHash.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelBlockedSimHashActionPerformed(evt);
            }
        });
        jMenu5.add(MIUserSelBlockedSimHash);

        MSearchSpace.add(jMenu5);

        MIReadSSFromFile.setText("Read From External File");
        MIReadSSFromFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIReadSSFromFileActionPerformed(evt);
            }
        });
        MSearchSpace.add(MIReadSSFromFile);

        MainMenuBar.add(MSearchSpace);

        MDecisionModel.setText("Decision Model");
        MDecisionModel.setEnabled(false);

        MDeterministic.setText("Deterministic");

        MIExact.setText("Equality Match");
        MIExact.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIExactActionPerformed(evt);
            }
        });
        MDeterministic.add(MIExact);

        MIRuleBased.setText("Rule Based");
        MIRuleBased.setEnabled(false);
        MIRuleBased.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIRuleBasedActionPerformed(evt);
            }
        });
        MDeterministic.add(MIRuleBased);

        MDecisionModel.add(MDeterministic);

        MProbabilistic.setText("Probabilistic");
        MProbabilistic.setEnabled(false);

        MMatchingVariables.setText("Matching Variables");

        MIUserSelectionMV.setText("Variables Selection");
        MIUserSelectionMV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUserSelectionMVActionPerformed(evt);
            }
        });
        MMatchingVariables.add(MIUserSelectionMV);

        MIMetricsSetting.setText("Metrics and Thresholds Setting");
        MIMetricsSetting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIMetricsSettingActionPerformed(evt);
            }
        });
        MMatchingVariables.add(MIMetricsSetting);

        MProbabilistic.add(MMatchingVariables);

        MFellegiSunter.setText("Fellegi-Sunter");
        MFellegiSunter.setEnabled(false);

        MIContingencyTable.setText("Contingency Table");
        MIContingencyTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIContingencyTableActionPerformed(evt);
            }
        });
        MFellegiSunter.add(MIContingencyTable);

        MIEMEstimation.setText("EM Estimation");
        MIEMEstimation.setEnabled(false);
        MIEMEstimation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIEMEstimationActionPerformed(evt);
            }
        });
        MFellegiSunter.add(MIEMEstimation);

        MProbabilistic.add(MFellegiSunter);

        MFellegiSunterOneBlock.setText("Fellegi-Sunter One Block");
        MFellegiSunterOneBlock.setEnabled(false);
        MFellegiSunterOneBlock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MFellegiSunterOneBlockActionPerformed(evt);
            }
        });

        MIBlockSelection.setText("Block Selection");
        MIBlockSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIBlockSelectionActionPerformed(evt);
            }
        });
        MFellegiSunterOneBlock.add(MIBlockSelection);

        MIContingencyTableOneBlock.setText("Contingency Table");
        MIContingencyTableOneBlock.setEnabled(false);
        MIContingencyTableOneBlock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIContingencyTableOneBlockActionPerformed(evt);
            }
        });
        MFellegiSunterOneBlock.add(MIContingencyTableOneBlock);

        MIEMEstimationOneBlock.setText("EM Estimation");
        MIEMEstimationOneBlock.setEnabled(false);
        MIEMEstimationOneBlock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIEMEstimationOneBlockActionPerformed(evt);
            }
        });
        MFellegiSunterOneBlock.add(MIEMEstimationOneBlock);

        MProbabilistic.add(MFellegiSunterOneBlock);

        MIReadMarginals.setText("Read Marginals from File");
        MIReadMarginals.setEnabled(false);
        MIReadMarginals.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIReadMarginalsActionPerformed(evt);
            }
        });
        MProbabilistic.add(MIReadMarginals);

        MDecisionModel.add(MProbabilistic);

        MainMenuBar.add(MDecisionModel);

        MReduction.setText("Linkage 1:1");
        MReduction.setEnabled(false);
        MReduction.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MReductionActionPerformed(evt);
            }
        });

        MReductionSolve.setText("Reduction to 1:1");

        MIReductionOtoO.setText("Optimal Solution");
        MIReductionOtoO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIReductionOtoOActionPerformed(evt);
            }
        });
        MReductionSolve.add(MIReductionOtoO);

        MIReductionByDBActionPerformed.setText("Greedy Solution");
        MIReductionByDBActionPerformed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIReductionByDBActionPerformedActionPerformed(evt);
            }
        });
        MReductionSolve.add(MIReductionByDBActionPerformed);

        MReduction.add(MReductionSolve);

        MIReducedContingencyTable.setText("Reduced Contingency Table");
        MIReducedContingencyTable.setEnabled(false);
        MIReducedContingencyTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIReducedContingencyTableActionPerformed(evt);
            }
        });
        MReduction.add(MIReducedContingencyTable);

        MainMenuBar.add(MReduction);

        MResult.setText("Linkage Result");
        MResult.setEnabled(false);
        MResult.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MResultActionPerformed(evt);
            }
        });

        MISettingMatchThreshold.setText("Threshold");
        MISettingMatchThreshold.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MISettingMatchThresholdActionPerformed(evt);
            }
        });

        MIGraph.setText("Choose by a Graphic");
        MIGraph.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIGraphActionPerformed(evt);
            }
        });
        MISettingMatchThreshold.add(MIGraph);

        MIInsertThreshold.setText("Just insert Threshold");
        MIInsertThreshold.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIInsertThresholdActionPerformed(evt);
            }
        });
        MISettingMatchThreshold.add(MIInsertThreshold);

        MResult.add(MISettingMatchThreshold);

        MOtoOResult.setText("1:1 Result");
        MOtoOResult.setEnabled(false);

        MIMatchOtoO.setText("Match");
        MIMatchOtoO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIMatchOtoOActionPerformed(evt);
            }
        });
        MOtoOResult.add(MIMatchOtoO);

        MIPossibleMatchOtoO.setText("Possible Match");
        MIPossibleMatchOtoO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIPossibleMatchOtoOActionPerformed(evt);
            }
        });
        MOtoOResult.add(MIPossibleMatchOtoO);

        MIDSUnmatchOtoO.setText("Residual Dataset");
        MIDSUnmatchOtoO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIDSUnmatchOtoOActionPerformed(evt);
            }
        });
        MOtoOResult.add(MIDSUnmatchOtoO);

        MIUnmatchOtoO.setText("Unmatch");
        MIUnmatchOtoO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUnmatchOtoOActionPerformed(evt);
            }
        });
        MOtoOResult.add(MIUnmatchOtoO);

        MResult.add(MOtoOResult);

        MClusterResult.setText("Cluster Result");

        MIMatchCluster.setText("Match");
        MIMatchCluster.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIMatchClusterActionPerformed(evt);
            }
        });
        MClusterResult.add(MIMatchCluster);

        MIPossibleMatchCluster.setText("Possible Match");
        MIPossibleMatchCluster.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIPossibleMatchClusterActionPerformed(evt);
            }
        });
        MClusterResult.add(MIPossibleMatchCluster);

        MIDSUnmatchCluster.setText("Residual Dataset");
        MIDSUnmatchCluster.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIDSUnmatchClusterActionPerformed(evt);
            }
        });
        MClusterResult.add(MIDSUnmatchCluster);

        MIUnmatchCluster.setText("Unmatch");
        MIUnmatchCluster.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIUnmatchClusterActionPerformed(evt);
            }
        });
        MClusterResult.add(MIUnmatchCluster);

        MResult.add(MClusterResult);

        MainMenuBar.add(MResult);

        MSave.setText("Save");
        MSave.setEnabled(false);

        jMenu6.setText("To file");

        MIChooseOutputFolder.setText("Choose Output Folder");
        MIChooseOutputFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuItemSetOutputDirActionPerformed(evt);
            }
        });
        jMenu6.add(MIChooseOutputFolder);

        MIChangeSeparator.setText("Change Field Separator");
        MIChangeSeparator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIChangeSeparatorActionPerformed(evt);
            }
        });
        jMenu6.add(MIChangeSeparator);

        MIMatchFile.setText("Match File");
        MIMatchFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIMatchFileActionPerformed(evt);
            }
        });
        jMenu6.add(MIMatchFile);

        MIPossibleMatchFile.setText("Possible Match File");
        MIPossibleMatchFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIPossibleMatchFileActionPerformed(evt);
            }
        });
        jMenu6.add(MIPossibleMatchFile);

        MIResidualDSASave.setText("Residual Dataset A");
        MIResidualDSASave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIResidualDSASaveActionPerformed(evt);
            }
        });
        jMenu6.add(MIResidualDSASave);

        MIResidualDSBSave.setText("Residual Dataset B");
        MIResidualDSBSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIResidualDSBSaveActionPerformed(evt);
            }
        });
        jMenu6.add(MIResidualDSBSave);

        MIOneTableSave.setText("Table Selection");
        MIOneTableSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIOneTableSaveActionPerformed(evt);
            }
        });
        jMenu6.add(MIOneTableSave);

        MSave.add(jMenu6);

        jMenu7.setText("Backup");

        MIResultBackup.setText("Create Result Backup");
        MIResultBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIResultBackupActionPerformed(evt);
            }
        });
        jMenu7.add(MIResultBackup);

        MIFullBackup.setText("Create Full Backup");
        MIFullBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIFullBackupActionPerformed(evt);
            }
        });
        jMenu7.add(MIFullBackup);

        MSave.add(jMenu7);

        MainMenuBar.add(MSave);

        MShowTables.setText("Utility");

        MISelectTable.setText("Table Display");
        MISelectTable.setEnabled(false);
        MISelectTable.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MISelectTableActionPerformed(evt);
            }
        });
        MShowTables.add(MISelectTable);

        MIDeleteBackup.setText("Delete Backup");
        MIDeleteBackup.setEnabled(false);
        MIDeleteBackup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIDeleteBackupActionPerformed(evt);
            }
        });
        MShowTables.add(MIDeleteBackup);

        jMenuItem1.setText("Change Output Order Key");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        MShowTables.add(jMenuItem1);

        MIProcessSummaries.setText("Process Summaries");
        MIProcessSummaries.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIProcessSummariesActionPerformed(evt);
            }
        });
        MShowTables.add(MIProcessSummaries);

        MIScreenClear.setText("Screen Clear");
        MIScreenClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIScreenClearActionPerformed(evt);
            }
        });
        MShowTables.add(MIScreenClear);

        MIExit.setText("Exit");
        MIExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIExitActionPerformed(evt);
            }
        });
        MShowTables.add(MIExit);

        MainMenuBar.add(MShowTables);

        setJMenuBar(MainMenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(outScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 923, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(outScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 614, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void MenuItemSetOutputDirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemSetOutputDirActionPerformed

  ReadOutputFolder rof = new ReadOutputFolder(this,true);
  String folder = vs.ReadOutputFolder();
  if (folder != null && !folder.equals(""))
      rof.setOutputFolderDefault(folder);
  rof.setVisible(true);
  if (rof.getReturnStatus()==ReadOutputFolder.RET_OK) {
    String choosedOutputFolder = rof.getChoosedOutputFolder();
    if (!choosedOutputFolder.equals("")) {
        try {
            log.AddMessage("Output directory selected: "+choosedOutputFolder);
        } catch (Exception e) {}
        idcs=cs.Insert("COF", "Setting Output Folder");
        vs.UpdateOutputFolder("'"+choosedOutputFolder+"'");
        MDataset.setEnabled(true);
        cs.UpdateStatus(idcs, "Successfully terminated");
    }
    else
        System.out.println("Output directory not selected!");
  }
 
}//GEN-LAST:event_MenuItemSetOutputDirActionPerformed

private void MenuItemSetInputFilesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemSetInputFilesActionPerformed
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  ReadInputFiles rif = new ReadInputFiles(this,true);
  rif.setVisible(true);
  if (rif.getReturnStatus()==ReadInputFiles.RET_OK) {
      
    idcs=cs.Insert("LDS", "Load Dataset from input files");
    String dsaFile = rif.getFileNameA();
    String dsaSep = rif.getSeparatorA();
    String dsbFile = null;
    String dsbSep = null;

    if(rif.getDeduplication()) {
        vs.UpdateProjectType("Deduplication");
        dsbFile = rif.getFileNameA();
        dsbSep = rif.getSeparatorA();
    } else {
        vs.UpdateProjectType("Linkage");
        dsbFile = rif.getFileNameB();
        dsbSep = rif.getSeparatorB();
    }
    
    vs.UpdateSeparator(dsaSep);
    System.out.println("Loading files in progress ...");
    LoadFromFileTask lfTask = new LoadFromFileTask(conn,dsaFile, dsaSep, dsbFile, dsbSep);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Load Dataset Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new LoadDatasetMediator().startTask(lfTask);
  }
}//GEN-LAST:event_MenuItemSetInputFilesActionPerformed

private void MICurrElabActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MICurrElabActionPerformed
  System.out.println("Connection to database...");
  try {
      Class.forName("com.mysql.jdbc.Driver");
  } catch (ClassNotFoundException e) {
      e.printStackTrace();
  }

  try {
      conn = DBConfiguration.getConnection();
      vs = new VariablesSetting(conn);
      cs = new CurrentStatus(conn);
      mmvv = new MetricMatchingVariableVector();
      log = new TraceLog(conn);
      sum = new Summary(conn);
      sumd = new SummaryDialog(this,false);

      if (!cs.Exists()) {
          AllertDialog all = new AllertDialog(this,true,"No project to open. New options are needed!");
          return;
      }
      log.AddMessage("Connection started");
      cs.CloseInProgress();
      boolean existsCurr = cs.Read();
      if (existsCurr) {
          System.out.println("Last transaction executed:");
          System.out.println(cs.getLastTransaction());
      }

      MDataset.setEnabled(true);
      MSave.setEnabled(true);
      MISelectTable.setEnabled(true);
      MIDeleteBackup.setEnabled(true);
      
      if (cs.isTerminated("LDS")) {
          MSearchSpace.setEnabled(true);
          MDecisionModel.setEnabled(true); 
          MDataProfiling.setEnabled(true);
          MPreprocessing.setEnabled(true);
      }
      if (cs.isTerminated("SSC")) {
          MProbabilistic.setEnabled(true);
          MIRuleBased.setEnabled(true);
      }
      if (cs.isTerminated("SMV")) {
          mv = new MatchingVariables(conn, mmvv);
          mmvv = mv.getMetricMatchingVariableVector();       
      }
 /*
  if (cs.isTerminated("SMV")) MDecisionModel.setEnabled(true);//GEN-LAST:event_MICurrElabActionPerformed
*/
      if (cs.isTerminated("SMV")) {
          MFellegiSunter.setEnabled(true);
          if (vs.ReadMethod().endsWith("Blocking")) MFellegiSunterOneBlock.setEnabled(true);
      }
      if (cs.isTerminated("ECT")) {
          MIEMEstimation.setEnabled(true);
          MIReadMarginals.setEnabled(true);
      }
      if (cs.isTerminated("DET")) {
          if (vs.ReadModel().equals("Deterministic")) {
              MReduction.setEnabled(true);
              MResult.setEnabled(true);
              MISettingMatchThreshold.setEnabled(false);
          }          
      }
      if (cs.isTerminated("MOD")) {
          MReduction.setEnabled(true);
          MResult.setEnabled(true);
          MISettingMatchThreshold.setEnabled(true);
      }
      if (cs.isTerminated("RED")) {
          MIReducedContingencyTable.setEnabled(true);
          MOtoOResult.setEnabled(true);
      }
      } catch (Exception ex) {
          System.out.println(ex.getMessage());
      }
      /*MISettingMatchThreshold.setEnabled(true);*/
}                                          

private void MINewElabActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MINewElabActionPerformed
  
  Connection conn1 = DBConfiguration.getConnection();
  CurrentStatus cs1 = new CurrentStatus(conn1);

  if (cs1.Exists() && cs1.Read()) {
      confirm = new ConfirmDialog(this,true,"Using New project option all current data will be lost!");
      if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
        return;
      
      confirm.dispose();
  }
  
  try {
      Class.forName("com.mysql.jdbc.Driver");
  } catch (ClassNotFoundException e) {
      e.printStackTrace();
  }
  
  try {
      conn = DBConfiguration.getConnection();
      vs = new VariablesSetting(conn);
      cs = new CurrentStatus(conn);
      mmvv = new MetricMatchingVariableVector();
      log = new TraceLog(conn);

      System.out.println("Database will be initialized...");
      ExportToDb.startElab(conn,"relais");
      vs.InitialSettingVariables();
      cs.CreateStatus();
      sum = new Summary(conn);
      sumd = new SummaryDialog(this,true);
      log.AddMessage("System is ready");
      MDataset.setEnabled(true);
      MSave.setEnabled(true);
      MISelectTable.setEnabled(true);
      MIDeleteBackup.setEnabled(true);
      MSearchSpace.setEnabled(false);
      MDecisionModel.setEnabled(false);
      MProbabilistic.setEnabled(false);
      MFellegiSunter.setEnabled(false);
      MFellegiSunterOneBlock.setEnabled(false);
      MIRuleBased.setEnabled(false);
      MIEMEstimation.setEnabled(false);
      MIReadMarginals.setEnabled(false);
      MIEMEstimationOneBlock.setEnabled(false);
      MIContingencyTableOneBlock.setEnabled(false);   
      MReduction.setEnabled(false);
      MDataProfiling.setEnabled(false);
      MPreprocessing.setEnabled(false);
      MResult.setEnabled(false);
      MIReducedContingencyTable.setEnabled(false);
      MOtoOResult.setEnabled(false);
      MISettingMatchThreshold.setEnabled(true);
    
  } catch (Exception ex) {
          System.out.println(ex.getMessage());
  }
  
}//GEN-LAST:event_MINewElabActionPerformed

private void MICopyBackupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MICopyBackupActionPerformed
   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
   DefaultComboBoxModel bklist = ExportToDb.BackUpList(conn, null, TablesName.nameDsa());
   if (bklist==null) {
       new AllertDialog(this,true,"There is no internal backup");
       return;
   }
   SelectBackup sbk=new SelectBackup(this,true,bklist);
   sbk.setVisible(true);
   if (sbk.getReturnStatus()==SelectBackup.RET_OK) {
       String dbBackup=sbk.getSelectedBackUp();
       if (dbBackup!=null && !dbBackup.equals("")) {
            System.out.println("Start copy dataset from '"+dbBackup+"' backup");
            idcs=cs.Insert("LDS", "Load Dataset from backup: "+dbBackup);
            CopyFromBackupTask cbTask = new CopyFromBackupTask(conn,dbBackup,"DATASET");
                waitDialog = new WaitDialog(this);
                waitDialog.setTitle("Load Dataset Task");
                waitDialog.setModal(false);
                waitDialog.setVisible(true);
        
            new LoadDatasetMediator().startTask(cbTask);
       }
       else

           System.out.println("The backup copy is not selected");
            }
}//GEN-LAST:event_MICopyBackupActionPerformed

private void MICrossProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MICrossProductActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }

    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created by "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    System.out.println("Search space creation via cross product...");
    idcs=cs.Insert("SSC", "Search space creation via cross product");
    SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Search Space Creation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new SearchSpaceMediator().startTask(sscTask);
  
}//GEN-LAST:event_MICrossProductActionPerformed

private void MIUserSelectionBlockVarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelectionBlockVarActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created by "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Blocking key: ");
    chv.setTitle("Select blocking key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Blocking key not selected");
        } else {
            String varblock = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
            
            System.out.println("Blocking key selected: "+varblock);
            vs.UpdateBlockVar(varblock);

            System.out.println("Search space reduction via blocking ...");
            idcs=cs.Insert("SSC", "Search space creation reduced via blocking");
            SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock);
            waitDialog = new WaitDialog(this);
            waitDialog.setTitle("Search Space Creation Task");
            waitDialog.setModal(false);
            waitDialog.setVisible(true);

            new SearchSpaceMediator().startTask(sscTask);
        }
    }
}//GEN-LAST:event_MIUserSelectionBlockVarActionPerformed

private void MIUserSelectionMVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelectionMVActionPerformed
    
    if (cs.isTerminated("MODOB") || cs.isTerminated("MOD")) {
      confirm = new ConfirmDialog(this,true,"Changing the matching variables current estimates will be lost!");
      if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
        return;
      
      try{
          RemoveMU rem=new RemoveMU(conn);
          rem.Remove();
      } catch (Exception e) {}
      
      confirm.dispose();
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Chosen variables: ");
    chv.setTitle("Select matching variables");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varlist = chv.getChosenItems();
        if (varlist.length < 1) {
            System.out.println("Matching variables not selected");
        } else {
            System.out.println("Matching variables selected: ");
            
            String matchvar;
            MetricMatchingVariable mmvAppo;
            mmvv.clear();
            
            for (int numvar=0; numvar<varlist.length;numvar++) {
                matchvar = (String) varlist[numvar];
                System.out.println(" "+(numvar+1)+") "+matchvar);
                mmvAppo = new MetricMatchingVariable();
                mmvAppo.setMatchingVariable(matchvar);
                mmvv.addElement(mmvAppo);
            }
            MFellegiSunter.setEnabled(false);
            MFellegiSunterOneBlock.setEnabled(false);
        }
    }
}//GEN-LAST:event_MIUserSelectionMVActionPerformed

private void MIMetricsSettingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIMetricsSettingActionPerformed
    ReadDistanceThreshold rdt = new ReadDistanceThreshold(this,true);
    int dimMM = mmvv.size();
    int currMM=0;
    MetricMatchingVariable mmvAppo;
            
    while (currMM<dimMM) {
        mmvAppo = mmvv.get(currMM);
        rdt.setMatchingVariable(mmvAppo);
        rdt.setVisible(true);
        if (rdt.getReturnStatus()==ReadDistanceThreshold.RET_OK) {
            mmvAppo = rdt.getMatchingVariable();
            try {
                log.AddMessage("Matching variable "+mmvAppo.getMatchingVariable()+": chosen distance "+mmvAppo.getComparisonFunction()+", threshold "+mmvAppo.getMetricThreshold()+" and window size "+mmvAppo.getWindowSize());
            } catch (Exception ex) {}
            mmvv.set(currMM, mmvAppo);
            currMM++;
        }
        else if (rdt.getReturnStatus()==ReadDistanceThreshold.RET_CANCEL) {
            break;
        }
    }
    
    if (dimMM==0) {
        new AllertDialog(this,true,"Matching varables not selected");
    } else if (currMM>=dimMM) {
        mv = new MatchingVariables(conn, mmvv);
        mv.CreateMatchingVariablesTable();
        mv.UpdateMatchingVariableTable(mmvv);
        idcs=cs.Insert("SMV", "Setting matching variables");
        cs.UpdateStatus(idcs, "Successfully terminated");
        MFellegiSunter.setEnabled(true);
        if (vs.ReadMethod().endsWith("Blocking")) MFellegiSunterOneBlock.setEnabled(true);
        try {
                log.AddMessage("Setting matching variables done");
            } catch (Exception ex) {}
    } else {
        System.out.println("Setting matching variables not complete...");
    }
        
}//GEN-LAST:event_MIMetricsSettingActionPerformed

private void MIContingencyTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIContingencyTableActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (mv.getNumMatchingVariables()<3) {
        new AllertDialog(this,true,"Fellegi-Sunter method needs at least 3 matching variables");
        return;
    }
    String method = vs.ReadMethod();
    vs.UpdateModel("Fellegi-Sunter");
    ContingencyTableTask ctTask = new ContingencyTableTask(conn,method);
    System.out.println("INFO: Pattern update task can take some minutes");
    System.out.println("Contingency table evaluation ...");
    idcs=cs.Insert("ECT", "Contingency table evaluation");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Pattern update Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
     sum.Insert(25, "Decisional Model", 0, "Fellegi-Sunter");    
       
    new ResultTableMediator().startTask(ctTask);
}//GEN-LAST:event_MIContingencyTableActionPerformed

private void MIEMEstimationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIEMEstimationActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    String method = vs.ReadMethod();
    EMEstimationTask emTask = new EMEstimationTask(conn,method);
    idcs=cs.Insert("MOD", "Estimation of the model using the Fellegi Sunter method");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("EM estimation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new EMEstimationMediator().startTask(emTask);
}//GEN-LAST:event_MIEMEstimationActionPerformed

private void MIScreenClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIScreenClearActionPerformed
    outScrollPanel.clearAll();

}//GEN-LAST:event_MIScreenClearActionPerformed

private void MIReductionOtoOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIReductionOtoOActionPerformed
   sum.Insert(35, "Reduction 1:1 Method", 0, "Optimal");
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (vs.ReadModel().equals("Deterministic")) {
    WeightDialog wei = new WeightDialog(this,true,conn);
    wei.setVisible(true);
    if (wei.getReturnStatus()!=WeightDialog.RET_OK) return;
    }
    System.out.println("Reduction to one to one linkage ...");
    ReductionOToOTask reTask = new ReductionOToOTask(conn,"LP");
    idcs=cs.Insert("RED", "Reduction to 1:1 linkage");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Reduction 1:1 Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);

    new ReductionOtoOMediator().startTask(reTask);
}//GEN-LAST:event_MIReductionOtoOActionPerformed

private void MIReductionByDBActionPerformed(java.awt.event.ActionEvent evt) {                                                
    sum.Insert(35, "Reduction 1:1 Method", 0, "Greedy");
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (vs.ReadModel().equals("Deterministic")) {
    WeightDialog wei = new WeightDialog(this,true,conn);
    wei.setVisible(true);
    if (wei.getReturnStatus()!=WeightDialog.RET_OK) return;
    }
    System.out.println("Reduction to one to one linkage...");
    ReductionOToOTask reTask = new ReductionOToOTask(conn,"ByDB");
    idcs=cs.Insert("RED", "Reduction to 1:1 linkage by sorting");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Reduction 1:1 Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);

    new ReductionOtoOMediator().startTask(reTask);
    
}   

private void MReductionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MReductionActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_MReductionActionPerformed

private void MIReducedContingencyTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIReducedContingencyTableActionPerformed
    String method = vs.ReadMethod();
    System.out.println("Evaluating reduced contingency table ...");
    ReducedContingencyTableTask rcTask = new ReducedContingencyTableTask(conn,method);
    idcs=cs.Insert("RCT", "Evaluating reduced contingency table (1:1)");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Reduced contingency table Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new ReducedContingencyTableMediator().startTask(rcTask);
}//GEN-LAST:event_MIReducedContingencyTableActionPerformed

private void MResultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MResultActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_MResultActionPerformed

private void MIInsertThresholdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIInsertThresholdActionPerformed
    SelectMThreshold smt = new SelectMThreshold(this,true);
           /* default value for match/unmatch thresholds */
            double mtr = vs.ReadThresholdM();
            double utr = vs.ReadThresholdU();
            
            if (mtr>=0 && utr>=0) {
                smt.setDefaultThresholds(mtr, utr);
            } else {
                smt.setDefaultThresholds(0.95, 0.5);
            }
            smt.setVisible(true);
            
            if (smt.getReturnStatus()==SelectMThreshold.RET_OK) {
                double mThreshold = smt.getMatchThreshold();
                double uThreshold = smt.getPossibleMatchThreshold();
                
                vs.UpdateThresholdM(mThreshold);
                vs.UpdateThresholdU(uThreshold);
                try {
                log.AddMessage("Thresholds chosen");
                log.AddMessage(" unmatch threshold: "+uThreshold);
                log.AddMessage(" match threshold: "+mThreshold);
                } catch (Exception e) {}
                idcs=cs.Insert("SMT", "Setting match threshold");
                cs.UpdateStatus(idcs, "Successfully terminated");
            }
            sum.Insert(38, "Threshold Unmatch", vs.ReadThresholdU(), "");
            sum.Insert(39, "Threshold Match", vs.ReadThresholdM(), "");
            
}//GEN-LAST:event_MIInsertThresholdActionPerformed

private void MIExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIExitActionPerformed
    try {
        if (cs.isInProgress()) {
            System.out.println("Execution in progress! Wait the end of execution task before exiting");
            return;
        }
        log.AddMessage("Exit RELAIS","I",false);
        this.dispose();
    } catch (Exception ex) {
        this.dispose();
    }
}//GEN-LAST:event_MIExitActionPerformed

private void MISelectTableActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MISelectTableActionPerformed
   DefaultComboBoxModel bklist = DisplayTable.tableList(conn, "RELAIS");
   SelectTable stb=new SelectTable(this,true,bklist);
   stb.setVisible(true);
   if (stb.getReturnStatus()==ReadInputFiles.RET_OK) {
       String tableShow=stb.getSelectedTable();
       if (tableShow!=null && !tableShow.equals("")) {
           System.out.println("Display data from table "+tableShow+" ...");
           DisplayTable dtTask = new DisplayTable(conn, tableShow);
          }
   }
}//GEN-LAST:event_MISelectTableActionPerformed

private void MICopyBackupUnmatchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MICopyBackupUnmatchActionPerformed
   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
   DefaultComboBoxModel bklist = ExportToDb.BackUpList(conn, null,TablesName.nameResidualDsa());
   if (bklist==null) {
       new AllertDialog(this,true,"Does not exist any backup with dataset residual");
       return;
   }
   SelectBackup sbk=new SelectBackup(this,true,bklist);
   sbk.setVisible(true);
   if (sbk.getReturnStatus()==ReadInputFiles.RET_OK) {
       String dbBackup=sbk.getSelectedBackUp();
       if (dbBackup!=null && !dbBackup.equals("")) {
            System.out.println("Start copy dataset from residual of '"+dbBackup+"' backup");
            idcs=cs.Insert("LDS", "Copy Dataset from residual of backup: "+dbBackup);
            CopyFromBackupTask cbTask = new CopyFromBackupTask(conn,dbBackup,"RESIDUAL");
                waitDialog = new WaitDialog(this);
                waitDialog.setTitle("Load Dataset Task");
                waitDialog.setModal(false);
                waitDialog.setVisible(true);
        
            new LoadDatasetMediator().startTask(cbTask);
       }
       else
           System.out.println("Backup copy is not selected!");
   }
}//GEN-LAST:event_MICopyBackupUnmatchActionPerformed

private void MIMatchOtoOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIMatchOtoOActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CMT", "Creation of match tables (linkage 1:1)");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"match","1:1",orderKey);
    System.out.println("Evaluating match ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    sumd.setMessage("match");
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIMatchOtoOActionPerformed

private void MIDSUnmatchOtoOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIDSUnmatchOtoOActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("CMT")) {
        AllertDialog all = new AllertDialog(this,true,"For the evaluation of residuals the match results are required!");
        return;
    }
    idcs=cs.Insert("CRT", "Creation of data set residual tables (linkage 1:1)");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"residual","1:1",orderKey);
    System.out.println("Evaluating data set residual ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIDSUnmatchOtoOActionPerformed

private void MIUnmatchOtoOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUnmatchOtoOActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CUT", "Creating unmatch tables (linkage 1:1)");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"unmatch","1:1",orderKey);
    System.out.println("Evaluating unmatch ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
     sumd.setMessage("unmatch");
        new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIUnmatchOtoOActionPerformed

private void MIMatchClusterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIMatchClusterActionPerformed
        if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CMT", "Creating match tables");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"match", orderKey);
    System.out.println("Evaluating match ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    sumd.setMessage("match");
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIMatchClusterActionPerformed

private void MIDSUnmatchClusterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIDSUnmatchClusterActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("CMT")) {
        AllertDialog all = new AllertDialog(this,true,"For the evaluation of residuals the match results are required!");
        return;
    }
    idcs=cs.Insert("CRT", "Creating data set residual tables");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"residual", orderKey);
    System.out.println("Evaluating data set residual ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIDSUnmatchClusterActionPerformed

private void MIUnmatchClusterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUnmatchClusterActionPerformed
        if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CUT", "Creating unmatch tables");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"unmatch", orderKey);
    sumd.setMessage("unmatch");
    System.out.println("Evaluating unmatch ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIUnmatchClusterActionPerformed

private void MIDeleteBackupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIDeleteBackupActionPerformed
    DefaultComboBoxModel bklist = ExportToDb.BackUpList(conn, null, TablesName.nameSetting());
   if (bklist==null) {
       System.out.println("WARNING: Does not exist internal backup.");
       return;
   }
   SelectBackup sbk=new SelectBackup(this,true,bklist);
   sbk.setTitle("Delete backup");
   sbk.setTextOkButton("Delete");
   sbk.setVisible(true);
   if (sbk.getReturnStatus()==ReadInputFiles.RET_OK) {
       String dbBackup=sbk.getSelectedBackUp();
       if (dbBackup!=null && !dbBackup.equals("")) {
            BackupRestoreTask brTask = new BackupRestoreTask(conn,dbBackup,"delete","nomodal");
            System.out.println("Deleting backup "+dbBackup+" ...");
            waitDialog = new WaitDialog(this);
            waitDialog.setTitle("Delete backup Task");
            waitDialog.setModal(false);
            waitDialog.setVisible(true);
            new GeneralMediator().startTask(brTask);
       }
   }
}//GEN-LAST:event_MIDeleteBackupActionPerformed

private void MIResultBackupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIResultBackupActionPerformed
    String bkname;
    confirm = new ConfirmDialog(this,true,"Result backup cannot be used to restore elaboration.");
    if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
        return;
    
    confirm.dispose();
    InputName inm = new InputName(this,true);
    inm.setVisible(true);
           
    if (inm.getReturnStatus()==SelectSize.RET_OK) {
        bkname = inm.getInputedName();
        if (bkname != null && !bkname.equals("")) {
            if (!ExportToDb.existsBackUp(conn, bkname)) {
                BackupRestoreTask brTask = new BackupRestoreTask(conn,bkname,"backup","result");
                System.out.println("Creating result backup "+bkname+" ...");
                waitDialog = new WaitDialog(this);
                waitDialog.setTitle("Create backup Task");
                waitDialog.setModal(false);
                waitDialog.setVisible(true);
                new GeneralMediator().startTask(brTask);
            } else {
                System.out.println("WARNING: Backup name "+bkname+" is not available");
            }
        }

    }
}//GEN-LAST:event_MIResultBackupActionPerformed

private void MIFullBackupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIFullBackupActionPerformed
    String bkname;
    InputName inm = new InputName(this,true);
    inm.setVisible(true);
            
    if (inm.getReturnStatus()==SelectSize.RET_OK) {
        bkname = inm.getInputedName();
        if (bkname != null && !bkname.equals("")) {
            if (!ExportToDb.existsBackUp(conn, bkname)) {
                BackupRestoreTask brTask = new BackupRestoreTask(conn,bkname,"backup","full");
                System.out.println("Creating full backup "+bkname+" ...");
                waitDialog = new WaitDialog(this);
                waitDialog.setTitle("Create backup Task");
                waitDialog.setModal(false);
                waitDialog.setVisible(true);
                new GeneralMediator().startTask(brTask);
            } else {
                System.out.println("WARNING: Backup name "+bkname+" is not available");
            }
        }

    }
}//GEN-LAST:event_MIFullBackupActionPerformed

private void MIMatchFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIMatchFileActionPerformed
    if (!cs.isTerminated("CMT")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the creation of match results is required!");
        return;
    }
    if (!cs.isTerminated("COF")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the choice of the output folder is required!");
        return;
    }
    String folder = vs.ReadOutputFolder();
    ExportToFileTask efTask = new ExportToFileTask(conn,folder,"Match");
    System.out.println("Saving match result to file "+folder+"\\Match.txt ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Save Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ExportFileMediator().startTask(efTask);

}//GEN-LAST:event_MIMatchFileActionPerformed

private void MIPossibleMatchFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIPossibleMatchFileActionPerformed
    if (!cs.isTerminated("CPT")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the creation of possible match result is required!");
        return;
    }
    if (!cs.isTerminated("COF")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the choice of the output folder is required!");
        return;
    }
    String folder = vs.ReadOutputFolder();
    ExportToFileTask efTask = new ExportToFileTask(conn,folder,"PossibleMatch");
    System.out.println("Saving possiblematch result to file "+folder+"\\PossibleMatch.txt ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Save Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ExportFileMediator().startTask(efTask);

}//GEN-LAST:event_MIPossibleMatchFileActionPerformed

private void MIOneTableSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIOneTableSaveActionPerformed
    if (!cs.isTerminated("COF")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the choice of the output folder is required!");
        return;
    }
    try {
       String folder = vs.ReadOutputFolder();
       DefaultComboBoxModel bklist = DisplayTable.tableList(conn, "RELAIS");
       SelectTable stb=new SelectTable(this,true,bklist);
       stb.setLabelOkButton("Export");
       stb.setVisible(true);
       if (stb.getReturnStatus()==ReadInputFiles.RET_OK) {
           String tableShow=stb.getSelectedTable();
           if (tableShow!=null && !tableShow.equals("")) {
                ExportToFileTask efTask = new ExportToFileTask(conn,folder,tableShow);
                System.out.println("Saving "+tableShow+" table to file "+folder+"\\"+tableShow+".txt");
                    waitDialog = new WaitDialog(this);
                    waitDialog.setTitle("Save Task");
                    waitDialog.setModal(false);
                    waitDialog.setVisible(true);
                new ExportFileMediator().startTask(efTask);
            }
        }
    } catch(Exception ex) {
        System.out.println(ex.getMessage());
    }
}//GEN-LAST:event_MIOneTableSaveActionPerformed

private void MIPossibleMatchOtoOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIPossibleMatchOtoOActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CPT", "Creation of possiblematch tables (linkage 1:1)");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"possiblematch","1:1",orderKey);
    System.out.println("Evaluating possiblematch ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    sumd.setMessage("possiblematch");
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIPossibleMatchOtoOActionPerformed

private void MIPossibleMatchClusterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIPossibleMatchClusterActionPerformed
        if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (!cs.isTerminated("SMT")) {
        AllertDialog all = new AllertDialog(this,true,"To evaluate the linkage results, the thresholds choice is required!");
        return;
    }
    idcs=cs.Insert("CPT", "Creation of possiblematch tables");
    ResultCreationTask rcTask = new ResultCreationTask(conn,"possiblematch", orderKey);
    System.out.println("Evaluating possiblematch ...");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Result evaluation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    sumd.setMessage("possiblematch");
    new ResultCreationMediator().startTask(rcTask);
}//GEN-LAST:event_MIPossibleMatchClusterActionPerformed

private void MIResidualDSBSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIResidualDSBSaveActionPerformed
    if (!cs.isTerminated("CRT")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the creation of the residual datasets is required!");
        return;
    }
    if (!cs.isTerminated("COF")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the choice of the output folder is required!");
        return;
    }
    String folder = vs.ReadOutputFolder();
    ExportToFileTask efTask = new ExportToFileTask(conn,folder,"ResidualDSB");
    System.out.println("Saving Residual DSB to file "+folder+"\\ResidualDSB.txt");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Save Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ExportFileMediator().startTask(efTask);
}//GEN-LAST:event_MIResidualDSBSaveActionPerformed

private void MIResidualDSASaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIResidualDSASaveActionPerformed
    if (!cs.isTerminated("CRT")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the creation of residual dataset is required!");
        return;
    }
    if (!cs.isTerminated("COF")) {
        AllertDialog all = new AllertDialog(this,true,"To SAVE, the choice of the output folder is required!");
        return;
    }
    String folder = vs.ReadOutputFolder();
    ExportToFileTask efTask = new ExportToFileTask(conn,folder,"ResidualDSA");
    System.out.println("Saving Residual DSA to file "+folder+"\\ResidualDSA.txt");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Save Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    new ExportFileMediator().startTask(efTask);
}//GEN-LAST:event_MIResidualDSASaveActionPerformed

private void MIRestartBackupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIRestartBackupActionPerformed
  confirm = new ConfirmDialog(this,true,"Using Open backup option all current data will be lost!");
  if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
    return;
    
  confirm.dispose();
  try {
      Class.forName("com.mysql.jdbc.Driver");
  } catch (ClassNotFoundException e) {
      e.printStackTrace();
  }
  
  conn = DBConfiguration.getConnection();

   DefaultComboBoxModel bklist = ExportToDb.BackUpList(conn, null,TablesName.nameCurrentStatus());
   if (bklist==null) {
       new AllertDialog(this,true,"Does not exist any full backup to restore");
       return;
   }
   SelectBackup sbk=new SelectBackup(this,true,bklist);
   sbk.setTextOkButton("Restore");
   sbk.setTitle("Restore backup");
   sbk.setVisible(true);
   if (sbk.getReturnStatus()==ReadInputFiles.RET_OK) {
      String dbBackup=sbk.getSelectedBackUp();
       
      System.out.println("Backup "+dbBackup+" will be restored ...");
      BackupRestoreTask brTask = new BackupRestoreTask(conn,dbBackup,"restore","full");
      waitDialog = new WaitDialog(this);
      waitDialog.setTitle("Restore backup Task");
      waitDialog.setModal(false);
      waitDialog.setVisible(true);
      new RestoreMediator().startTask(brTask);
   }
}//GEN-LAST:event_MIRestartBackupActionPerformed

private void MIRuleBasedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIRuleBasedActionPerformed
 
   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    String method = vs.ReadMethod();
    WriteRule wrl=new WriteRule(this,true,conn,vs);
    wrl.setVisible(true);
    if (wrl.getReturnStatus()==WriteRule.RET_OK) {
        vs.UpdateModel("Deterministic");
        System.out.println("INFO: "+TablesName.nameMURule()+" table view is enabled on menu '"+MShowTables.getText()+"'");
        ContingencyTableTask ctTask = new ContingencyTableTask(conn,method,"Deterministic",vs,orderKey);
        System.out.println("INFO: Pattern update task can take some minutes");
        System.out.println("Evaluating Contingency table...");
        idcs=cs.Insert("SMT", "Deterministic threshold");
        idcs=cs.Insert("DET", "Apply deterministic model");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Pattern update Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        sum.Insert(25, "Decisional Model", 0, "Rule Based");
        new DeterministicMediator().startTask(ctTask);
    }
}//GEN-LAST:event_MIRuleBasedActionPerformed

private void MIExactActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIExactActionPerformed

   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Matching exact key: ");
    chv.setTitle("Select matching key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Matching key not selected");
            return;
        }
        vs.UpdateModel("Deterministic Exact");
        System.out.println("Matching key selected: ");
        String matchvar;
        MetricMatchingVariable mmvAppo;
        mmvv.clear();

        for (int numvar=0; numvar<varblocklist.length;numvar++) {
            matchvar = (String) varblocklist[numvar];
            System.out.println(" "+(numvar+1)+") "+matchvar);
            mmvAppo = new MetricMatchingVariable();
            mmvAppo.setMatchingVariable(matchvar);
            mmvv.addElement(mmvAppo);
            mmvAppo.setComparisonFunction("Equality");
            mmvAppo.setMetricThreshold(1);
            mmvv.set(numvar, mmvAppo);
        }
        mv = new MatchingVariables(conn, mmvv);
        mv.CreateMatchingVariablesTable();
        mv.UpdateMatchingVariableTable(mmvv);
        idcs=cs.Insert("SMK", "Setting matching key");
        cs.UpdateStatus(idcs, "Successfully terminated");
        
        ContingencyTableTask ctTask = new ContingencyTableTask(conn,"Exact","Deterministic",vs,orderKey);
        System.out.println("INFO: Equality match task can take some minutes");
        System.out.println("Evaluating Match table ...");
        idcs=cs.Insert("SMT", "Deterministic threshold");
        idcs=cs.Insert("CMT", "Match Creation via exact matching");
        idcs=cs.Insert("CRT", "Creating data set residual");
        idcs=cs.Insert("DET", "Applying equality match model");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Equality match Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
        sum.Insert(25, "Decisional Model", 0, "Exact");
        new DeterministicMediator().startTask(ctTask);
    }
}//GEN-LAST:event_MIExactActionPerformed

private void MIGuidedSelectionBlockVarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIGuidedSelectionBlockVarActionPerformed
    ChooseVariableMetadata chv = new ChooseVariableMetadata(this, "Variables: ", "Chosen variables: ");
    chv.setTitle("Guided Selection");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariableMetadata.OK_EXIT_STATUS) {
        Object[] varlist = chv.getChosenItems();
        if (varlist.length < 1) {
            new AllertDialog(this,true,"No variables selected");
        } else {
            
            waitDialog = new WaitDialog(this);
            waitDialog.setTitle("Data Profiling Task");
            waitDialog.setModal(false);

            DataProfilingTask dpTask = new DataProfilingTask(conn,"blockvar",varlist,waitDialog,this,MShowTables.getText());
            new GeneralMediator().startTask(dpTask);
            
        }
    }
}//GEN-LAST:event_MIGuidedSelectionBlockVarActionPerformed

private void MIGuidedSelectionMatchingVarActionPerformed(java.awt.event.ActionEvent evt) {                                                          
    ChooseVariableMetadata chv = new ChooseVariableMetadata(this, "Variables: ", "Chosen variables: ");
    chv.setTitle("Guided Selection");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariableMetadata.OK_EXIT_STATUS) {
        Object[] varlist = chv.getChosenItems();
        if (varlist.length < 1) {
            new AllertDialog(this,true,"No variables selected");
        } else {
            waitDialog = new WaitDialog(this);
            waitDialog.setTitle("Data Profiling Task");
            waitDialog.setModal(false);

            DataProfilingTask dpTask = new DataProfilingTask(conn,"matchingvar",varlist,waitDialog,this,MShowTables.getText());
            new GeneralMediator().startTask(dpTask);

        }
    }
}                                                         


private void MIGuidedSelectionMVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIGuidedSelectionMVActionPerformed
    MIGuidedSelectionMatchingVarActionPerformed(evt);
}//GEN-LAST:event_MIGuidedSelectionMVActionPerformed

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
   SelectOrderKey sok=new SelectOrderKey(this,true);
   sok.setVisible(true);
   if (sok.getReturnStatus()==SelectOrderKey.RET_OK) {
       orderKey=sok.getSelectedItem();
   }
   try {
       log.AddMessage("Dataset order chosen "+orderKey.substring(4));
   } catch (Exception e) {
       System.out.println("Dataset order chosen "+orderKey.substring(4));
   }
}//GEN-LAST:event_jMenuItem1ActionPerformed

private void MIReductionByDBActionPerformedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIReductionByDBActionPerformedActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (vs.ReadModel().equals("Deterministic")) {
    WeightDialog wei = new WeightDialog(this,true,conn);
    wei.setVisible(true);
    if (wei.getReturnStatus()!=WeightDialog.RET_OK) return;
    }
    System.out.println("Reduction to one to one linkage ...");
    ReductionOToOTask reTask = new ReductionOToOTask(conn,"ByDB");
    idcs=cs.Insert("RED", "Reduction to 1:1 linkage by sorting");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Reduction 1:1 Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);

    new ReductionOtoOMediator().startTask(reTask);
}//GEN-LAST:event_MIReductionByDBActionPerformedActionPerformed

private void MIUserSelectionSortVarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelectionSortVarActionPerformed
if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created via "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Sorting key: ");
    chv.setTitle("Select sorting key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Sorting key not selected");
        } else {
            String varblock = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
            
            System.out.println("Sorting key selected: "+varblock);
            vs.UpdateBlockVar(varblock);
            
            SelectSize ssz = new SelectSize(this,true);
            ssz.setVisible(true);

            if (ssz.getReturnStatus()==SelectSize.RET_OK) {
                int size = ssz.getInputedSize();
                System.out.println("Neighborhood size chosen: "+size);
                System.out.println("Search space reduction via sorted neighborhood ...");
                idcs=cs.Insert("SSC", "Search space creation reduced via sorted neighborhood");
                SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock,size);
                waitDialog = new WaitDialog(this);
                waitDialog.setTitle("Search Space Creation Task");
                waitDialog.setModal(false);
                waitDialog.setVisible(true);

                new SearchSpaceMediator().startTask(sscTask);
            }
        }
    }
}//GEN-LAST:event_MIUserSelectionSortVarActionPerformed

private void MIBlockSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIBlockSelectionActionPerformed
   ArrayList<String> list = new ArrayList<String>();
   try{
     Statement stm = (Statement)conn.createStatement();
     String query = "SELECT BLOCK_MODALITY FROM "+TablesName.nameBlockModality()+";";
     ResultSet rs = stm.executeQuery(query);
     while(rs.next())
         list.add(rs.getString(1));
     rs.close();
     stm.close();
   
     DefaultComboBoxModel bklist = new DefaultComboBoxModel(list.toArray());
     SelectBlockModality sbm=new SelectBlockModality(this,true,bklist);
     sbm.setVisible(true);
     if (sbm.getReturnStatus()==SelectBlockModality.RET_OK) {
       blockModality=sbm.getSelectedItem();
       if (blockModality!=null) {
           Statement stm1 = (Statement)conn.createStatement();
           ResultSet rs1 = stm1.executeQuery("SELECT BLOCK_NUMBER FROM "+TablesName.nameBlockModality()+" WHERE BLOCK_MODALITY = '"+blockModality+"';");
           rs1.next();
           blockNumber = rs1.getInt(1);
           rs1.close();
           stm1.close();
           System.out.println("Block Modality Selected: "+blockModality+"\nBlock Number Selected: "+blockNumber);
           MIContingencyTableOneBlock.setEnabled(true);   
       }
    
     } 
  
   }catch(Exception e){
       e.printStackTrace();
   }        
}//GEN-LAST:event_MIBlockSelectionActionPerformed

private void MFellegiSunterOneBlockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MFellegiSunterOneBlockActionPerformed
// TODO add your handling code here:
   sum.Insert(25, "Decisional Model", 0, "Fellegi-Sunter");    
   
}//GEN-LAST:event_MFellegiSunterOneBlockActionPerformed

private void MIContingencyTableOneBlockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIContingencyTableOneBlockActionPerformed
// TODO add your handling code here:
      if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (mv.getNumMatchingVariables()<3) {
        new AllertDialog(this,true,"Fellegi-Sunter method needs at least 3 matching variables");
        return;
    }
    vs.UpdateModel("Fellegi-Sunter");
    ContingencyTableOneBlockTask ctobTask = new ContingencyTableOneBlockTask(conn,blockNumber, blockModality);
    System.out.println("INFO: Pattern update task can take some minutes");
    System.out.println("Evaluating Contingency table ...");
    idcs=cs.Insert("ECTOB", "Evaluation of One Block Contingency table");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Pattern update Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
    sum.Insert(25, "Decisional Model", 0, "Fellegi-Sunter");    
    new ResultTableMediator().startTask(ctobTask);    
}//GEN-LAST:event_MIContingencyTableOneBlockActionPerformed


private void MIEMEstimationOneBlockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIEMEstimationOneBlockActionPerformed
     if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    EMEstimationOneBlockTask emTask = new EMEstimationOneBlockTask(conn, blockModality);
    idcs=cs.Insert("MODOB", "One Block Estimation model via Fellegi Sunter method");
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("EM estimation Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new EMEstimationMediator().startTask(emTask);
}//GEN-LAST:event_MIEMEstimationOneBlockActionPerformed

private void MIChangeSeparatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIChangeSeparatorActionPerformed
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    
    InputSeparator isp = new InputSeparator(this,true,vs.ReadSeparator());
    isp.setVisible(true);

    if (isp.getReturnStatus()==SelectSize.RET_OK) {
        String newSep = isp.getNewSeparator();
        System.out.println("New output field separator "+newSep);
        vs.UpdateSeparator(newSep);
    }
}//GEN-LAST:event_MIChangeSeparatorActionPerformed

private void MenuItemInputFromDBOracleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemInputFromDBOracleActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  ReadInputDBOracle ridbo = new ReadInputDBOracle(this,true);
  ridbo.setVisible(true);
  if(ridbo.getReturnStatus()==ReadInputDBOracle.RET_OK){
    idcs=cs.Insert("LDS", "Read Data Base Oracle Information");
    dataBase =ridbo.getDataBase();
    host =ridbo.getHost();
    port =ridbo.getPort();
    user =ridbo.getUser();
    password = ridbo.getPassword();
    dsaTableName =ridbo.getDSATableName();
    if (ridbo.getDeduplication()) {
        vs.UpdateProjectType("Deduplication");
        dsbTableName =ridbo.getDSATableName();
    } else {
        vs.UpdateProjectType("Linkage");
        dsbTableName =ridbo.getDSBTableName();        
    }
                    
    try {
        log.AddMessage("Input from Database Oracle Chosen");
        log.AddMessage("Data Base "+dataBase);
        log.AddMessage("Host "+ host);
        log.AddMessage("Port "+port);
        log.AddMessage("User "+user);
        log.AddMessage("DSA Table Name "+dsaTableName);
        log.AddMessage("DSB Table Name "+dsbTableName);
        } catch (Exception e) {}
       cs.UpdateStatus(idcs, "Successfully terminated");
       
       System.out.println("Reading Tables in progress ...");
       LoadFromDBOracleTask ldboTask = new LoadFromDBOracleTask(this.conn, dataBase, host, port, user, password, dsaTableName, dsbTableName);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Load Dataset Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new LoadDatasetMediator().startTask(ldboTask);
     
  
  }
                                          
   
}//GEN-LAST:event_MenuItemInputFromDBOracleActionPerformed

private void MenuItemInputFromDBMySQLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MenuItemInputFromDBMySQLActionPerformed
// TODO add your handling code here:
   if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  ReadInputDBMySql ridbms = new ReadInputDBMySql(this,true);
  ridbms.setVisible(true);
  if(ridbms.getReturnStatus()==ReadInputDBMySql.RET_OK){
    idcs=cs.Insert("LDS", "Read Data Base MySql Information");
    dataBase =ridbms.getDataBase();
    host =ridbms.getHost();
    port =ridbms.getPort();
    user =ridbms.getUser();
    password = ridbms.getPassword();
    dsaTableName =ridbms.getDSATableName();
    if (ridbms.getDeduplication()) {
        vs.UpdateProjectType("Deduplication");
        dsbTableName =ridbms.getDSATableName();
    } else {
        vs.UpdateProjectType("Linkage");
        dsbTableName =ridbms.getDSBTableName();        
    }
                    
    try {
        log.AddMessage("Input from Database MySql Chosen");
        log.AddMessage("Database "+dataBase);
        log.AddMessage("Host "+ host);
        log.AddMessage("Port "+port);
        log.AddMessage("User "+user);
        log.AddMessage("DSA Table Name "+dsaTableName);
        log.AddMessage("DSB Table Name "+dsbTableName);
        } catch (Exception e) {}
       cs.UpdateStatus(idcs, "Successfully terminated");
       
       System.out.println("Reading Tables in progress ...");
       LoadFromDBMySqlTask ldbmsTask = new LoadFromDBMySqlTask(this.conn, dataBase, host, port, user, password, dsaTableName, dsbTableName);
       waitDialog = new WaitDialog(this);
       waitDialog.setTitle("Load Dataset Task");
       waitDialog.setModal(false);
       waitDialog.setVisible(true);
        
    new LoadDatasetMediator().startTask(ldbmsTask);
  }
}//GEN-LAST:event_MenuItemInputFromDBMySQLActionPerformed

private void MIUserSelCombBlockingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelCombBlockingActionPerformed
if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created via "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Blocking key: ");
    chv.setTitle("Select blocking key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Blocking key not selected");
        } else {
            String varblock = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
            
            System.out.println("Sorting key selected: "+varblock);
            
            ChooseVariable chv2 = new ChooseVariable(this, "Variables: ", "Sorting key: ");
            chv2.setTitle("Select sorting key");
            chv2.setModal(true);
            chv2.setItems(ReconciledSchema.getReconciledSchema(conn));
            chv2.setVisible(true);

            if (chv2.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
                Object[] varsortlist = chv2.getChosenItems();
                if (varsortlist.length < 1) {
                    System.out.println("Sorting key not selected");
                } else {
                    String varsort = (String) varsortlist[0];
                    for (int ind=1;ind<varsortlist.length;ind++)
                        varsort = varsort + "," + varsortlist[ind];

                    System.out.println("Sorting key selected: "+varsort);
                    vs.UpdateBlockVar(varblock+","+varsort);

                    SelectSize ssz = new SelectSize(this,true);
                    ssz.setVisible(true);

                    if (ssz.getReturnStatus()==SelectSize.RET_OK) {
                        int size = ssz.getInputedSize();
                        System.out.println("Neighborhood size chosen: "+size);
                        System.out.println("Search space reduction via combined blocking neighborhood ...");
                        idcs=cs.Insert("SSC", "Search space creation reduced via combined blocking neighborhood");
                        SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock,varsort,size);
                        waitDialog = new WaitDialog(this);
                        waitDialog.setTitle("Search Space Creation Task");
                        waitDialog.setModal(false);
                        waitDialog.setVisible(true);

                        new SearchSpaceMediator().startTask(sscTask);
                    }
                }
            }
        }
    }
}//GEN-LAST:event_MIUserSelCombBlockingActionPerformed

private void MIReadMarginalsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIReadMarginalsActionPerformed
 // TODO add your handling code here:
    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    String method = vs.ReadMethod();
    ReadFile rif = new ReadFile(this,true);
    rif.setVisible(true);
    if (rif.getReturnStatus()==ReadInputFiles.RET_OK) {
      
       idcs=cs.Insert("MOD", "Loading of the marginal probabilities from file");
       String mrgFile = rif.getFileName();
       String mrgSep = rif.getSeparator();

       LoadMarginalsTask lmTask = new LoadMarginalsTask(conn,method,mrgFile,mrgSep);

       waitDialog = new WaitDialog(this);
       waitDialog.setTitle("Load marginals Task");
       waitDialog.setModal(false);
       waitDialog.setVisible(true);
        
       new LoadMarginalsMediator().startTask(lmTask);
    }
}//GEN-LAST:event_MIReadMarginalsActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  DefaultComboBoxModel clista = VariablesSchema.VariablesList(conn, TablesName.nameColDsa());
  DefaultComboBoxModel clistb = VariablesSchema.VariablesList(conn, TablesName.nameColDsb());
  DateFormat df = new DateFormat(this,true,vs.ReadProjectType(),clista,clistb);
  df.setVisible(true);
  if (df.getReturnStatus()==ReadInputFiles.RET_OK) {
      
    idcs=cs.Insert("PPC", "Preprocessing check format");
    
    System.out.println("Check date format in progress ...");
    PreprocessingTask ppTask = new PreprocessingTask(conn,df);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Check Format Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new PreprocessingMediator().startTask(ppTask);
  }
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  DefaultComboBoxModel clista = VariablesSchema.VariablesList(conn, TablesName.nameColDsa());
  DefaultComboBoxModel clistb = VariablesSchema.VariablesList(conn, TablesName.nameColDsb());
  FieldStandardization fs = new FieldStandardization(this,true,vs.ReadProjectType(),clista,clistb);
  fs.setVisible(true);
  if (fs.getReturnStatus()==ReadInputFiles.RET_OK) {
      
    idcs=cs.Insert("PPC", "Preprocessing field standadization");
    
    System.out.println("New variable creation in progress ...");
    PreprocessingTask ppTask = new PreprocessingTask(conn,fs);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Field Standadization Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new PreprocessingMediator().startTask(ppTask);
  }
}//GEN-LAST:event_jMenuItem5ActionPerformed

private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  DefaultComboBoxModel clista = VariablesSchema.VariablesList(conn, TablesName.nameColDsa());
  DefaultComboBoxModel clistb = VariablesSchema.VariablesList(conn, TablesName.nameColDsb());
  ReadConversionFile rcf = new ReadConversionFile(this,true,vs.ReadProjectType(),clista,clistb);
  rcf.setVisible(true);
  if (rcf.getReturnStatus()==ReadInputFiles.RET_OK) {
      
    idcs=cs.Insert("PPC", "Preprocessing inaccurate conversion");
    
    System.out.println("New variable creation in progress ...");
    PreprocessingTask ppTask = new PreprocessingTask(conn,rcf);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Inaccurate conversion Task");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new PreprocessingMediator().startTask(ppTask);
  }
}//GEN-LAST:event_jMenuItem9ActionPerformed

private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  DefaultComboBoxModel clista = VariablesSchema.VariablesList(conn, TablesName.nameColDsa());
  DefaultComboBoxModel clistb = VariablesSchema.VariablesList(conn, TablesName.nameColDsb());
  FieldMerge fm = new FieldMerge(this,true,vs.ReadProjectType(),clista,clistb);
  fm.setVisible(true);
  
  if (fm.getReturnStatus()== FieldMerge.RET_OK) {
      
    idcs=cs.Insert("PPC", "Preprocessing fields merge");
    
    //System.out.println(fm.getFieldToMerge());
    System.out.println("New variable creation in progress ...");
    PreprocessingTask ppTask = new PreprocessingTask(conn,fm);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Field Merge");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new PreprocessingMediator().startTask(ppTask);
  }
}//GEN-LAST:event_jMenuItem7ActionPerformed

private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  DefaultComboBoxModel clista = VariablesSchema.VariablesList(conn, TablesName.nameColDsa());
  DefaultComboBoxModel clistb = VariablesSchema.VariablesList(conn, TablesName.nameColDsb());
  FieldSplit fsp = new FieldSplit(this,true,vs.ReadProjectType(),clista,clistb);
  fsp.setVisible(true);
  
  if (fsp.getReturnStatus()== FieldMerge.RET_OK) {
      
    idcs=cs.Insert("PPC", "Preprocessing field parse");
    
    System.out.println("New variables creation in progress ...");
    PreprocessingTask ppTask = new PreprocessingTask(conn,fsp);
        waitDialog = new WaitDialog(this);
        waitDialog.setTitle("Field Merge");
        waitDialog.setModal(false);
        waitDialog.setVisible(true);
        
    new PreprocessingMediator().startTask(ppTask);
  }
}//GEN-LAST:event_jMenuItem8ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
// TODO add your handling code here:
  if (cs.isInProgress()) {
     System.out.println(MSGTASKBUSY);
     return;
  }
  
  ChooseReconciledSchema crs = new ChooseReconciledSchema(this,true,conn);
  crs.setVisible(true);
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void MIProcessSummariesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIProcessSummariesActionPerformed
      sum = new Summary(conn);
      fsd = new FinalSummaryDialog(this,false);
      fsd.show(sum,mv);
      fsd.setVisible(true);
}//GEN-LAST:event_MIProcessSummariesActionPerformed

private void MIGraphActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIGraphActionPerformed


   DrawFunctionTask dfTask;
   if (vs.ReadMethod().endsWith("Blocking")) {
       String sMessNograph = " is not currently admitted with Blocking!";
       AllertDialog alld = new AllertDialog(this,true,"This functionality"+sMessNograph);
       System.out.println("The threshold choose by a graphic"+sMessNograph);
       return;
       /* DefaultComboBoxModel mulist = DisplayTable.MUListWithBlock(conn, "RELAIS");
       SelectTable stb=new SelectTable(this,true,mulist);
       stb.setDescription("Select block");
       
       stb.setVisible(true);
       if (stb.getReturnStatus()!=ReadInputFiles.RET_OK) {
           System.out.println("Thresholds choice canceled");
           return;
       }
       String appoMU=stb.getSelectedTable();
       String selectedMU=appoMU.substring(0,appoMU.indexOf("(")-1);
       System.out.println("Selected MUtable: "+selectedMU);
       dfTask = new DrawFunctionTask(conn,vs, sum,cs,selectedMU); */
   }
   
   dfTask = new DrawFunctionTask(conn,vs, sum,cs);
            
   new DrawFunctionMediator().startTask(dfTask);   
   System.out.println("Choosing thresholds via graphic ...");
      
}//GEN-LAST:event_MIGraphActionPerformed

    private void MISettingMatchThresholdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MISettingMatchThresholdActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_MISettingMatchThresholdActionPerformed

private void MIUserSelUnionBlockVarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelUnionBlockVarActionPerformed
// TODO add your handling code here:
   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created by "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Blocking key: ");
    chv.setTitle("Select blocking key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Blocking key not selected");
        } else {
            String varblock = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
            
            System.out.println("Blocking key selected: "+varblock);
            vs.UpdateBlockVar(varblock);

            System.out.println("Search space reduction via blocking union ...");
            idcs=cs.Insert("SSC", "Search space creation reduced via blocking union");
            SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock,true);
            waitDialog = new WaitDialog(this);
            waitDialog.setTitle("Search Space Creation Task");
            waitDialog.setModal(false);
            waitDialog.setVisible(true);

            new SearchSpaceMediator().startTask(sscTask);
        }
    }
}//GEN-LAST:event_MIUserSelUnionBlockVarActionPerformed

private void MIReadSSFromFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIReadSSFromFileActionPerformed
   if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created by "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ReadFile rif = new ReadFile(this,true);
    rif.FileDefinition("Search Space:");
    rif.setVisible(true);
    if (rif.getReturnStatus()==ReadInputFiles.RET_OK) {
      
       System.out.println("Search space creation via external file reading ...");
       idcs=cs.Insert("SSC", "Search space creation reduced via external file");
       String ssFile = rif.getFileName();
       String ssSep = rif.getSeparator();

       SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,ssFile,ssSep);
            
       waitDialog = new WaitDialog(this);
       waitDialog.setTitle("Search Space Creation Task");
       waitDialog.setModal(false);
       waitDialog.setVisible(true);

       new SearchSpaceMediator().startTask(sscTask);
    }

}//GEN-LAST:event_MIReadSSFromFileActionPerformed

private void MIUserSelectionSimHashActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelectionSimHashActionPerformed

    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created via "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Chosen key: ");
    chv.setTitle("Select key for shingling");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        Object[] varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Key for shingling not selected");
        } else {
            String varblock = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
            
            System.out.println("Key for shingling: "+varblock);
            
            ChooseSimhashParam par= new ChooseSimhashParam(this,true);
            par.setVisible(true);
            
            if (par.getReturnStatus()!=ChooseSimhashParam.RET_OK) {
                System.out.println("Task canceled from user");
                return;
            }
            
            int HDthr=par.getHDThreshold();
            int nRound=par.getRoundsNum();
            int nGLen=par.getGramLenght();
            boolean bWeig=par.getUseWeights();
            
            System.out.println("SimHash parameters: (HDthreshold="+HDthr+" Rotations="+nRound+" Grams Size="+nGLen+")");
            if (bWeig) System.out.println(" Use of TF-IDF weights");
            System.out.println("Search space reduction via SimHash method ...");
            
                        idcs=cs.Insert("SSC", "Search space creation reduced via simhash method");
                        SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock,nRound,HDthr,nGLen,bWeig);
                        waitDialog = new WaitDialog(this);
                        waitDialog.setTitle("Search Space Creation Task");
                        waitDialog.setModal(false);
                        waitDialog.setVisible(true);

                        new SearchSpaceMediator().startTask(sscTask);
        }
    }                                                  

}//GEN-LAST:event_MIUserSelectionSimHashActionPerformed

private void MIUserSelBlockedSimHashActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIUserSelBlockedSimHashActionPerformed

    if (cs.isInProgress()) {
        System.out.println(MSGTASKBUSY);
        return;
    }
    if (cs.isTerminated("SSC")) {
          String usedmeth = vs.ReadMethod();
          confirm = new ConfirmDialog(this,true,"Search space already created via "+usedmeth,"Revise");
          if (confirm.getReturnStatus()==ConfirmDialog.RET_CANCEL)
             return;
    }
    ChooseVariable chv = new ChooseVariable(this, "Variables: ", "Blocking key: ");
    chv.setTitle("Select Blocking key");
    chv.setModal(true);
    chv.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv.setVisible(true);
    Object[] varblocklist=null;
            
    if (chv.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        varblocklist = chv.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Blocking key not selected");
            return;
        }
        if (varblocklist.length > 1) {
            System.out.println("Only one variable permissed as Blocking key");
            return;
        }
    }
    else
        return;
        
    String varblock = (String) varblocklist[0];
    for (int ind=1;ind<varblocklist.length;ind++)
                varblock = varblock + "," + varblocklist[ind];
    System.out.println("Blocking key selected: "+varblock);
    
    ChooseVariable chv2 = new ChooseVariable(this, "Variables: ", "Chosen key: ");
    chv2.setTitle("Select key for shingling");
    chv2.setModal(true);
    chv2.setItems(ReconciledSchema.getReconciledSchema(conn));
    chv2.setVisible(true);
    
    if (chv2.getExitStatus()==ChooseVariable.OK_EXIT_STATUS) {
        varblocklist = chv2.getChosenItems();
        if (varblocklist.length < 1) {
            System.out.println("Key for shingling not selected");
        } else {
            String varhash = (String) varblocklist[0];
            for (int ind=1;ind<varblocklist.length;ind++)
                varhash = varhash + "," + varblocklist[ind];
            
            System.out.println("Key for shingling: "+varhash);
            
            ChooseSimhashParam par= new ChooseSimhashParam(this,true);
            par.setVisible(true);
            
            if (par.getReturnStatus()!=ChooseSimhashParam.RET_OK) {
                System.out.println("Task canceled from user");
                return;
            }
            
            int HDthr=par.getHDThreshold();
            int nRound=par.getRoundsNum();
            int nGLen=par.getGramLenght();
            boolean bWeig=par.getUseWeights();
            
            System.out.println("SimHash parameters: (HDthreshold="+HDthr+" Rotations="+nRound+" Grams Size="+nGLen+")");
            if (bWeig) System.out.println(" Use of TF-IDF weights");
            
                        System.out.println("Search space reduction via Blocked SimHash method ...");
                        idcs=cs.Insert("SSC", "Search space creation reduced via blocked simhash method");
                        SearchSpaceCreationTask sscTask = new SearchSpaceCreationTask(conn,vs,varblock,varhash,nRound,HDthr,nGLen,bWeig);
                        waitDialog = new WaitDialog(this);
                        waitDialog.setTitle("Search Space Creation Task");
                        waitDialog.setModal(false);
                        waitDialog.setVisible(true);

                        new SearchSpaceMediator().startTask(sscTask);
        }
    }                                                  

}//GEN-LAST:event_MIUserSelBlockedSimHashActionPerformed
 
 
   
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Relais2Frame().setVisible(true);
            }
        });
    }

private class ResultTableMediator extends AbstractMediator {
		public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Contincency table creation task failed");
                        cs.UpdateStatus("ECT", "Task failed");
                        cs.UpdateStatus("ECTOB", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Contingency table created");
                        System.out.println("INFO: "+TablesName.nameContingency()+" table view is enabled on menu '"+MShowTables.getText()+"'");
                        cs.UpdateStatus("ECT", "Successfully terminated");
                        cs.UpdateStatus("ECTOB", "Successfully terminated");
                        if(cs.isTerminated("ECTOB")) MIEMEstimationOneBlock.setEnabled(true);
                        if(cs.isTerminated("ECT")) MIEMEstimation.setEnabled(true);
                        MIReadMarginals.setEnabled(true);
                        
                }
		
	}

private class LoadDatasetMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Load data set task failed");
                        System.out.println("See log table for more details");
                        cs.UpdateStatus("LDS", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        sumd.setSummaryTitle("Dataset Read");
                        sumd.show("Dataset",vs,sum);
                        //sumd.setVisible(true);
                        
                        System.out.println("Data set loaded");
                        MSearchSpace.setEnabled(true);
                        MPreprocessing.setEnabled(true);
                        MDataProfiling.setEnabled(true);
                        MDecisionModel.setEnabled(true);
                        cs.UpdateStatus("LDS", "Successfully terminated");
		}
		
	}

private class SearchSpaceMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Search space creation task failed");
                        cs.UpdateStatus("SSC", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Search space creation done");
                        MDecisionModel.setEnabled(true);
                        MProbabilistic.setEnabled(true);
                        MIRuleBased.setEnabled(true);
                        cs.UpdateStatus("SSC", "Successfully terminated");
                        
                        if (cs.isTerminated("SMV")) {
                            if (vs.ReadMethod().endsWith("Blocking"))
                                MFellegiSunterOneBlock.setEnabled(true);
                            else
                                MFellegiSunterOneBlock.setEnabled(false);
                        }
                        
                        sumd.setSummaryTitle("Search space created");
                        sumd.show("Searchspace",vs,sum);
		}
		
	}

private class EMEstimationMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: EM estimation task failed");
                        cs.UpdateStatus("MOD", "Task failed");
                        cs.UpdateStatus("MODOB", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Fellegi Sunter method done");
                        System.out.println("INFO: "+TablesName.nameMU()+" view is enabled on menu '"+MShowTables.getText()+"'");
                        MReduction.setEnabled(true);
                        MResult.setEnabled(true);
                        MISettingMatchThreshold.setEnabled(true);
                        cs.UpdateStatus("MOD", "Successfully terminated");
                        cs.UpdateStatus("MODOB", "Successfully terminated");
                        MIContingencyTableOneBlock.setEnabled(false);
                        MIEMEstimationOneBlock.setEnabled(false);
		}
		
	}

private class LoadMarginalsMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Load Marginals task failed");
                        cs.UpdateStatus("MOD", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Load marginal probabilities and calculation of mu-table done");
                        System.out.println("INFO: "+TablesName.nameMU()+" view is enabled on menu '"+MShowTables.getText()+"'");
                        MReduction.setEnabled(true);
                        MResult.setEnabled(true);
                        MISettingMatchThreshold.setEnabled(true);
                        cs.UpdateStatus("MOD", "Successfully terminated");
                        MIContingencyTableOneBlock.setEnabled(false);
                        MIEMEstimationOneBlock.setEnabled(false);
		}
		
	}

private class ReductionOtoOMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Reduction 1:1 task failed");
                        cs.UpdateStatus("RED", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Reduction done");
                        MIReducedContingencyTable.setEnabled(true);
                        MOtoOResult.setEnabled(true);
                        cs.UpdateStatus("RED", "Successfully terminated");
		}
		
	}

private class ReducedContingencyTableMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Reduced contingency table task failed");
                        cs.UpdateStatus("RCT", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Evaluation done");
                        System.out.println("INFO: "+TablesName.nameContingencyReduced()+" view is enabled on menu '"+MShowTables.getText()+"'");
                        cs.UpdateStatus("RCT", "Successfully terminated");
		}
		
	}

private class ResultCreationMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Result evaluation task failed");
                        cs.UpdateStatus("CMT", "Task failed");
                        cs.UpdateStatus("CPT", "Task failed");
                        cs.UpdateStatus("CUT", "Task failed");
                        cs.UpdateStatus("CRT", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Table result created");
                        sumd.setSummaryTitle("Linkage result");
                        sumd.show(vs,sum);
                        cs.UpdateStatus("CMT", "Successfully terminated");
                        cs.UpdateStatus("CPT", "Successfully terminated");
                        cs.UpdateStatus("CUT", "Successfully terminated");
                        cs.UpdateStatus("CRT", "Successfully terminated");
		}
		
	}

private class DeterministicMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Deterministic model task failed");
                        cs.UpdateStatus("CMT", "Task failed");
                        cs.UpdateStatus("CRT", "Task failed");
                        cs.UpdateStatus("DET", "Task failed");
                        cs.UpdateStatus("SMT", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("Model successfully terminated");
                        if (vs.ReadModel().equals("Deterministic Exact")) {
                            System.out.println(" Table match created");
                            System.out.println(" Tables residual created");
                            sumd.setSummaryTitle("Linkage result");
                            sumd.show("match",vs,sum);
                        }
                        cs.UpdateStatus("CMT", "Successfully terminated");
                        cs.UpdateStatus("CRT", "Successfully terminated");
                        cs.UpdateStatus("DET", "Successfully terminated");
                        cs.UpdateStatus("SMT", "Successfully terminated");

                        if (vs.ReadModel().equals("Deterministic")) {
                            MReduction.setEnabled(true);
                            MResult.setEnabled(true);
                            MISettingMatchThreshold.setEnabled(false);
                        }
		}
		
	}

private class ExportFileMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Save task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("File created");
		}
		
	}

private class MetaDataMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: Guided selection task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
		}
		
	}

private class GeneralMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: task failed");
                        System.out.println("See log table for more details");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
		}
		
	}

 class RestoreMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: task failed");
                        System.out.println("See log table for more details");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
                                        MICurrElabActionPerformed(null);
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
		}
		
	}
 
class PreprocessingMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: task failed");
                        System.out.println("See log table for more details");
                        cs.UpdateStatus("PPC", "Task failed");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					waitDialog.dispose();
				}
			};
			SwingUtilities.invokeLater(updateUI);
                        cs.UpdateStatus("PPC", "Successfully terminated");
		}
		
}
class DrawFunctionMediator extends AbstractMediator {
	public void failTask(AbstractTask task) {
			Runnable updateUI = new Runnable() {
				public void run() {
					
                                }
			};
			SwingUtilities.invokeLater(updateUI);
                        System.out.println("ERROR: task failed");
                        System.out.println("See log table for more details");
		}
		
		public void succeedTask(AbstractTask task) {
						
			Runnable updateUI = new Runnable() {
				public void run() {
					
				}
			};
			SwingUtilities.invokeLater(updateUI);
		}
		
	}



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu MClusterResult;
    private javax.swing.JMenu MDataProfiling;
    private javax.swing.JMenu MDataset;
    private javax.swing.JMenu MDecisionModel;
    private javax.swing.JMenu MDeterministic;
    private javax.swing.JMenu MFellegiSunter;
    private javax.swing.JMenu MFellegiSunterOneBlock;
    private javax.swing.JMenuItem MIBlockSelection;
    private javax.swing.JMenuItem MIChangeSeparator;
    private javax.swing.JMenuItem MIChooseOutputFolder;
    private javax.swing.JMenuItem MIContingencyTable;
    private javax.swing.JMenuItem MIContingencyTableOneBlock;
    private javax.swing.JMenuItem MICopyBackup;
    private javax.swing.JMenuItem MICopyBackupUnmatch;
    private javax.swing.JMenuItem MICrossProduct;
    private javax.swing.JMenuItem MICurrElab;
    private javax.swing.JMenuItem MIDSUnmatchCluster;
    private javax.swing.JMenuItem MIDSUnmatchOtoO;
    private javax.swing.JMenuItem MIDeleteBackup;
    private javax.swing.JMenuItem MIEMEstimation;
    private javax.swing.JMenuItem MIEMEstimationOneBlock;
    private javax.swing.JMenuItem MIExact;
    private javax.swing.JMenuItem MIExit;
    private javax.swing.JMenuItem MIFullBackup;
    private javax.swing.JMenuItem MIGraph;
    private javax.swing.JMenuItem MIGuidedSelectionBlockVar;
    private javax.swing.JMenuItem MIGuidedSelectionMV;
    private javax.swing.JMenuItem MIInputFromDBMySQL;
    private javax.swing.JMenuItem MIInputFromDBOracle;
    private javax.swing.JMenuItem MIInsertThreshold;
    private javax.swing.JMenuItem MILoadFromInputFiles;
    private javax.swing.JMenuItem MIMatchCluster;
    private javax.swing.JMenuItem MIMatchFile;
    private javax.swing.JMenuItem MIMatchOtoO;
    private javax.swing.JMenuItem MIMetricsSetting;
    private javax.swing.JMenuItem MINewElab;
    private javax.swing.JMenuItem MIOneTableSave;
    private javax.swing.JMenuItem MIPossibleMatchCluster;
    private javax.swing.JMenuItem MIPossibleMatchFile;
    private javax.swing.JMenuItem MIPossibleMatchOtoO;
    private javax.swing.JMenuItem MIProcessSummaries;
    private javax.swing.JMenuItem MIReadMarginals;
    private javax.swing.JMenuItem MIReadSSFromFile;
    private javax.swing.JMenuItem MIReducedContingencyTable;
    private javax.swing.JMenuItem MIReductionByDBActionPerformed;
    private javax.swing.JMenuItem MIReductionOtoO;
    private javax.swing.JMenuItem MIResidualDSASave;
    private javax.swing.JMenuItem MIResidualDSBSave;
    private javax.swing.JMenuItem MIRestartBackup;
    private javax.swing.JMenuItem MIResultBackup;
    private javax.swing.JMenuItem MIRuleBased;
    private javax.swing.JMenuItem MIScreenClear;
    private javax.swing.JMenuItem MISelectTable;
    private javax.swing.JMenu MISettingMatchThreshold;
    private javax.swing.JMenuItem MIUnmatchCluster;
    private javax.swing.JMenuItem MIUnmatchOtoO;
    private javax.swing.JMenuItem MIUserSelBlockedSimHash;
    private javax.swing.JMenuItem MIUserSelCombBlocking;
    private javax.swing.JMenuItem MIUserSelUnionBlockVar;
    private javax.swing.JMenuItem MIUserSelectionBlockVar;
    private javax.swing.JMenuItem MIUserSelectionMV;
    private javax.swing.JMenuItem MIUserSelectionSimHash;
    private javax.swing.JMenuItem MIUserSelectionSortVar;
    private javax.swing.JMenu MMatchingVariables;
    private javax.swing.JMenu MOtoOResult;
    private javax.swing.JMenu MPreprocessing;
    private javax.swing.JMenu MProbabilistic;
    private javax.swing.JMenu MReduction;
    private javax.swing.JMenu MReductionSolve;
    private javax.swing.JMenu MResult;
    private javax.swing.JMenu MSave;
    private javax.swing.JMenu MSearchSpace;
    private javax.swing.JMenu MShowTables;
    private javax.swing.JMenu MStart;
    private javax.swing.JMenuBar MainMenuBar;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu5;
    private javax.swing.JMenu jMenu6;
    private javax.swing.JMenu jMenu7;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private it.istat.relais.gui.OutScrollPane outScrollPanel;
    // End of variables declaration//GEN-END:variables

}
