
package it.istat.relais.gui;

import it.istat.relais.project.Summary;
import it.istat.relais.project.SummaryData;
import it.istat.relais.project.VariablesSetting;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.ArrayList;

public class SummaryDialog extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    private String remMessage="no";

    public SummaryDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
					(screenSize.height - frameSize.height) / 2);
        this.setVisible(false);
    }

    public void show(VariablesSetting vs,Summary sum) {
        if (!remMessage.equalsIgnoreCase("no")) show(remMessage,vs,sum);
        setMessage("no");
    }
            
    public void show(String message,VariablesSetting vs,Summary sum) {
        ArrayList<SummaryData> sdata = new ArrayList<SummaryData>();
        int appo;
        sdata = sum.Create(message, vs);
        
        //System.out.println("rec"+sdata.size());
        summary1.setText(sdata.get(0).getSummary()+":");
        appo = (int)sdata.get(0).getValue();
        value1.setText(""+appo);
        if (sdata.size()>1) {
            summary2.setText(sdata.get(1).getSummary()+":");
            appo = (int)sdata.get(1).getValue();
            value2.setText(""+appo);
        } else
        {
            summary2.setText("");
            value2.setText("");
        }
        this.setVisible(true);
    }
    
    public int getReturnStatus() {
        return returnStatus;
    }
    
    public void setSummaryTitle(String title) {
        SummaryTitle.setText(title);
    }
    
    public void setMessage(String message) {
        remMessage=message;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        cancelButton = new javax.swing.JButton();
        SummaryTitle = new javax.swing.JLabel();
        summary1 = new javax.swing.JLabel();
        summary2 = new javax.swing.JLabel();
        value1 = new javax.swing.JLabel();
        value2 = new javax.swing.JLabel();

        setTitle("Summary");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        cancelButton.setText("Close");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        SummaryTitle.setFont(new java.awt.Font("Tahoma", 1, 11));
        SummaryTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        SummaryTitle.setText("Title");

        summary1.setText("text1");
        summary1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        summary1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        summary2.setText("text2");

        value1.setText("jLabel1");
        value1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        value1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        value2.setText("jLabel1");
        value2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        value2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(SummaryTitle, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(25, 25, 25)
                        .addComponent(summary1, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(value1, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addComponent(summary2, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(value2, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(127, Short.MAX_VALUE)
                .addComponent(cancelButton)
                .addGap(120, 120, 120))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(SummaryTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(summary1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 26, Short.MAX_VALUE)
                    .addComponent(value1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(2, 2, 2)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(summary2, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(value2, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cancelButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

    private void doClose(int retStatus) {
        returnStatus = retStatus;
        dispose();
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                SummaryDialog dialog = new SummaryDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel SummaryTitle;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel summary1;
    private javax.swing.JLabel summary2;
    private javax.swing.JLabel value1;
    private javax.swing.JLabel value2;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
}
