package it.istat.relais.gui;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Window;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JProgressBar;

public class WaitDialog extends JDialog {
	
	private static final long serialVersionUID = 1L;
	private JProgressBar progressBar;
	
	public WaitDialog(Dialog owner) {
		super(owner);
		construct(owner);
	}
	
	public WaitDialog(Frame owner) {
		super(owner);
		construct(owner);
	}
	
	public void setLengthOfTask(int minimum, int maximum) {
		progressBar.setMinimum(minimum);
		progressBar.setMinimum(maximum);
	}
	
	public void setProgress(int n) {
		progressBar.setValue(n);
		if (progressBar.isIndeterminate()) {
			progressBar.setIndeterminate(false);
	        progressBar.setString(null); 
		}
	}
	
	
	private void construct(Window owner) {
		BagBuilder bag = new BagBuilder(getContentPane());
		
		JLabel label = new JLabel("Please wait...");
		bag.constraints().insets = new Insets(10, 10, 5, 10);
		bag.add(label, 0, 0, 1, 1, 0, 0,
				GridBagConstraints.NONE,
				GridBagConstraints.WEST);		
		
		progressBar = new JProgressBar();
        progressBar.setStringPainted(true); 
        progressBar.setString(""); 
        progressBar.setIndeterminate(true);
        bag.constraints().insets = new Insets(5, 10, 5, 10);
		bag.add(progressBar, 0, 1, 1, 1, 1, 0,
				GridBagConstraints.HORIZONTAL,
				GridBagConstraints.CENTER);
        
        pack();
        int width = (int) (getSize().width * 1.25);
		int height = getSize().height;
		setSize(new Dimension(width, height));
		
		setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
		setLocationRelativeTo(owner);
        setResizable(false);
	}
	
}
