package it.istat.relais.gui;

import it.istat.relais.log.TraceLog;
import java.sql.Connection;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import it.istat.relais.deterministic.*;
import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.metrics.dataStructure.MetricMatchingVariable;
import it.istat.relais.metrics.dataStructure.MetricMatchingVariableVector;
import it.istat.relais.project.ReconciledSchema;
import it.istat.relais.project.VariablesSetting;

public class WriteRule extends javax.swing.JDialog {
    public static final int RET_CANCEL = 0;
    public static final int RET_OK = 1;
    VariablesSetting vs;
    int ntotMV;
    Connection connection;
    TraceLog log;
    RuleElement[] elementsRule;
    int lastElement, indexMV;
    MetricMatchingVariableVector mmvv;

    public WriteRule(java.awt.Frame parent, boolean modal, Connection conn, VariablesSetting vs) {
        super(parent, modal);
        initComponents();
        
        ComboBoxModel matchvar=null;
        
        this.connection=conn;
        this.log = new TraceLog(conn);
        this.vs = vs;
        try{
            DefaultComboBoxModel cbmodel = new DefaultComboBoxModel(ReconciledSchema.getReconciledSchema(conn));
            matchvar = (ComboBoxModel) cbmodel;
        } catch (Exception e) {
            matchvar = null;
        }
        
        if (matchvar!=null) VariableCombo.setModel(matchvar);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = getSize();
        setLocation((screenSize.width - frameSize.width) / 2,
                    (screenSize.height - frameSize.height) / 2);
        
        mmvv = new MetricMatchingVariableVector();
        elementsRule = new RuleElement[200];
        lastElement = 0;
        indexMV = 0;
        elementsRule[lastElement]=new RuleElement(lastElement,"",1,1,'(',' ',false);
        
        /* write of: ( */
        elementsRule[lastElement+1]=new RuleElement(lastElement+1," (",
                                  elementsRule[lastElement].GetLevel()+1,
                                  -1,'(',elementsRule[lastElement].GetOperator(),elementsRule[lastElement].GetNot());
        lastElement++;
        this.addRuleText();

    }

    public int getReturnStatus() {
        return returnStatus;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        VariableCombo = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        DistanceCombo = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        Threshold = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        RuleText = new javax.swing.JTextArea();

        setTitle("Input rule");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("Ok");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        jButton3.setText("Or");
        jButton3.setMaximumSize(new java.awt.Dimension(110, 23));
        jButton3.setMinimumSize(new java.awt.Dimension(110, 23));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton7.setText("Clear rule");
        jButton7.setMaximumSize(new java.awt.Dimension(110, 23));
        jButton7.setMinimumSize(new java.awt.Dimension(110, 23));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jButton8.setText("Canc");
        jButton8.setMaximumSize(new java.awt.Dimension(110, 23));
        jButton8.setMinimumSize(new java.awt.Dimension(110, 23));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jLabel1.setText("Variable: ");

        VariableCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "var1", "var2", "var3", "var4" }));
        VariableCombo.setOpaque(false);

        jButton1.setText("Add Condition");
        jButton1.setMaximumSize(new java.awt.Dimension(110, 23));
        jButton1.setMinimumSize(new java.awt.Dimension(110, 23));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel3.setText("Metric:");

        DistanceCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Equality", "NumericComparison", "3Grams", "Dice", "Jaro", "JaroWinkler", "Levenshtein", "Soundex", "NumericEuclideanDistance", "Inclusion3Grams" }));
        DistanceCombo.setOpaque(false);
        DistanceCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DistanceComboActionPerformed(evt);
            }
        });

        jLabel4.setText("Threshold:");

        Threshold.setText("1.0");
        Threshold.setEnabled(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(31, 31, 31)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(DistanceCombo, 0, 129, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Threshold, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(VariableCombo, 0, 229, Short.MAX_VALUE))
                        .addGap(24, 24, 24))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 66, Short.MAX_VALUE)
                        .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(63, 63, 63)))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButton7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(34, 34, 34))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(VariableCombo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Threshold, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4)
                            .addComponent(DistanceCombo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(17, 17, 17)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jButton7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel2.setText("MATCH RULE:");

        jScrollPane1.setMinimumSize(new java.awt.Dimension(24, 12));

        RuleText.setColumns(20);
        RuleText.setEditable(false);
        RuleText.setFont(new java.awt.Font("Comic Sans MS", 0, 14));
        RuleText.setRows(1);
        RuleText.setMargin(new java.awt.Insets(5, 1, 1, 1));
        jScrollPane1.setViewportView(RuleText);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 327, Short.MAX_VALUE)
                        .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /* button OK */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed

        if (elementsRule[lastElement].GetLastdigit() == '(' || elementsRule[lastElement].GetLastdigit() == 'O') {
            new AllertDialog(null,true,"Missing value");
            return;
        }
        elementsRule[lastElement+1]=new RuleElement(lastElement+1,")",
                                  elementsRule[lastElement].GetLevel()-1,
                                  -1,')',' ',false);
        lastElement++;
        /*this.addRuleText();*/
    
        elementsRule[lastElement+1]=new RuleElement(lastElement+1,"",
                                  elementsRule[lastElement].GetLevel(),
                                  -1,'E',' ',false);
        lastElement++;
        try {
            MatchingVariables mv = new MatchingVariables(connection,mmvv);
            mv.CreateMatchingVariablesTableComplete();
            log.AddMessage("Insert matching variables for rule",false);
            MUTableDeterministic mutable = new MUTableDeterministic(connection,indexMV,elementsRule);
            if (mutable.Load()==0) {
                new AllertDialog(null,true,"Semantic error: the rule is never verified!");
                return;
            }
            System.out.println("Match rule :");
            log.AddMessage("Rule - "+RuleText.getText(),false);
            System.out.println(RuleText.getText());
            vs.UpdateRule(RuleText.getText());
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }

        doClose(RET_OK);
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

    /* button Or */
private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
    if (elementsRule[lastElement].GetLastdigit() == '(' || elementsRule[lastElement].GetLastdigit() == 'O') {
        new AllertDialog(null,true,"Missing value");
        return;
    }
    
    /* write of: ) */
    elementsRule[lastElement+1]=new RuleElement(lastElement+1,")",
                                  elementsRule[lastElement].GetLevel()-1,
                                  -1,')',' ',false);
    lastElement++;
    this.addRuleText();
    
    elementsRule[lastElement+1]=new RuleElement(lastElement+1," Or"+System.getProperty("line.separator"),
                                  elementsRule[lastElement].GetLevel(),
                                  -1,'O','O',false);
    lastElement++;
    this.addRuleText();
    
    /* write of: ( */
    elementsRule[lastElement+1]=new RuleElement(lastElement+1," (",
                              elementsRule[lastElement].GetLevel()+1,
                              -1,'(',elementsRule[lastElement].GetOperator(),elementsRule[lastElement].GetNot());
    lastElement++;
    this.addRuleText();
}//GEN-LAST:event_jButton3ActionPerformed
   
    /* button delete rule */
private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
    RuleText.setText("");
    lastElement=0;
    
    /* write of: ( */
    elementsRule[lastElement+1]=new RuleElement(lastElement+1," (",
                              elementsRule[lastElement].GetLevel()+1,
                              -1,'(',elementsRule[lastElement].GetOperator(),elementsRule[lastElement].GetNot());
    lastElement++;
    this.addRuleText();
}//GEN-LAST:event_jButton7ActionPerformed

    /* button canc */
private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
    if (lastElement>0) {
        if (elementsRule[lastElement].GetLastdigit() == '(')
            lastElement=lastElement-3;
        else
            lastElement=lastElement-2;
        
        String remaining="";
        int remainEl=0;
        while (remainEl<=lastElement) {
            remaining = remaining+elementsRule[remainEl].GetText();
            remainEl++;           
        }
        RuleText.setText(remaining+")");
        
        if (elementsRule[lastElement].GetLastdigit() == 'O' || lastElement==0) {
            elementsRule[lastElement+1]=new RuleElement(lastElement+1," (",
                              elementsRule[lastElement].GetLevel()+1,
                              -1,'(',elementsRule[lastElement].GetOperator(),elementsRule[lastElement].GetNot());
            lastElement++;
            this.addRuleText();
        }
    }
    
}//GEN-LAST:event_jButton8ActionPerformed

    /* button add condition */
private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    double nThresh;
    int currMV;
    if (elementsRule[lastElement].GetLastdigit() != '(') {
        elementsRule[lastElement+1]=new RuleElement(lastElement+1," And",
                                  elementsRule[lastElement].GetLevel(),
                                  -1,'O','A',false);
        lastElement++;
        this.addRuleText();
    }
    
    try {
        nThresh = Double.parseDouble(Threshold.getText());
        if (nThresh<0 || nThresh>1) {
            new AllertDialog(null,true,"The Threshold value must be a number between 0 and 1");
            return;
        }
    } catch (Exception e) {
        new AllertDialog(null,true,"The Threshold value must be a number");
        return;
    }
    String newText = " "+DistanceCombo.getSelectedItem().toString()+"["+VariableCombo.getSelectedItem().toString()+"]";
    if (!DistanceCombo.getSelectedItem().equals("Equality")) {
        newText=newText+">="+nThresh;
    }
    char oper = elementsRule[lastElement].GetOperator();
    boolean not = elementsRule[lastElement].GetNot();
    if (elementsRule[lastElement].GetLastdigit()=='(') {
        oper = ' ';
        not = false;
    }
    
    MetricMatchingVariable mmvAppo=new MetricMatchingVariable();
    mmvAppo.setMatchingVariable(VariableCombo.getSelectedItem().toString());
    mmvAppo.setComparisonFunction(DistanceCombo.getSelectedItem().toString());
    mmvAppo.setMetricThreshold(nThresh);
    currMV = mmvv.getIndex(mmvAppo);
    if (currMV<0) {
        currMV=indexMV;
        mmvv.add(indexMV, mmvAppo);
        indexMV++;
    }
    
    elementsRule[lastElement+1]=new RuleElement(lastElement+1,newText,
                                  elementsRule[lastElement].GetLevel(),
                                  currMV,
                                  'V',oper,not);
    lastElement++;
    this.addRuleText();
}//GEN-LAST:event_jButton1ActionPerformed

private void DistanceComboActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DistanceComboActionPerformed
    if (DistanceCombo.getSelectedItem().equals("Equality")) {
        Threshold.setText("1.0");
        Threshold.setEnabled(false);
    } else {
        Threshold.setEnabled(true);
    }
}//GEN-LAST:event_DistanceComboActionPerformed

    private void addRuleText () {
        String oldtext = RuleText.getText();
        String newText;
        int lenght;
        if (oldtext == null)
            newText = elementsRule[lastElement].GetText();
        else {
            lenght= oldtext.length();
            if (lenght>1) oldtext = oldtext.substring(0,lenght-1);
            newText = oldtext+elementsRule[lastElement].GetText();
        }
        newText=newText+")";
        RuleText.setText(newText);
    }
        
    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }
    
    public void setTextOkButton(String message) {
        this.okButton.setText(message);  
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                WriteRule dialog = new WriteRule(new javax.swing.JFrame(), true,null,null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox DistanceCombo;
    private javax.swing.JTextArea RuleText;
    private javax.swing.JTextField Threshold;
    private javax.swing.JComboBox VariableCombo;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
}
