package it.istat.relais.gui.task;

public abstract class AbstractMediator {
	
	private AbstractTask task;
	
	public SwingWorker startTask(AbstractTask task) {
		this.task = task;
		SwingWorker worker = new TaskWorker(task);
		task.setSuccessCommand(new SuccessCommand());
		task.setFailCommand(new FailCommand());
		worker.start();
		
		return worker;
	}
	
	public abstract void succeedTask(AbstractTask task);
	
	public abstract void failTask(AbstractTask task);
	
	class SuccessCommand implements Command {
		
		public void execute() {
			succeedTask(task);
		}
		
	}
	
	class FailCommand implements Command {
		
		public void execute() {
			failTask(task);
		}
		
	}
	
}
