package it.istat.relais.gui.task;

import it.istat.relais.export.ExportToDb;
import it.istat.relais.log.TraceLog;
import java.sql.Connection;

public class BackupRestoreTask extends AbstractTask {

    private Connection conn;
    private String backup;
    private String operation;
    private String modal;
    
    public BackupRestoreTask(Connection conn, String backup, String operation, String modal) {
        this.conn=conn;
        this.backup=backup;
        this.operation=operation;
        this.modal=modal;
    }
    public void run() {
        ExportToDb bkcp = new ExportToDb(conn,backup);
        TraceLog log = new TraceLog(conn);
        try {
            log.AddMessage("Menagement backup "+backup+": "+operation+" "+modal,false);
            if (operation.equalsIgnoreCase("restore")) {
                  ExportToDb.startElab(conn,"relais");
                  ExportToDb start = new ExportToDb(conn,backup);

                  start.dbImport();
                  System.out.println("System is ready");
                }
            else if (operation.equalsIgnoreCase("backup")) {
                if (modal.equalsIgnoreCase("result")) {
                    ExportToDb edb = new ExportToDb(conn, backup);
                    edb.dbCreate();
                    edb.dbCopyResult();
                    log.AddMessage("Backup "+backup+" created");
                } else {
                    ExportToDb edb = new ExportToDb(conn, backup);
                    edb.dbCreate();
                    edb.dbCopy();
                    log.AddMessage("Full backup "+backup+" created");
                }
             }
             else if (operation.equalsIgnoreCase("delete")) {
                ExportToDb bkrm = new ExportToDb(conn,backup);
                bkrm.dbDrop();
                log.AddMessage("Backup "+backup+" removed.");
             }
             else {
                throw new Exception("Operation "+operation+" not allowed in backup/restore task");
             }
             succeed();
             
            } catch (Exception ex) {
            try {
                log.AddMessage("Backup/Restore exception","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
            
        }
    }
}
