package it.istat.relais.gui.task;

import java.sql.Connection;
import it.istat.relais.decision.contingencyTable.ContingencyTable;
import it.istat.relais.log.TraceLog;
import it.istat.relais.project.VariablesSetting;

public class ContingencyTableOneBlockTask extends AbstractTask {
 private Connection conn;
    private String method;
    private String model;
    private VariablesSetting vs;
    private int blockNumber;
    private String blockModality;
    
    public ContingencyTableOneBlockTask(Connection conn, int blockNumber, String blockModality) {
        this.conn=conn;
        this.method="Blocking";
        this.vs=null;
        this.model="Fellegi-Sunter";
        this.blockNumber = blockNumber;
        this.blockModality = blockModality;
    }
  
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {
            log.AddMessage("Evaluation of Contingency table. Model: "+model+"Method: "+method,false);
            ContingencyTable ctob = new ContingencyTable(conn);
            ctob.CreateContingencyTableOneBlock(blockNumber, blockModality);
            log.AddMessage("Update pattern and contingency table creation done",false);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception in update pattern","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}

