package it.istat.relais.gui.task;

import it.istat.relais.constants.TablesName;
import it.istat.relais.export.ExportToDb;
import it.istat.relais.log.TraceLog;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;

public class CopyFromBackupTask extends AbstractTask {

    private Connection conn;
    private String backup;
    private String type;
    
    public CopyFromBackupTask(Connection conn, String backup, String dstype) {
        this.conn=conn;
        this.backup=backup;
        this.type=dstype;
    }
    public void run() {
        ExportToDb bkcp = new ExportToDb(conn,backup);
        TraceLog log = new TraceLog(conn);
        try {
            log.AddMessage("Copy of Dataset from internal backup",false);
            log.AddMessage("Backup: "+backup+" type ds: "+type,false);
            
            VariablesSetting vs = new VariablesSetting(this.conn);
            vs.UpdateSeparator(bkcp.ReadSeparator());
            vs.UpdateProjectType(bkcp.ReadProcessType());
            
            if (type.equals("RESIDUAL")) {
                bkcp.tableImport(TablesName.nameDsa(),TablesName.nameResidualDsa());
                log.AddMessage("Table "+TablesName.nameResidualDsa()+" imported",false);
                bkcp.tableImport(TablesName.nameDsb(),TablesName.nameResidualDsb());
                log.AddMessage("Table "+TablesName.nameResidualDsb()+" imported",false);
            } else {
                bkcp.tableImport(TablesName.nameDsa());
                log.AddMessage("Table "+TablesName.nameDsa()+" imported",false);
                bkcp.tableImport(TablesName.nameDsb());
                log.AddMessage("Table "+TablesName.nameDsb()+" imported",false);
            }
            
            bkcp.tableImport(TablesName.nameColDsa());
            bkcp.tableImport(TablesName.nameColDsb());
            bkcp.tableImport(TablesName.nameReconciledSchema()); 
            log.AddMessage("Table "+TablesName.nameReconciledSchema()+" imported",false);
            
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Copy from Backup exception","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
            
        }
    }
}
