package it.istat.relais.gui.task;

import it.istat.relais.log.TraceLog;
import it.istat.relais.method.fs.FellegiSunterOneBlock;
import java.sql.Connection;

public class EMEstimationOneBlockTask extends AbstractTask {
 private Connection conn;
    private String blockModality;
    
    public EMEstimationOneBlockTask(Connection conn, String blockModality) {
        this.conn=conn;
        this.blockModality= blockModality;
    }
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {
              FellegiSunterOneBlock fsob = new FellegiSunterOneBlock(conn, blockModality);
              fsob.FellegiSunter();
              log.AddMessage("MU table created",false);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception applying Fellegi-Sunter model","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
