package it.istat.relais.gui.task;

import it.istat.relais.log.TraceLog;
import it.istat.relais.method.fs.FellegiSunterBlocking;
import it.istat.relais.method.fs.FellegiSunterMethod;
import java.sql.Connection;

public class EMEstimationTask extends AbstractTask {

    private Connection conn;
    private String method;
    
    public EMEstimationTask(Connection conn, String method) {
        this.conn=conn;
        this.method=method;
    }
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {
            if (method.endsWith("Blocking")) {
                FellegiSunterBlocking fsb = new FellegiSunterBlocking(conn);
                fsb.FellegiSunter();
            } else {
                FellegiSunterMethod fs = new FellegiSunterMethod(conn);
                fs.FellegiSunter();
            }
            log.AddMessage("MU table created",false);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception applying Fellegi-Sunter model","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
