package it.istat.relais.gui.task;

import it.istat.relais.constants.TablesName;
import it.istat.relais.export.ExportToFile;
import java.sql.Connection;

public class ExportToFileTask extends AbstractTask {

    private Connection conn;
    private String folder;
    private String tablename;
    
    public ExportToFileTask(Connection conn,String folder,String tablename) {
        this.conn=conn;
        this.tablename=tablename;
        this.folder=folder;
    }
    
    public void run() {
        ExportToFile exf;
        String filename = tablename + ".txt";
        String table="";
        try {
            exf = new ExportToFile(folder, conn); 
            
            if (tablename.equals("Match")) table=TablesName.nameMatch();
            else if (tablename.equals("PossibleMatch")) table=TablesName.namePossibleMatch();
            else if (tablename.equals("ResidualDSA")) table=TablesName.nameResidualDsa();
            else if (tablename.equals("ResidualDSB")) table=TablesName.nameResidualDsb();
        
            if (tablename.equals("Match") || tablename.equals("PossibleMatch")) {
                exf.expTableMPU(filename, table);
            } else if (tablename.startsWith("ResidualDS")) {
                exf.expTableDS(filename, table);
            } else {
                exf.expTable(filename, tablename);
            }
            succeed();
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            fail();
        }
    }
}
