package it.istat.relais.gui.task;

import it.istat.relais.datasetInput.ReadingFile;
import it.istat.relais.log.TraceLog;
import java.sql.Connection;

public class LoadFromFileTask extends AbstractTask {

    private Connection conn;
    private String dsaFile;
    private String dsaSep;
    private String dsbFile;
    private String dsbSep;
    
    public LoadFromFileTask(Connection conn, String dsaFile, String dsaSep,
                            String dsbFile, String dsbSep) {
        this.conn=conn;
        this.dsaFile=dsaFile;
        this.dsaSep=dsaSep;
        this.dsbFile=dsbFile;
        this.dsbSep=dsbSep;
    }
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {
            ReadingFile ri; 
            log.AddMessage("Load dataset from input files",false);
            log.AddMessage("Dataset A: "+dsaFile);
            log.AddMessage("Dataset B: "+dsbFile);
            ri = new ReadingFile(conn);
            ri.Reading(dsaFile, dsaSep, dsbFile, dsbSep);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception on load input files","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
            
        }
    }
}
