package it.istat.relais.gui.task;

import it.istat.relais.log.TraceLog;

import it.istat.relais.method.read.ReadingMarginals;
import java.sql.Connection;

public class LoadMarginalsTask extends AbstractTask {

    private Connection conn;
    private String method;
    private String file;
    private String sep;
    
    public LoadMarginalsTask(Connection conn, String method,String file,String sep) {
        this.conn=conn;
        this.method=method;
        this.file=file;
        this.sep=sep;
    }
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {
            ReadingMarginals rmarg = new ReadingMarginals(conn);
            rmarg.LoadFile(file, sep);
            rmarg.MUEval();
            log.AddMessage("Marginals table loaded",false);
            log.AddMessage("MU table created",false);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception in load marginals","E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
