package it.istat.relais.gui.task;

import it.istat.relais.gui.DateFormat;
import it.istat.relais.gui.FieldMerge;
import it.istat.relais.gui.FieldSplit;
import it.istat.relais.gui.FieldStandardization;
import it.istat.relais.gui.ReadConversionFile;
import it.istat.relais.log.TraceLog;
import it.istat.relais.preprocessing.InaccurateList;
import it.istat.relais.preprocessing.StandardizationField;
import java.sql.Connection;
import javax.swing.JDialog;

public class PreprocessingTask extends AbstractTask {

    private Connection conn;
    private String type;
    private JDialog dialog;
    
    public PreprocessingTask(Connection conn, DateFormat df) {
        this.conn=conn;
        this.dialog=df;
        this.type="Check Inaccurate";
    }
    
    public PreprocessingTask(Connection conn, FieldStandardization sf) {
        this.conn=conn;
        this.dialog=sf;
        this.type="Standardization";
    }
   
    public PreprocessingTask(Connection conn, FieldMerge fm) {
        this.conn=conn;
        this.dialog=fm;
        this.type="Merge";
    }
  
    public PreprocessingTask(Connection conn, ReadConversionFile rcf) {
        this.conn=conn;
        this.dialog=rcf;
        this.type="Inaccurate Convesion";
    }
    
    public PreprocessingTask(Connection conn, FieldSplit fsp) {
        this.conn=conn;
        this.dialog=fsp;
        this.type="Split";
    }
    
    @Override
    public void run() {
        TraceLog log = new TraceLog(conn);
        try {

            if (type.equals("Check Inaccurate")) {
                InaccurateList inList = new InaccurateList(conn);
                inList.creteFile((DateFormat)dialog);
            }
            
            if (type.equals("Standardization")) {
                StandardizationField stdField = new StandardizationField(conn);
                stdField.createNewVariable((FieldStandardization)dialog);
            }
            
            if (type.equals("Inaccurate Convesion")) {
                StandardizationField stdField = new StandardizationField(conn);
                stdField.convertVariable((ReadConversionFile)dialog);
            }
            
            if (type.equals("Merge")) {
                StandardizationField stdField = new StandardizationField(conn);
                stdField.createMergeVariable((FieldMerge)dialog);
            }
            
            if (type.equals("Split")) {
                StandardizationField stdField = new StandardizationField(conn);
                stdField.splitVariable((FieldSplit)dialog);
            }
            
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception on preprocessing function "+this.type,"E",false);
                log.AddMessage(ex.getMessage(),"E",false);
            } catch (Exception ex2) { 
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
            
        }
    }
}
