package it.istat.relais.gui.task;

import it.istat.relais.linkageOtoO.ReducedCT.ReducedContingencyTable;
import it.istat.relais.linkageOtoO.ReducedCT.ReducedContingencyTableBlocking;
import it.istat.relais.log.TraceLog;
import java.sql.Connection;

public class ReducedContingencyTableTask extends AbstractTask {

    private Connection conn;
    private String method;
    
    public ReducedContingencyTableTask(Connection conn, String method) {
        this.conn=conn;
        this.method=method;
    }
    public void run() {
        TraceLog log;
        log = new TraceLog(conn);
        try {
            log.AddMessage("Contingency table reduction. Method: "+method,false);
            if (method.endsWith("Blocking")) {
                ReducedContingencyTableBlocking rctb = new ReducedContingencyTableBlocking(conn);
                rctb.ReducedCT();
            } else {
                ReducedContingencyTable rct = new ReducedContingencyTable(conn);
                rct.ReducedCT();
            }
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception on contingency table reduction",false);
                log.AddMessage(ex.getMessage());
            } catch (Exception ex2) {
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
