package it.istat.relais.gui.task;

import it.istat.relais.linkageOtoO.*;
import it.istat.relais.log.TraceLog;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;

public class ReductionOToOTask extends AbstractTask {

    private Connection conn;
    private String type;
    private String method;
    private String model;
    
    public ReductionOToOTask(Connection conn, String type) {
        this.conn=conn;
        this.type=type;
        VariablesSetting vs = new VariablesSetting(conn);
        this.method=vs.ReadMethod();
        this.model=vs.ReadModel();
    }
    public void run() {
        TraceLog log;
        log = new TraceLog(conn);
        try {
            if (type.equals("LP")) log.AddMessage("1:1 Reduction via LP algorithm. Method: "+method,false);
            if (type.equals("ByDB")) log.AddMessage("1:1 Reduction via sorted algorithm. Method: "+method,false);
            
            if (type.equals("LP") && method.endsWith("Blocking")) {
                LinkageOtoOBlocking lob = new LinkageOtoOBlocking(conn);
                lob.ReduceOtoO();
            } else if (type.equals("LP")) {
                LinkageOtoO loo = new LinkageOtoO(conn);
                loo.ReduceOtoO();  
            } else { 
                ReductionByDB rdb = new ReductionByDB(conn);
                
                if (method.endsWith("Blocking")) rdb.ReduceOtoOBlock();
                else rdb.ReduceOtoO();
            }
            log.AddMessage("1:1 Reduction done",false);
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception on 1:1 reduction",false);
                log.AddMessage(ex.getMessage());
            } catch (Exception ex2) {
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
