package it.istat.relais.gui.task;

import it.istat.relais.log.TraceLog;
import it.istat.relais.result.ResultTable;
import java.sql.Connection;

public class ResultCreationTask extends AbstractTask {

    private Connection conn;
    private String tablename;
    private String reduction;
    private String orderKey;
    
    public ResultCreationTask(Connection conn,String tablename, String orderKey) {
        this.conn=conn;
        this.tablename=tablename;
        this.reduction=new String("none");
        this.orderKey = orderKey;
    }
    
    public ResultCreationTask(Connection conn,String tablename,String reduction, String orderKey) {
        this.conn=conn;
        this.tablename=tablename;
        this.reduction=reduction;
        this.orderKey = orderKey;
    }
    
    public void run() {
        TraceLog log;
        log = new TraceLog(conn);
        try {
            log.AddMessage("Created result table "+tablename+". Reduction: "+reduction,false);
            ResultTable rt = new ResultTable(conn);
            if (reduction.equals("1:1")) {
                if (tablename.equals("match")) {
                    rt.CreateTableMatchOtoO();
                }
                if (tablename.equals("possiblematch")) {
                    rt.CreateTablePossiblematchOtoO();
                }
                if (tablename.equals("unmatch")) {
                    rt.CreateTableUnmatchOtoO();
                }
                if (tablename.equals("residual")) {
                    rt.CreateTableUnmatchDSA();
                    rt.CreateTableUnmatchDSB();
                }
            } else { /*no reduction */
                if (tablename.equals("match")) {
                    rt.CreateTableMatch(this.orderKey);
                }
                if (tablename.equals("possiblematch")) {
                    rt.CreateTablePossiblematch(this.orderKey);
                }
                if (tablename.equals("unmatch")) {
                    rt.CreateTableUnmatch(this.orderKey);
                }
                if (tablename.equals("residual")) {
                    rt.CreateTableUnmatchDSA();
                    rt.CreateTableUnmatchDSB();
                }
            }
            succeed();
        } catch (Exception ex) {
            try {
                log.AddMessage("Exception on result creation","E",false);
                log.AddMessage(ex.getMessage(),"E");
            } catch (Exception ex2) {
                System.out.println(ex2.getMessage());
                System.out.println(ex.getMessage());
            } finally {
                fail();
            }
        }
    }
}
