package it.istat.relais.linkageOtoO.ReducedCT;

import it.istat.relais.constants.TablesName;
import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;
import java.sql.Statement;
/* This class contains the set of patterns updated after the one-to-one reduction process*/

public class ReducedContingencyTable {

	private Connection connection;
        private String model;
	
	
	public ReducedContingencyTable(Connection conn){
	 	this.connection = conn; 
                VariablesSetting vs = new VariablesSetting(conn);
                this.model = vs.ReadModel();
	}
	
        /* returns the column name for pilote variable, that is P_POST 
         in the probabilistic approach and RULE in the deterministic one*/
        private String PiloteVariable() {
            if (model.equals("Deterministic"))
                return ("RULE");
            return ("P_POST");
        }
           
        /* creates the contingency table for the pairs reduced to 1:1
           with probability of match/unmatch */
	public void ReducedCT() throws Exception {
		try{
			Statement stm1 = (Statement)connection.createStatement();
			stm1.executeUpdate("DROP TABLE "+TablesName.nameContingencyReduced());
			stm1.close();
		}catch(Exception e){
			;
		}
		try{
                        MatchingVariables mv = new MatchingVariables(connection);
                        String[] cols=mv.getContingencyColumns();
                        String substrings = "";
                        String createString = "CREATE TABLE "+TablesName.nameContingencyReduced()+" (";
                        for (int index=0;index<cols.length;index++) {
                            createString = createString+cols[index]+" CHAR(1), ";
                            substrings=substrings+"substr(PATTERN,"+(index+1)+",1), ";
                        }
                        createString=createString+" FREQ BIGINT, R DOUBLE, "+PiloteVariable()+" DOUBLE);";
			Statement stm2 =(Statement)connection.createStatement();
			stm2.executeUpdate(createString);
			stm2.close();
			Statement stm3 =(Statement)connection.createStatement();
			stm3.executeUpdate("INSERT INTO "+TablesName.nameContingencyReduced()+" SELECT "+substrings+" COUNT(*), R, "+PiloteVariable()+" FROM "+TablesName.nameOtoO()+" GROUP BY "+substrings+" R, "+PiloteVariable()+" ORDER BY "+PiloteVariable()+",R,1,2,3;");
			stm3.close();
		}catch(Exception e){
			throw e;
		}
	}
}
