package it.istat.relais.linkageOtoO.ReducedCT;

import it.istat.relais.constants.TablesName;
import it.istat.relais.matchingVariables.MatchingVariables;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
/* This class contains the set of patterns updated after the one-to-one reduction process 
 nd after a blocking step*/
public class ReducedContingencyTableBlocking {

		private Connection connection;
		private ArrayList<String> blockModality;
		private String blockingKey;
                private String model;
		
		public ReducedContingencyTableBlocking(Connection conn) throws Exception {
		 	this.connection = conn; 
                        VariablesSetting vs = new VariablesSetting(conn);
                        this.model = vs.ReadModel();
		 	try{
			Statement stm1 =(Statement)connection.createStatement();
			ResultSet rs1 = stm1.executeQuery("SELECT BLOCKVAR FROM "+TablesName.nameSetting()+";");
			rs1.next();
			this.blockingKey = rs1.getString(1);
			stm1.close();
			
			this.blockModality = new ArrayList<String>();
			Statement stm2 =(Statement)connection.createStatement();
			ResultSet rs2 = stm2.executeQuery("SELECT * FROM "+TablesName.nameBlockModality()+";");
 			while(rs2.next())
				this.blockModality.add(rs2.getString(1));
			stm2.close();
		 	}catch(Exception e){
		 		throw e;
		 	}
		}
		
               /* returns the column name for pilote variable, that is P_POST 
         in the probabilistic approach and RULE in the deterministic one*/
                private String PiloteVariable() {
                    if (model.equals("Deterministic"))
                        return ("RULE");
                    return ("P_POST");
                }
      
           /* creates the contingency table for the pairs reduced to 1:1
           with probability of match/unmatch in case of search space reduced by blocking */
		public void ReducedCT() throws Exception {
			for(int i=0; i< blockModality.size(); i++){
			try{
				Statement stm1 = (Statement)connection.createStatement();
				stm1.executeUpdate("DROP TABLE "+TablesName.nameContingencyReduced()+"_"+blockingKey.replace(",","_").toUpperCase()+"_"+blockModality.get(i).toUpperCase()+";");
				stm1.close();
			}catch(Exception e){
				;
			}
			
			try{
				Statement stm0 =(Statement)connection.createStatement();
	        	ResultSet rs0 = stm0.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_NAME = '"+TablesName.nameOtoO()+"_"+blockingKey.replace(",","_").toUpperCase()+"_"+blockModality.get(i).toUpperCase()+"' AND TABLE_SCHEMA = 'relais'");
	        	if(rs0.next()){
                                MatchingVariables mv = new MatchingVariables(connection);
                                String[] cols=mv.getContingencyColumns();
                                String substrings = "";
                                String createString = "CREATE TABLE "+TablesName.nameContingencyReduced()+"_"+blockingKey.replace(",","_").toUpperCase()+"_"+blockModality.get(i).toUpperCase()+" (";
                                for (int index=0;index<cols.length;index++) {
                                    createString = createString+cols[index]+" CHAR(1), ";
                                    substrings=substrings+"substr(PATTERN,"+(index+1)+",1), ";
                                }
                                createString=createString+" FREQ BIGINT, R DOUBLE, "+PiloteVariable()+" DOUBLE);";
                                
	        		Statement stm2 =(Statement)connection.createStatement();
	        		stm2.executeUpdate(createString);
	        		stm2.close();
                                
	        		Statement stm3 =(Statement)connection.createStatement();
	        		stm3.executeUpdate("INSERT INTO "+TablesName.nameContingencyReduced()+"_"+blockingKey.replace(",","_").toUpperCase()+"_"+blockModality.get(i).toUpperCase() +
                                 " SELECT "+substrings+" COUNT(*), R, "+PiloteVariable()+" FROM "+TablesName.nameOtoO()+"_"+blockingKey.replace(",","_").toUpperCase()+"_"+blockModality.get(i).toUpperCase()+" GROUP BY "+substrings+" R, "+PiloteVariable()+" ORDER BY "+PiloteVariable()+",R,1,2,3;");
	        		stm3.close();
	        	}
			}catch(Exception e){
				throw e;
			}
		}
	}
}

