package it.istat.relais.output;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class RowWriter {
	
	private PrintWriter out;
	
      
	public RowWriter(String pathname, boolean append) throws IOException {
		try {
			
			out = new PrintWriter(new BufferedWriter(new FileWriter(pathname, append)));
			
		} catch (IOException e) {
			
			System.err.println("Could not open" + pathname);
			throw e;
			
		}
	}
	
  
	public RowWriter(String pathname, boolean append, int buffer_sz) throws IOException {
		try {
			
			out = new PrintWriter(
					new BufferedWriter(new FileWriter(pathname, append), buffer_sz));
			
		} catch (IOException e) {
			
			System.err.println("Could not open" + pathname);
			throw e;
			
		}
	}

	public void write(String row) {
		out.println(row);
	}
	
     
	public void writeNotLN(String row) {
		out.print(row);
	}

     
        public void close() {
		out.close();
	}
	
      
	public void flush(){
		out.flush();
	}
}

