package it.istat.relais.preprocessing;

import it.istat.relais.gui.DateFormat;
import java.io.File;
import java.io.FileWriter;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;

public class InaccurateList {
private final int DIMMAX = 20000;
File fileOut;
FileWriter streem;
Connection conn;
String pathFile;
String separator;

/*Constructor*/
public InaccurateList(Connection conn) {
	this.conn=conn;
}

/*Returns the file name of the output file*/
public File getFile() {
	return fileOut;
}

/*Create a file with inaccurate value of variable*/
public void creteFile(DateFormat df) throws Exception {
	
        String modality;
        String fileName=df.getOutFile();
	this.fileOut = new File(fileName);
	this.streem = new FileWriter(fileOut, false);
	
	String queryData = "SELECT DISTINCT "+df.getField()+" FROM "+df.getTable();
    
	Statement stValues = (Statement) conn.createStatement();
	ResultSet rsValues = stValues.executeQuery(queryData);
	
        
	while (rsValues.next()) {
            modality = rsValues.getString(1);
            if ((df.getCheckFieldLength() && (modality.length()!=df.getLength())) ||
                (df.getCheckDataFormat() && !CheckFormat(modality,df.getFormat()) )) {
                streem.write(modality+System.getProperty("line.separator"));	
            }
	}
	rsValues.close();
	stValues.close();
	streem.flush();
        streem.close();
        System.out.println("File "+fileOut.getName()+" created.");
}

public boolean CheckFormat(String str,String format) {
    if (format.equals("dd/mm/yyyy")) {
        if (str.length()!=10 || str.charAt(2)!='/' || str.charAt(5)!='/') return false;
    }
    if (format.equals("mm/dd/yyyy")) {
        if (str.length()!=10 || str.charAt(2)!='/' || str.charAt(5)!='/') return false;
    }
    if (format.equals("yyyy-mm-dd")) {
        if (str.length()!=10 || str.charAt(4)!='-' || str.charAt(7)!='-') return false;
    }
    if (format.equals("yyyymmdd")) {
        if (str.length()!=8) return false;
    }
    if (format.equals("dd/mm/yy")) {
        if (str.length()!=8 || str.charAt(2)!='/' || str.charAt(5)!='/') return false;
    }
    return true;
}
public void close() throws Exception {
	this.streem.close();
}


}