package it.istat.relais.qualityMetaData;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class BlockingAdeguacy {
private Connection conn;
private String DS;
private String varName;
private int blockDim;

public BlockingAdeguacy(Connection conn, String DS, String varName, int blockDim){
    this.conn =conn;
    this.DS = DS;
    this.varName =varName;
    this.blockDim = blockDim;
}

/* returns evaluation of blocking adeguacy for the variable using the frequency table */
public double EvaluateBlockingAdeguacy(){
    double blockingAdeguacy = -1;
    int numMod;
   
    Categories c = new Categories(conn, DS, varName);
    numMod = c.EvaluateCategories();
    try{
        Statement stm =(Statement)conn.createStatement();
        String query = "SELECT COUNT(*) FROM "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+TablesName.nameDsa()+" A, relais."+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+TablesName.nameDsb()+" B";
        query = query +" WHERE A.MODALITY = B.MODALITY AND (A.FREQUENCY * B.FREQUENCY)>= "+blockDim+";";    
        ResultSet rs =stm.executeQuery(query);
        rs.next();
        blockingAdeguacy = 1-((double)rs.getInt(1)/(double)numMod);
        rs.close();
        stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
    return blockingAdeguacy;
}
}
