package it.istat.relais.qualityMetaData;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class CramerIndex {
private Connection conn;
private String DS;
private String varName1;
private String varName2;
private int dimDS;

public CramerIndex(Connection conn, String DS, int dimDS, String varName1, String varName2){
    this.conn = conn;
    this.DS = DS;
    this.dimDS = dimDS;
    this.varName1 = varName1;
     this.varName2 = varName2;
}
    	
/* returns the evaluation of correlation (Cramer Index) using table of frequency */
public double EvaluateCramerIndex(){
    double indexCramer = -1;
    double index = 0;
    Categories cat1 = new Categories(this.conn, this.DS, this.varName1);
    int numCategoriesVarName1 = cat1.EvaluateCategories();
    Categories cat2 = new Categories(this.conn, this.DS, this.varName2);
    int numCategoriesVarName2 = cat2.EvaluateCategories();
    if((numCategoriesVarName1==1)||(numCategoriesVarName2 == 1)){
        return indexCramer;
    }

    FrequencyDistributions fd2 = new FrequencyDistributions(this.conn, this.DS, this.varName2);
    fd2.EvaluateFrequencyDistributions();
     int ni, nj, nij;
    String mod1, mod2;
    
    try{
      Statement stm1 = (Statement)conn.createStatement();
      String query1 = "SELECT MODALITY, FREQUENCY FROM "+TablesName.nameFrequencyDistributions()+"_"+this.varName1+"_"+this.DS+";";
      ResultSet rs1 = stm1.executeQuery(query1);
      while(rs1.next()){
        mod1 = rs1.getString(1).replace("'", "''");
        ni = rs1.getInt(2);
        
        Statement stm2 = (Statement)conn.createStatement();
        String query2 = "SELECT MODALITY, FREQUENCY FROM "+TablesName.nameFrequencyDistributions()+"_"+this.varName2+"_"+this.DS+";";
        ResultSet rs2 = stm2.executeQuery(query2);
        while(rs2.next()){
            mod2 = rs2.getString(1).replace("'", "''");
            nj = rs2.getInt(2);
        
            Statement stm3 = (Statement)conn.createStatement();
            String query3 = "SELECT COUNT(*) FROM "+this.DS+" a";
            query3 = query3 + " WHERE a."+this.varName1 +"= '"+mod1+"' AND a."+this.varName2+" ='"+mod2+"';";             
            
            ResultSet rs3 = stm3.executeQuery(query3);
            rs3.next();
            nij = rs3.getInt(1);
            
            index = index + (Math.pow(nij, 2)/(ni*nj));
            
            rs3.close();
            stm3.close();
        }
        rs2.close();
        stm2.close();
      }
      rs1.close();
      stm1.close();
      indexCramer = Math.sqrt((index-1)/Math.min(numCategoriesVarName1-1, numCategoriesVarName2-1));
    }catch(Exception e){
        e.printStackTrace();
    }
    return (1-indexCramer);
}
}
