package it.istat.relais.qualityMetaData;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class Entropy {
    private Connection conn;
    private String DS;
    private String varName;
    
    public Entropy(Connection conn, String DS, String varName){
        this.conn = conn;
        this.DS = DS;
        this.varName = varName;
    }
    
    /* returns evaluation of entropy using table of frequency */
    public double EvaluateEntropy(){
	boolean notExists;
        int dimX;
        double fi;
        int numMod;
        double entropy = -1;
        FrequencyDistributions fd = new FrequencyDistributions(conn, DS, varName);
        try{
        Statement stm = (Statement)conn.createStatement();
        ResultSet rs = stm.executeQuery("SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA = 'relais' AND upper(TABLE_NAME) = '"+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+"';");
        if(!rs.next()){
            notExists = true;      
            fd.EvaluateFrequencyDistributions();
        }
        else
            notExists = false;
        rs.close();
        stm.close();
        Statement stm1 = (Statement)conn.createStatement();
        String query1 = "SELECT SUM(FREQUENCY) FROM "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+";";
        ResultSet rs1 = stm1.executeQuery(query1);
        rs1.next();
        dimX =rs1.getInt(1);
        rs1.close();
        stm1.close();
        
        Statement stm2 = (Statement)conn.createStatement();
        ResultSet rs2 = stm2.executeQuery("SELECT COUNT(DISTINCT(MODALITY)) FROM "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+";");
        rs2.next();
        numMod = rs2.getInt(1);
        rs2.close();
        stm2.close();
        
        if (numMod>1) {
            entropy = 0.0;
            Statement stm3 = (Statement)conn.createStatement();
            ResultSet rs3 =stm3.executeQuery("SELECT FREQUENCY FROM "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+";");
            while(rs3.next()){
                fi = ((double)(rs3.getInt(1))/(double)dimX);
                entropy = entropy + fi*((double)Math.log(fi)/(double)Math.log(numMod));
            }
            rs3.close();
            stm3.close();
        }
        else
            entropy = -1;
           
        if(notExists)
            fd.DropFrequencyTable();
        }catch(Exception e){
            e.printStackTrace();
        }
	return -entropy;		
	}
	

}
