package it.istat.relais.qualityMetaData;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.Statement;

public class FrequencyDistributions {
private Connection conn;
private String DS;
private String DStable;
private String varName;
private String menuOut;

public FrequencyDistributions(Connection conn, String DS, String varName){
    this.conn=conn;
    this.DStable = DS;
    this.DS = DS;
    this.varName = varName;
    this.menuOut = null;
}

public void setDisplayMenu(String menu) {
    menuOut = menu;
}

/* loads the frequencies of each modality of a varaible in the frequency table */
public void EvaluateFrequencyDistributions(){
    CreateFrequencyTable();
    try{
     Statement stm1 =(Statement)conn.createStatement();
     stm1.executeUpdate("INSERT INTO "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+" SELECT "+varName+", COUNT(*) FROM relais."+DStable+" GROUP BY "+varName+" ORDER BY 2;");
     stm1.close();
     
     if (menuOut!=null) System.out.println("Table "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+" created (View is enabled on menu '"+menuOut+"')");
     }catch(Exception e){
        e.printStackTrace();
    }
}

/* creates the frequency table  */
public void CreateFrequencyTable(){
    DropFrequencyTable();
    try{
        Statement stm =(Statement)conn.createStatement();
        stm.executeUpdate("CREATE TABLE "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+" (MODALITY VARCHAR(500), FREQUENCY BIGINT);");
        stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* drops the frequency table */
public void DropFrequencyTable(){
    try{
        Statement stm =(Statement)conn.createStatement();
        stm.executeUpdate("DROP TABLE "+TablesName.nameFrequencyDistributions()+"_"+varName+"_"+DS+";");
        stm.close();
    }catch(Exception e){
        ;
    }
}
}
