package it.istat.relais.qualityMetaData;

import it.istat.relais.constants.TablesName;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class MetaData {
private int dimDSA;
private int dimDSB;
private Connection conn;

public MetaData(Connection conn){
    this.conn = conn;
    try{
    Statement stm = (Statement)conn.createStatement();
    ResultSet rs = stm.executeQuery("SELECT COUNT(*) FROM "+TablesName.nameDsa());
    rs.next();
    this.dimDSA = rs.getInt(1);
    rs.close();
    stm.close();
    Statement stm1 = (Statement)conn.createStatement();
    ResultSet rs1 = stm1.executeQuery("SELECT COUNT(*) FROM "+TablesName.nameDsb());
    rs1.next();
    this.dimDSB = rs1.getInt(1);
    rs1.close();
    stm1.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* returns the dimension of dataset a */
public int getDimDSA(){
    return this.dimDSA;
}

/* returns the dimension of dataset b */
public int getDimDSB(){
    return this.dimDSB;
}

/* creates table to save result of quality indicators (blocking)*/
public void CreateBlockingMetaDataTable(){
    DropBlockingMetaDataTable();
    try{
    Statement stm = (Statement)conn.createStatement();
    stm.executeUpdate("CREATE TABLE "+TablesName.nameBlockingMetaData()+" (VARNAME VARCHAR(500), METADATA VARCHAR(100), DATASET VARCHAR(3), VALUE DOUBLE);");
    stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* drops table to save result of quality indicators */
public void DropBlockingMetaDataTable(){
    try{
    Statement stm = (Statement)conn.createStatement();
    stm.executeUpdate("DROP TABLE "+TablesName.nameBlockingMetaData()+";");
    stm.close();
    }catch(Exception e){
    }
}

/* inserts a record in the table of quality indicators */
public void InsertRowBlockingMetaDataTable(String DS,String metaDataName, String varName){
    try{
     Statement stm = (Statement)conn.createStatement();
     stm.executeUpdate("INSERT INTO "+TablesName.nameBlockingMetaData()+" VALUES('"+varName+"', '"+metaDataName+"', '"+DS+"', null);");
     stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* modifies a record in the table of quality indicators */
public void UpdateRowBlockingMetaDataTable(String DS, String metaDataName, double value, String varName){
    try{
       Statement stm = (Statement)conn.createStatement();
       stm.executeUpdate("UPDATE "+TablesName.nameBlockingMetaData()+" SET VALUE = "+value+" WHERE DATASET = '"+DS+"' AND METADATA = '"+metaDataName+"' AND VARNAME = '"+varName+"';");
       stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* creates a table to save result of quality indicators (matching)*/
public void CreateMatchingMetaDataTable(){
    DropTableMatchingMetaDataTable();
    try{
    Statement stm = (Statement)conn.createStatement();
    stm.executeUpdate("CREATE TABLE "+TablesName.nameMatchingMetaData()+" ( VARNAME VARCHAR(500), METADATA VARCHAR(100), DATASET VARCHAR(3), VALUE DOUBLE);");
    stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* drops table to save result of quality indicators (matching)*/
public void DropTableMatchingMetaDataTable(){
    try{
    Statement stm = (Statement)conn.createStatement();
    stm.executeUpdate("DROP TABLE "+TablesName.nameMatchingMetaData()+";");
    stm.close();
    }catch(Exception e){
       ;
    }
}

/* inserts record in the table of quality indicators (matching)*/
public void InsertRowMatchingMetaDataTable(String DS, String metaDataName, String varName){
    try{
     Statement stm = (Statement)conn.createStatement();
     stm.executeUpdate("INSERT INTO "+TablesName.nameMatchingMetaData()+" VALUES('"+varName+"', '"+metaDataName+"', '"+DS+"', null);");
     stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

/* modifies a record in the table of quality indicators (matching)*/
public void UpdateRowMatchingMetaDataTable(String DS, String metaDataName, double value, String varName){
    try{
       Statement stm = (Statement)conn.createStatement();
       stm.executeUpdate("UPDATE "+TablesName.nameMatchingMetaData()+" SET VALUE = "+value+" WHERE DATASET = '"+DS+"' AND METADATA = '"+metaDataName+"' AND VARNAME = '"+varName+"';");
       stm.close();
    }catch(Exception e){
        e.printStackTrace();
    }
}

}
