package it.istat.relais.searchSpaceCreation;

import it.istat.relais.constants.TablesName;
import it.istat.relais.datasetInput.Record;
import it.istat.relais.datasetInput.RecordReader;
import it.istat.relais.project.VariablesSetting;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;


public class ReadingSearchSpace {
Connection connection;
private String method;
int numVar;
	
	public ReadingSearchSpace(Connection con){
		this.connection = con;
		this.method = "Reading External File";
                this.numVar=2;
	}

        /* creation of the search space table by cross product */
	public String LoadInput(String inputFile, String sep) throws Exception {
		Statement stmDrop, stmCreate, stmInsert = null;
		String insertSS, createSS;
		String tableName = TablesName.nameSearchSpaceTemp();
                RecordReader readerSS;
		Record schemaSS;
		
		try{
                    stmDrop = (Statement)connection.createStatement();
                    stmDrop.executeUpdate("DROP TABLE IF EXISTS " +tableName+ ";");
                    
                    readerSS = new RecordReader(inputFile, sep);
	            schemaSS = new Record(readerSS.read(), sep);
		    numVar = schemaSS.size();

                    insertSS=" KEY_DSA, KEY_DSB \n";
		    createSS = "CREATE TABLE "+tableName+" (ROWNUMBER BIGINT UNSIGNED NOT NULL AUTO_INCREMENT, KEY_DSA INTEGER UNSIGNED NOT NULL, KEY_DSB INTEGER UNSIGNED NOT NULL,\n";
                    for(int i=2; i < numVar; i++){
                        if (schemaSS.get(i).toString().equals("")) throw new Exception("Column name missing #"+(i+1));
				
                        createSS = createSS+ schemaSS.get(i).toString().toUpperCase()+" VARCHAR(50), \n";
			insertSS = insertSS + ", "+ schemaSS.get(i).toString()+" \n";
                    }
                    createSS = createSS+" PRIMARY KEY (ROWNUMBER)) ENGINE = MYISAM;";

                    stmCreate = (Statement)connection.createStatement();
                    stmCreate.executeUpdate(createSS);
                    stmCreate.close();
                    
                    String name = "os.name";
                    String os = System.getProperty(name).toLowerCase();
                    if (os.indexOf("win") >= 0){
        		String pathLoad = inputFile.replace("\\", "\\\\");
			
			String loadSS = "LOAD DATA INFILE \'"+pathLoad+ "\' INTO TABLE "+tableName+
                                        " FIELDS TERMINATED BY \""+sep+"\" LINES TERMINATED BY '\r\n' IGNORE 1 LINES ("+
                                        insertSS +");";
            
                        stmInsert = (Statement)connection.createStatement();
                        stmInsert.executeUpdate(loadSS);
			stmInsert.close();
                    }
                    else {
                        String insertDSAtemp;
                        String rs;
                        Record row;
                        Statement stmI;
                        
                        while((rs=readerSS.read())!= null){
                            row = new Record(rs,sep);
                            insertDSAtemp = "INSERT INTO "+tableName+" ("+insertSS+") VALUES (";
                            for(int i=0; i < numVar-1; i++)
                                insertDSAtemp = insertDSAtemp+"'"+ row.get(i).toString().replaceAll("'", "''")+"', ";
                            insertDSAtemp = insertDSAtemp + "'"+ row.get(numVar-1).toString().replaceAll("'", "''")+ "');";
                            stmI = (Statement)connection.createStatement();
                            stmI.executeUpdate(insertDSAtemp);
                            stmI.close();
                        }
                    }
                        
		}catch (Exception e) {
			e.printStackTrace();		
                        throw e;
	}
	return this.method;
 }
}	
