package it.istat.relais.searchSpaceCreation;

import it.istat.relais.constants.TablesName;
import java.io.*;
import java.security.*;
import java.util.*;
import java.math.*;
import it.istat.relais.log.TraceLog;
import it.istat.relais.project.ReconciledSchema;
import it.istat.relais.project.VariablesSetting;
import it.istat.relais.searchSpaceCreation.ReadingSearchSpace;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class Simhash {

 Connection connection;
 private String method;
 private ReconciledSchema rsc;
 int soglia=45;
 int soglia2=35;
 int sogliagiro;
 int gradino=64;
 int hashdim=128;
 TraceLog log;
 int grDim=2;
 boolean weights=false;
 HashMap wgrams;
 HashMap wgramsi;
 
 public Simhash(Connection conn,int thresh,int rounds,int grDim,boolean weigths){
	this.connection=conn;
	this.method = "SimHash";
        rsc = new ReconciledSchema(conn);
        this.gradino=(int) (hashdim/rounds);
        this.soglia=thresh;
        this.soglia2=(int) (thresh*0.75);
        log = new TraceLog(connection);
        this.grDim=grDim;
        this.weights=weigths;
        wgrams = new HashMap();
        wgramsi = new HashMap();
 }

 public static String invert(String s) {
        String temp = "";
        for (int i = s.length() - 1; i >= 0; i--)
            temp += s.charAt(i);
        return temp;
    }
 
 public class FileRec {
 int num;
 String value;
 
    public FileRec(int num,String value) throws Exception {
       this.num=num;
       this.value=value;
	}
 }
 
 public class HashRec {
    int num;
    int ds;
    String hashcode;
    String hashinvert;
    String value;
    String invert;
	
    public HashRec(int ds,int num,String value,int hashdim,int totRec,boolean wgh) throws Exception {
       this.ds=ds;
       this.num=num;
       this.value=value;
       this.invert=invert(value);
       Hash h=new Hash(grDim,wgrams,wgh,totRec);
       Hash hi=new Hash(grDim,wgramsi,wgh,totRec);

       this.hashcode=h.decodemd5(value);
       this.hashinvert=hi.decodemd5(invert);
        
       /*TESTRELAIS if ((ds==0 && num==122) || (ds==1 && num==1112)) System.out.println(value+":"+hashcode);*/
    }

	
    public void progres (int nbit,int inv) {
       if (inv==0) hashcode = hashcode.substring(nbit)+hashcode.substring(0,nbit);
	   else        hashinvert = hashinvert.substring(nbit)+hashinvert.substring(0,nbit);
    }
	
    
    public String print() {
       return (hashcode+" : "+value+" ("+ds+":"+num+")");
    }
 }

 public String CreateSSRBlock(String hashKey, String blockKey) throws Exception {
   
     String blockKeyDsa,blockKeyDsb,currbl;
     ArrayList<String> list;
   
     blockKeyDsa = rsc.getAttribute(blockKey, "A");
     blockKeyDsb = rsc.getAttribute(blockKey, "B");
     
     
     indexCreate(TablesName.nameDsa(),blockKeyDsa,"IXBLSHDSA");
     indexCreate(TablesName.nameDsb(),blockKeyDsb,"IXBLSHDSB");
     
     list=blockList(TablesName.nameDsa(),blockKeyDsa);
     int indice = 0;
     
     log.AddMessage("----creo tabella ssr ---",false);
     CreaTabSSR();
   
     for (String curr : list) {
         indice ++;
         log.AddMessage("Block "+indice+" of "+list.size()+" ("+curr+")");
         CreateSSR(hashKey,curr,blockKeyDsa,blockKeyDsb,true);
     }
     
     return("Blocked SimHash");
     
 }
 
 public String CreateSSR(String hashKey) throws Exception {
     
     log.AddMessage("----creo tabella ssr ---",false);
     CreaTabSSR();
     CreateSSR(hashKey,"noblock","novarA","novarB",false);
     return("SimHash");
     
 }
 
 public void CreateSSR(String hashKey,String blockVal,String blockVarA,String blockVarB,boolean block) throws Exception {
   
   // param(4): 0)inputfile1 1)inputfile2 2)outputfile 3)soglia 4)gradino 
   ArrayList<FileRec> strnumA,strnumB;
   ArrayList<HashRec> set;
   HashMap ssr;
   int dist;
   char dedup='N';
   VariablesSetting vs = new VariablesSetting(connection);
   String concatVarDsa,concatVarDsb;
   wgrams = new HashMap();
   wgramsi = new HashMap();
   
   set = new ArrayList<HashRec>();
   ssr = new HashMap();
   
   log.AddMessage(" HD threshold: "+soglia,false);
   log.AddMessage(" step-rotation: "+gradino,false);
   log.AddMessage(" bit hash: "+hashdim,false);
   if (soglia2!=soglia) log.AddMessage(" HD threshold2: "+soglia2,false);
   
   StringTokenizer tok = new StringTokenizer(hashKey,",");
   String comVar=tok.nextToken();
   
   concatVarDsa = rsc.getAttribute(comVar, "A");
   concatVarDsb = rsc.getAttribute(comVar, "B");
   while (tok.hasMoreTokens()) {
        comVar=tok.nextToken();
        concatVarDsa = concatVarDsa+","+rsc.getAttribute(comVar, "A");
        concatVarDsb = concatVarDsb+","+rsc.getAttribute(comVar, "B");
   }
    
    log.AddMessage("----hash decode----",false);
    if (vs.ReadProjectType().equalsIgnoreCase("Deduplication")) 
        dedup='S';
    
    int totRec=0;
    strnumA = leggi("A",concatVarDsa,block,blockVarA,blockVal);
    totRec += strnumA.size();
    strnumB = null;
    if (dedup!='S') {
        strnumB = leggi("B",concatVarDsb,block,blockVarB,blockVal);
        totRec += strnumB.size();
    }

    if (weights) {
      for (FileRec frec : strnumA) {
	 addGrams(frec.value,wgrams);
	 addGrams(invert(frec.value),wgramsi);
      }
      if (dedup!='S')
         for (FileRec frec : strnumB){
	   addGrams(frec.value,wgrams);
	   addGrams(invert(frec.value),wgramsi);
        }
      log.AddMessage(" grams weighted ",!block);
    }
    
      for (FileRec frec : strnumA)
         set.add(new HashRec(0,frec.num,frec.value,hashdim,totRec,weights));
	 
      if (dedup!='S'){
         
         for (FileRec frec : strnumB)
            set.add(new HashRec(1,frec.num,frec.value,hashdim,totRec,weights));
      }
   
   
   //for (HashRec h: set)
   //    System.out.println(h.print());
   log.AddMessage(" hash decoding terminated",!block);
   log.AddMessage("----hash comparing steps----",false);
   HashRec h1;
   HashRec h2;
   int confronti=0;
   int outsoglia=hashdim;
   String tipogiro="";
   
    for (int giri=0; giri<=(hashdim/gradino); giri++) 
    for (int inv=0; inv<2; inv++) {

    sogliagiro=soglia;
    if (giri==(hashdim/gradino)) {
	     if (inv==0) {
	        Collections.sort(set, new SortValue());
			tipogiro="SNM  ";
			sogliagiro=soglia2;
	     }
	     else {
	        Collections.sort(set, new SortInvert());
			tipogiro="SNM/r";
			sogliagiro=soglia2;
		 }
	  }
	  else {
	     if (inv==0) {
            Collections.sort(set, new SortHash());
			tipogiro="SH"+giri+"  ";
	     }
		 else {
		    Collections.sort(set, new SortHashInvert());
			tipogiro="SH"+giri+"/r";
		 }
	  }
	  log.AddMessage(" hash sorting terminated",false);
      for (int ix=0; ix<(set.size()-1); ix++) {

	     outsoglia=hashdim;
         for (int ix2=ix+1; ix2<set.size(); ix2++) {
             h1=set.get(ix);
             h2=set.get(ix2);
			 if (h1.ds!=h2.ds || dedup=='S') {
			    confronti++;
				if (inv==0)
				   dist=hashdist(h1.hashcode,h2.hashcode);
				else
			           dist=hashdist(h1.hashinvert,h2.hashinvert);
                                /*TESTRELAISSystem.out.println(" confronto "+h1.ds+";"+h1.num+" - "+h2.ds+";"+h2.num+" = "+dist);*/
				/*TESTRELAIS if (tipogiro.equals("SH2  ") && h1.hashcode.startsWith("0101110")) System.out.println(" confronto "+h1.ds+";"+(h1.num+1)+" - "+h2.ds+";"+(h2.num+1)+" = "+dist);*/
                                
				if (dist<sogliagiro) {
                                   /*TESTRELAISSystem.out.println("  INSERT ");*/
				   outsoglia=hashdim;
                                   if (((h1.ds==0 && h2.ds==1) || (dedup=='S' && (h1.num<h2.num))) &&
				       (ssr.get(h1.ds+";"+h1.num+";"+h2.ds+";"+h2.num)==null)) {
                                        ssr.put(h1.ds+";"+h1.num+";"+h2.ds+";"+h2.num, h1.num+","+h2.num);
                                        //if (ssr.size()%10000==0) System.out.println("Pairs: "+ssr.size());
                                   }
                                   else if (((h2.ds==0 && h1.ds==1) || (dedup=='S' && (h1.num>h2.num))) &&
    				       (ssr.get(h2.ds+";"+h2.num+";"+h1.ds+";"+h1.num)==null)) {
                                        ssr.put(h2.ds+";"+h2.num+";"+h1.ds+";"+h1.num, h2.num+","+h1.num);
                                        //if (ssr.size()%10000==0) System.out.println("Pairs: "+ssr.size());
                                   }
				}
                else if (tipogiro.equals("SNM  ")) {
				   if (dist>outsoglia) {
				      outsoglia=hashdim;
				      break;
				   }
				   else outsoglia=dist;
                }
                else {
				   break;
				}
             }
         }
      }
	  
      /*TESTRELAISSystem.out.println("fine "+tipogiro);*/
      log.AddMessage("round: "+tipogiro+" ssr-size: "+ssr.size(),false);
      for (HashRec h: set)
          h.progres(gradino,inv);
    }
   

   Collection pairs = ssr.values();
   
   scrivi(pairs);
   //Collections.sort(pairs);

   log.AddMessage("-- total pair hash-compared : "+confronti+" --",false);
   //System.out.println(" endtime:   "+System.currentTimeMillis()/1000 );

 }

 public void addGrams(String strtograms, HashMap map) {
     int numb;
     HashMap gramString = new HashMap();
     
     String[] appo = Hash.getGrams(strtograms,grDim);
     
     for (int idx=0;idx<appo.length;idx++) {
         if (!gramString.containsKey(appo[idx])) {
	        gramString.put(appo[idx],appo[idx]);
	   }
     }
     
     Collection grs = gramString.values();
     for (Object ngr: grs) {
            numb=1;
	    if (map.containsKey(ngr)) {
	        numb = Integer.parseInt(map.get(ngr).toString());
	        numb++; 
	   }
           map.put(ngr, (numb));
       }
 }
 
 public static int hashdist(String hash1, String hash2) throws Exception {
    int dist=0;
    for (int ix=0;ix<hash1.length();ix++)
      if (hash1.charAt(ix)!=hash2.charAt(ix)) dist++;
      
    return dist;
 }
 
 
 
 public ArrayList<FileRec> leggi(String ds,String concatVar,boolean block,String blColumn,String blockValue) throws Exception {

     int indice;
     ArrayList<FileRec> result;
     
     String nomeTab, nomeKey;
     
     nomeTab=TablesName.nameDsa();
     nomeKey="KEY_DSA";
     
     if (ds.equals("B")) {
         nomeTab=TablesName.nameDsb();
         nomeKey="KEY_DSB";
     } 
     
     String selectString = "SELECT "+nomeKey+", concat("+concatVar+") FROM "+nomeTab;
     if (block) {
         selectString=selectString+" WHERE "+blColumn+" = '"+blockValue+"'";
     }
     Statement stm=connection.createStatement();
     ResultSet rsSelect = stm.executeQuery(selectString);
     
     result=new ArrayList<FileRec>();
     indice=0; 			
     while (rsSelect.next()) {
	    indice++;
            result.add(new FileRec(rsSelect.getInt(1),rsSelect.getString(2)));
     }
     
     log.AddMessage(" record decoded for ds"+ds+": "+indice,false);
     
     return result;
 }
 
  public void scrivi(Collection pairs) throws Exception {

     //int conta=0;     
     String parteFissa, insertString;
     
     parteFissa="INSERT INTO "+TablesName.nameSearchSpaceTemp()+" (KEY_DSA,KEY_DSB) ";
     
     log.AddMessage("write in table ssr",false);
     
     Statement stmInsert=(Statement)connection.createStatement();
     for (Object pair: pairs) {
         insertString =parteFissa+" VALUES ("+(String) pair+")";
	 stmInsert.executeUpdate(insertString);
            //conta++;
     }
     stmInsert.close();
     
 }
  
 public static class SortHash implements java.util.Comparator {

        @Override
    public int compare(Object boy, Object girl) {
       String has1=((HashRec)boy).hashcode;
       String has2=((HashRec)girl).hashcode;
       
       return has1.compareTo(has2);
       
    }
 } 
 
 public static class SortHashInvert implements java.util.Comparator {

        @Override
    public int compare(Object boy, Object girl) {
       String has1=((HashRec)boy).hashinvert;
       String has2=((HashRec)girl).hashinvert;

       return (has1.compareTo(has2));
       
    }
 }
 
 public static class SortValue implements java.util.Comparator {

        @Override
    public int compare(Object boy, Object girl) {
       String has1=((HashRec)boy).value;
       String has2=((HashRec)girl).value;
       
       return (has1.compareTo(has2));
  
    }
 }
 
 public static class SortInvert implements java.util.Comparator {

        @Override
    public int compare(Object boy, Object girl) {
       String has1=((HashRec)boy).invert;
       String has2=((HashRec)girl).invert;
       
       return (has1.compareTo(has2));

    }
 } 
 
 public void CreaTabSSR() throws Exception {
     Statement stmDrop;
     Statement stmCreate;
     	stmDrop =(Statement)connection.createStatement();
		stmDrop.executeUpdate("DROP table IF EXISTS "+TablesName.nameSearchSpaceTemp()+";");
		stmDrop.close();

		stmCreate=(Statement)connection.createStatement();
		String createString ="CREATE TABLE "+TablesName.nameSearchSpaceTemp()+
                       " (KEY_DSA INTEGER UNSIGNED, KEY_DSB INTEGER UNSIGNED, ROWNUMBER BIGINT UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ROWNUMBER)) ENGINE = MYISAM;";
		stmCreate.executeUpdate(createString);
        stmCreate.close();
        
 }
 
  public ArrayList<String> blockList(String tableName,String blVar) throws Exception {

     int indice;
     ArrayList<String> result;
     
     String selectString = "SELECT DISTINCT "+blVar+" FROM "+tableName;
     Statement stm=connection.createStatement();
     ResultSet rsSelect = stm.executeQuery(selectString);
     
     result=new ArrayList<String>();
     indice=0; 			
     while (rsSelect.next()) {
	    indice++;
            result.add(rsSelect.getString(1));
     }
     
     log.AddMessage(" -- blocks :"+indice,false);
     
     return result;
 }
 
 public void indexCreate(String tableName,String column,String indexName) throws Exception {
     Statement stmDrop;
     Statement stmCreate;
     
        try {
                stmDrop =(Statement)connection.createStatement();
		stmDrop.executeUpdate("ALTER table "+tableName+" DROP INDEX "+indexName+";");
		stmDrop.close();
        }  catch (Exception ex) {
            log.AddMessage(ex.getMessage(),false);
        }

		stmCreate=(Statement)connection.createStatement();
		String createString ="CREATE INDEX "+indexName+" ON "+tableName+
                       " ("+column+");";
		stmCreate.executeUpdate(createString);
        stmCreate.close();
        
 }
  
}